1.14.4:

2010-07-22  Murray Cumming  <murrayc@murrayc.com>

	Added --restore command-line option.

	* glom/application.[h|cc]: Added init() with a bool restore option,
  calling do_backup_restore() if appropriate.
	* glom/main.cc: Added a --restore command and pass the bool result to
  Application::init().

  This allows the user to restore from a backup without first loading an
  existing file, though this is so far only possible via the terminal.

2010-07-22  Murray Cumming  <murrayc@murrayc.com>

  Added Developer/Restore Backup menu item.

	* glom/application.[h.cc]: Added a Developer/Restore Backup menu item,
  which lets the user choose a .tar.gz, untars it in /tmp/ and opens it.

	* tests/test_selfhosting_new_empty.cc:
	* glom/libglom/utils.[h|cc]: Move delete_directory() to Utils.
  Added get_directory_child_with_suffix(), used to find the .glom file inside
  an untarred directory.

2010-07-22  Murray Cumming  <murrayc@murrayc.com>

	Saving from a backup: Now works.

	* glom/application.[h|cc]: on_document_load(): Simplify the code to
  create from a backup, modifying the from-example code to handle it too,
  calling a new recreate_database_from_backup() method.
  That now creates the database and then adds the groups before trying
  to restore from the backup file.
	* glom/libglom/connectionpool_backends/backend.h: convert_backup():
	* glom/libglom/connectionpool_backends/postgres.[h|cc]: convert_backup():
	* glom/libglom/connectionpool_backends/sqlite.[h|cc]: convert_backup():
  Add a database_name_parameter. This now expects the database to exist
  already, though it should be empty. It should also already have the
  expected groups.
	* glom/libglom/connectionpool.[h|cc]: convert_backup(): Supply the
  database name. Also update the meta data so we know about the new tables.

2010-07-21  Murray Cumming  <murrayc@murrayc.com>

	Small Business example: Add table privileges.

	* examples/example_smallbusiness.glom: Give some privileges to the
    accounts and personnel groups and resave-as-an-example. These were
    probably lost some time.

2010-07-21  Murray Cumming  <murrayc@murrayc.com>>

	Saving as example: Fix this.

	* glom/libglom/document/document.cc: set_modified(): Actually use
    m_allow_auto_save so we don't just save every time, overwriting
    previous saves. For instance, the examples were saved with is_example=false
    after the document was changed back.

2010-07-21  Murray Cumming  <murrayc@murrayc.com>>

	Saving from examples: Set the table privileges mentioned in the document.

	* glom/base_db.[h|cc]: Added set_table_privileges_groups_from_document().
	* glom/application.cc: recreate_database_from_example(): call it.

2010-07-21  Murray Cumming  <murrayc@murrayc.com>

	Saving from examples: Create the groups mentioned in the document.

	* glom/base_db.[h|cc]: Added add_groups_from_document().
	* glom/application.cc: recreate_database_from_example(): call it.

2010-07-20  Murray Cumming  <murrayc@murrayc.com>>

	Fixed warnings with latest gtkmm-2.24

	* glom/mode_data/notebook_data.cc:
	* glom/mode_find/notebook_find.cc: Use Gtk::Notebook::append_page()
    instead of Gtk::Notebook::pages().push_back().

2010-07-13  Murray Cumming  <murrayc@murrayc.com>

	Fixed warnings, even with the latest gtkmm-2.24.

	Many files: Try to include box.h or dialog.h before other treemodel.h.
    Sometimes just add a gtkmm.h to simplify things. This will not be necessary
    with gtkmm-3.0 (in glom's master branch).

2010-07-07  Murray Cumming  <murrayc@murrayc-desktop>

	PostgresQL backups: Suggest a dated name.

	* glom/application.cc: on_menu_developer_export_backup(): Suggest
    a directory name based on the current name and the date/time.
    Also use the directory name for the .glom filename, as we usually would do,
    instead of calling it just backup.glom.

2010-07-07  Murray Cumming  <murrayc@murrayc.com>

	PostgreSQL backups: Archive the directory in a .tar.gz..

	* configure.ac: Check for the tar and gzip executables.
	* glom/application.cc: on_menu_developer_export_backup(): Use tar
    via the command line, to put it all in a .tar.gz, so it is self-contained.

2010-07-07  Murray Cumming  <murrayc@murrayc.com>

	PostgreSQL backups: Use .pgpass.

	* glom/libglom/connectionpool_backends/postgres.[h|cc]:
	* glom/libglom/connectionpool_backends/postgres_self.[h|cc]:
    Move create_text_file() from PostgresSelf to Postgres and add an
    only_for_current_user bool parameter, so we can use it in a
    new save_password_to_pgpass() method.
    save_backup(), convert_backup(): Temporarily store the password in
    ~/.pgpass, so pg_dump and pg_restore actually work.

2010-07-05  Murray Cumming  <murrayc@murrayc.com>

	Show progress in the UI during backup saving and restoring.

	* glom/application.[h|cc]: on_document_load(),
    on_menu_developer_export_backup(): Show a pulsing progress dialog while
    waiting for backup exporting and restoring.
    on_menu_developer_export_backup(): Close the file chooser dialog as soon
    as we stop using it.

2010-07-03  Murray Cumming  <murrayc@murrayc.com>

	Improve backup saving and add backup restoring.

	* glom/libglom/document/document.[h|cc]: Added get/set_is_backup_file(),
	saved in the XML document..
  on_menu_developer_export_backup(): Mark the .glom file as a backup file.
	Rename recreate_database() to recreate_database_from_example().
	on_document_load(): Handle backup .glom files similarly to examples files,
	but using the backup file instead of example data.
	* glom/frame_glom.cc:
	* glom/libglom/connection_pool.[h|cc]:
	* glom/libglom/connectionpool_backends/backend.[h|cc]: startup(): Return a
	StartupErrors enum, to provide more clues, for instance to say that backup
	data was found.
	Add get/set_database_directory_uri(), replacing the one in sqlite.[h|cc] and
	replacing set_self_hosting_data_uri() in postgres_self.[hc|cc].
	save_backup(): Don't take a filepath - use get_database_directory_uri()
	instead.
	Added convert_backup() to restore from a backup.
	* glom/libglom/connectionpool_backends/sqlite.[h|cc]:
	* glom/libglom/connectionpool_backends/postgres.[h|cc]:
	get_path_to_postgres_executable(): Catch exceptions from Glib::build_filename().
	save_backup(): Use --format=c with pg_dump, because the default one can't be
	used with pg_restore.
	Implement convert_backup(), using pg_restore.
	Added get_self_hosting_config_path(), get_self_hosting_data_path() and
	get_self_hosting_backup_path() to avoid copy/pasting magic paths.
	* glom/libglom/connectionpool_backends/postgres_self.[h|cc]:
	Adapted.
	* glom/application.[h|cc]:
	* tests/test_selfhosting_new_empty.cc: Adapted to check the enum result from
	startup().

2010-07-02  Murray Cumming  <murrayc@murrayc.com>

	Document: Avoid a crash when creating the parent directory.

	* glom/libglom/docment/bakery/document.cc: write_to_disk(): Check the
	result of Gio::File::get_parent() for null, because that happens if we
	provide a path instead of a URI.

2010-07-02  Murray Cumming  <murrayc@murrayc.com>

	Save as Example: Reset the old file URI and allow auto-saving again.

	* glom/application.cc: on_menu_file_save_as_example(): reset the old file
	URI and turn auto-saving back on again, because it makes no sense to leave
	the user editing an example document. This is really an export anyway.
	This allows the user to close the window again after saving as an example.

2010-07-01  Murray Cumming  <murrayc@murrayc.com>

	Add Save Backup menu item.

	* glom/libglom/connectionpool_backends/backend.[h|cc]:
	* glom/libglom/connectionpool_backends/posgres.[h|cc]:
	* glom/libglom/connectionpool_backends/sqlite.[h|cc]: Added save_backup()
	virtual method, using pg_dump for PostgreSQL.
	* glom/libglom/connectionpool.[h|cc]: Add save_backup() here, calling the
	backend.
	* glom/application.cc: Add a Developer/Export Backup menu item, to use
	this feature. This also saves the .glom file.

2010-07-01  Murray Cumming  <murrayc@murrayc.com>

	Spawn functions: Catch some exceptions.

	* glom/libglom/spawn_with_feedback.cc():
	execute_command_line(), execute_command_line_and_wait(): Catch exceptions
	so that these functions don't throw, simplifying caller code. For instance,
	a command may be malformed and rejected by the shell.

2010-06-29  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.[h|cc]: Developer menu: Added an Export Backup menu item.

	* glom/libglom/connectionpool_backends/postgres_central.[h|cc]:
	* glom/libglom/connectionpool_backends/postgres_self.[h|cc]: Moved
    m_host and m_port into the base class:
	* glom/libglom/connectionpool_backends/postgres.[h|cc]:
    because they are used in both derived classes. Therefore remove port
    parameter from attempt_connect().
    Also move get_path_to_postgres_executable() and port_as_string() there
    so they can be used in the base class.

2010-06-29  Murray Cumming  <murrayc@murrayc.com>

	Improve stderr message.

	* glom/libglom/spawn_with_feedback.cc:
    execute_command_line_and_wait_until_second_command_returns_success():
    Correct the error message when a command (such as postgres) fails. As
    noticed in bug #617504.

2010-06-21  David King  <amigadave@amigadave.com>

	Explicitly link with libdl for Python module loading test

	* Makefile_tests.am: Do not rely on libdl being a dependency of a
	library in LIBGLOM_LIBS, by linking with it explicitly.

1.14.3:

2010-06-19  Murray Cumming  <murrayc@murrayc.com>

	Revert previous "Fix a crash when using find mode" commit.

	* glom/application.cc:
	* glom/application.h: This was apparently only a problem due to a previous
	UI-changing commit in the glom-1-16 branch.

2010-05-03  Daniel Borgmann  <danielb@openismus.com>

	Set default icon instead of individual window icons.

	* glom/application.cc: Set default window icon.

	* glom/dialog_existing_or_new.cc:
	* glom/filechooser_export.cc:
	* glom/frame_glom.cc:
	* glom/glade_utils.h:
	* glom/mode_design/script_library/dialog_script_library.cc:
	* glom/mode_design/translation/window_translations.cc:
	* glom/mode_design/users/dialog_groups_list.cc:
	* glom/utility_widgets/filechooserdialog_saveextras.cc:
	* glom/utils_ui.cc:
	* glom/window_boxholder.cc:

	Don't call set_icon_name() on individual windows.

2010-05-12 Daniel Borgmann <danielb@openismus.com>

	Don't allow deleting placeholder rows.

	* glom/utility_widgets/db_adddel/db_adddel.cc: Don't allow deleting a
	placeholder row (which leads to broken behaviour).

2010-05-14  Daniel Borgmann  <danielb@openismus.com>

	Fix position of "Records / Found" labels.

	* glom/glom.glade: Make sure "Records: X Found: X" appears in the right
	order.

2010-05-14  Daniel Borgmann  <danielb@openismus.com>

	Fix a crash when using find mode.

	* glom/application.cc: Don't access m_action_mode_data.
	* glom/application.h: Remove m_action_mode_data.

2010-06-19  Murray Cumming  <murrayc@murrayc.com>

	Remove unnecessary gtk C includes.

	* glom/application.cc:
	* glom/bakery/app_withdoc_gtk.cc:
	* glom/libglom/data_structure/print_layout.cc:
	* glom/libglom/document/document.cc:
	* glom/libglom/gst-package.c:
	* glom/mode_design/comboentry_currency.cc:
	* glom/mode_design/fields/combo_fieldtype.cc:
	* glom/mode_design/layout/combobox_fields.cc:
	* glom/mode_design/layout/combobox_relationship.cc:
	* glom/mode_design/layout/layout_item_dialogs/combo_summarytype.cc:
	* glom/mode_design/layout/layout_item_dialogs/comboentry_borderwidth.cc:
	* glom/mode_design/print_layouts/print_layout_toolbar.cc:
	* glom/mode_design/translation/combobox_locale.cc:
	* glom/utility_widgets/cellrendererlist/cellrendererlist.cc:
	* glom/utility_widgets/combo_textglade.cc:
	* glom/utility_widgets/db_adddel/cellrenderer_buttonimage.cc:
	* glom/utility_widgets/db_adddel/cellrenderer_buttonimage.h:
	* glom/utility_widgets/db_adddel/cellrenderer_buttontext.cc:
	* glom/utility_widgets/db_adddel/cellrenderer_buttontext.h:
	* glom/utility_widgets/db_adddel/db_adddel.cc:
	* glom/utility_widgets/flowtable.cc:
	* glom/utility_widgets/layouttoolbar.cc:
	* glom/xsl_utils.cc: Remove now-unnecessary gtk+/gtk* includes,
	replacing some with use of C++ API. These caused warnings due to GSEAL.

2010-06-19  Murray Cumming  <murrayc@murrayc.com>

	Configure: Remove checks for libegg dependencies, because we don't use it.

	* configure.ac: We don't build libegg code here any more.

2010-06-19  Murray Cumming  <murrayc@murrayc.com>

	Remove the avahi-ui dependency because we don't use it any more.

	* configure.ac: Don't check for avahi-ui.
	* glom/application.cc: Don't include avahi-ui.h

1.14.2:

2010-05-02  Murray Cumming  <murrayc@murrayc-x61>

	Python calculations: Really convert to expected types.

	* glom/libglom/data_structure/glomconversions.cc:
	get_double_for_gda_value_numeric(): Handle all numeric GTypes - not just
	G_TYPE_INT..
	convert_value(): Remove the special case for G_TYPE_INT (now handled in
	get_double_for_gda_value_numeric instead). Make sure that all numeric GTypes
	are converted to GDA_TYPE_NUMERIC, making it easier for callers to check.

2010-05-01  Murray Cumming  <murrayc@murrayc.com>

	Add test of type conversion after python calculations.

	* Makefile_tests.am:
	* tests/test_python_execute_func_change_result_type.cc: Add a test that
	calls a python function that returns a number, for a text field, to
	check that the conversion is done.

2010-05-01  Murray Cumming  <murrayc@murrayc.com>

	Python scripts and calculations: Test buttons now show python errors.

	* glom/python_embed/glom_python.[h|cc]:
	glom_execute_python_function_implementation(),
	glom_evaluate_python_function_implementation(): Add an error_message output
	parameter, to report syntax errors, for instance.
	* glom/mode_design/fields/dialog_fieldcalculation.cc:
  * glom/mode_design/layout/layout_item_dialogs/dialog_buttonscript.cc:
  Show the python error, if any, when pressing the Test button.
  * Other files: Adapt, ignoring the error message for now.
  * Makefile_tests.am:
	* tests/test_python_execute_func_bad_syntax.cc: Added a test of the new
	error_message parameter.

2010-05-01  Murray Cumming  <murrayc@murrayc.com>

	Fix a possible crash when showing choices.

	* glom/mode_data/datawidget/combo.cc: set_text(): Don't show a warning if
	"" is not found because it's OK to use that to clear the combo.
	* glom/mode_data/datawidget/combochoiceswithtreemodel.cc:
	set_choices_with_second(): Don't dereference a null smartpointer, avoiding
	a crash with one .glom file that I tried.

2010-05-01  Murray Cumming  <murrayc@murrayc.com>

	Python Glom API documentation improvement.

	* glom/python_embed/python_module/py_glom_module.cc: Turn off auto-writing
	of the Python signatures in the docstrings, because that is a) crappy and
	b) confuses the sphinx autodoc module, which adds an invisible ..function
	reStrucuredText line.
	Add :param:, :type, and :returns: lines with the necessary indenting and
	empty lines needed by that invisible ..function line.

2010-05-01  Murray Cumming  <murrayc@murrayc.com>

	Fix document saving (recently broken by me) and add a test for it.

	* glom/libglom/document/bakery/document.cc: write_to_disk():
	Do not fail if the parent directory already exists.
	* Makefile_tests.am:
	* tests/test_document_autosave.cc: Added a test of document saving and
	autosaving.

2010-05-01  Murray Cumming  <murrayc@murrayc.com>

	Move tests out of sub-directories, simplifying the build file.

	* tests/Makefile_test.am:
	* tests/test_document_load.cc:
	* tests/test_selfhosting_new_empty.cc: Move out of the sub-directories,
	because they do not need extra files.

2010-04-27  Murray Cumming  <murrayc@murrayc-x61>

	PyGlom: Don't use deprecated boost::python::args.

	* glom/python_embed/python_module/py_glom_module.cc: Use boost::python::arg()
	instead of boost::python::args(), because I noticed that args is deprecated.

1.14.1:

2010-04-27  Murray Cumming  <murrayc@murrayc.com>

	Make sure all glade-instantiated windows have the Glom icon.

	* glom/glade_utils.h: helper_get_glade_widget_derived_with_warning():
    Call set_icon_name() on windows, fixing my regression.

2010-04-27  Murray Cumming  <murrayc@murrayc-desktop>

    Documentation: Added libglom main page. Installed _sources for pyglom.

	* docs/pyglom_reference/Makefile.am: Also install html/_sources, used by search.
	* glom/libglom/init.h: Add a doxygen main page.

2010-04-26  Murray Cumming  <murrayc@murrayc.com>

	Fix the build.

	* Makefile_tests.am: test_selfhosting_new_empty: Link to the Glom sources
	to fix the unresolved link to Glom::Priv's method. We will use more from
	the rest of Glom here too.

2010-04-26  Daniel Elstner  <danielk@openismus.com>

	Use installed mm-common instead of copying it

	* autogen.sh: Run mm-common-prepare to pull in the mm-common include
	files for Automake.
	* docs/libglom_reference/Makefile.am: Set up configuration variables
	and include doc-reference.am instead of copy'n'pasting its content.
	* docs/libglom-reference/doxygen_to_devhelp.xsl: Delete file.  It is
	shipped with mm-common and also part of the glibmm installation.

2010-04-26  Murray Cumming  <murrayc@murrayc.com>

	Reenable test_load_document.

	* Makefile_tests.am: Reenable test_load_document.cc
	* tests/test_load_document/test_load_document.cc: Restore (rewrite) this
	missing file.

2010-04-26  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Remove the dist-bzip2 option that was added by mistake.

2010-04-26  Murray Cumming  <murrayc@murrayc.com>

	Self-Hosting test: Check that cleanup works.

	* Makefile_tests.am:
	* glom/libglom/connectionpool.[h|cc]:
	* glom/libglom/connectionpool_backends/backend.[h|cc]:
	* glom/libglom/connectionpool_backends/postgres_self.[h|cc]:
	* tests/test_selfhosting_new_empty/test_selfhosting_new_empty.cc:
	Make cleanup() return a bool, so we can check it, because this fails sometimes.
	Use the standard username and password.

2010-04-26  Daniel Elstner  <danielk@openismus.com>

	Heavily cut the pyglom_reference build magic

	* docs/pyglom_reference/Makefile.am: Drop the custom installation
	rules and use the GNU make $(wildcard) function for both distribution
	and installation of the generated documentation files.  Since the
	files do not undergo translation at install time, it is not necessary
	to integrate the custom installation tool from mm-common.  Pull in a
	missing GNU make function definition for computing the list of files.

2010-04-26  Daniel Elstner  <danielk@openismus.com>

	Temporarily disable test_document_load

	* Makefile_tests.am (check_PROGRAMS), (TESTS): Temporarily remove
	test_document_load, because the corresponding source file is currently
	missing from the repository.

2010-04-26  Daniel Elstner  <danielk@openismus.com>

	Enable maintainer-mode build in autogen.sh

	* autogen.sh: Run configure with --enable-maintainer-mode since the
	AM_MAINTAINER_MODE macro is now used in configure.ac.

2010-04-26  Murray Cumming  <murrayc@murrayc.com>

	Python Glom module: Improved the docstrings, using reStructuredText

	* glom/python_embed/python_module/py_glom_module.cc: Use more
    reStructureText (or as much as sphinx allows us to use in a docstring).
    It's looking quite good.

2010-04-25  Murray Cumming  <murrayc@murrayc.com>

	Simplify test_selfhosting_new_empty.

	* glom/frame_glom.cc: Move setup_connection_pool_from_document() to:
	* glom/libglom/connectionpool.[h|cc]: Added setup_from_document().
	* tests/test_selfhosting_new_empty/test_selfhosting_new_empty.cc: Use the
	new function here, removing code to explicitly set the backend.

2010-04-23  Murray Cumming  <murrayc@murrayc.com>

	Add a document-loading test and self-hosting test

	* glom/Makefile_tests.am: Added the tests.
	* glom/libglom/test_document.cc: Renamed to example_document_load.cc.
	* tests/test_document_load/test_document_load.cc: Added this new test to
	load a document, checking some known parts of its structure.

	* glom/libglom/document/bakery/document.cc: write_to_disk(): Create the
 	parent directory if necessary, instead of failing with a Gio exception.
 	* test/test_selfhosting_newempty/test_selfhosting_newempty.cc: Saves a new
 	file from an example, starts self-hosting of it, and stops self-hosting.
 	This needs work and expansion.

2010-04-20  Murray Cumming  <murrayc@murrayc.com>

	Python Glom module: Improve sphinx-generated documentation.

	* glom/python_embed/python_module/py_glom_module.cc: Added class docstring
	documentation, based on
	http://library.gnome.org/users/glom/unstable/sec-calculated-fields.html
	Use reStructuredText format as expected by sphinx and as apparently now
	use by Python for docstring text.

2010-04-20  Murray Cumming  <murrayc@murrayc.com>

    Fix the python Glom module name.

	* configure.ac: Fix a recent typo to again use the correct underlined
    name for the Python Glom module. This was fatal, in tests too.

2010-04-20  David King  <davidk@openismus.com>

	Relax the autoconf requirement

	* configure.ac: Relax the autoconf requirement to 2.63, as 2.65 is not
	required. Something older than 2.63 may even be acceptable, but I do
	not have an older version to test.

2010-04-20  David King  <davidk@openismus.com>

	Fix the sphinx-build configure check

	* configure.ac: Abort configure with an error if sphinx-build could
	not be found and --enable-documentation was passed to configure.

2010-04-20  Murray Cumming  <murrayc@murrayc.com>

	Glom Python API reference: Failed attempt to dist the html files.

	* docs/pyglom_reference/Makefile.am: Copied some stuff from the mm-common
    files, but it doesn't work yet.

2010-04-20  Murray Cumming  <murrayc@murrayc.com>

	Glom Python API reference: Install the html generated by sphinx.

	* docs/pyglom_reference/Makefile.am: Add install rules based on awful hacked
    copies of the mm-common stuff. I believe this could be far simpler.

2010-04-20  Murray Cumming  <murrayc@murrayc.com>

	Solve the long-paths problem with the doxygen-generated html files.

	* configure.ac: Change the AM_INIT_AUTOMAKE() call to be like gtkmm,
	allowing the tarball to contain long paths - needed for the libglom html
	documentation.

2010-04-19  Murray Cumming  <murrayc@murrayc.com>

	More improved use of sphinx.

	* docs/pyglom_reference/conf.py.in: Do not generate the module index page
	because we have only one module.
	* docs/pyglom_reference/index.rst.in: Add back the link to the general index,
	which seems to actually be generated.

2010-04-19  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Ran autoupdate to remove use of deprecated macros.

2010-04-19  Murray Cumming  <murrayc@murrayc.com>

    Avoid the requirement for sphinx-build if documentation is disabled.

	* configure.ac: Use AC_PATH_PROG() instead of AC_CHECK_PROG() so we get the
    path to use. Only check if --enable-documentation was used.
	* docs/pyglom_reference/Makefile.am: Only build the html if
    --enable-documentation was used (not yet built by default anyway).

2010-04-19  Murray Cumming  <murrayc@murrayc.com>

    Improved use of sphinx.

	* configure.ac: AC_SUBST() GLOM_ABI_VERSION_UNDERLINED so we can use it
    in docs/pyglom_reference/Makefile.am. Mention these files that will be
    genereated form .in files with the ABI and version numbers substituted.
    Check for sphinx-build, though this should only matter when building docs.
	* docs/pyglom_reference/conf.py.in:
	* docs/pyglom_reference/index.rst.in: Use ABI and version variables instead
    of hard-coding. Add short introductory text with links.

2010-04-16  Murray Cumming  <murrayc@murrayc.com>

    Try to use sphinx for pyglom API documentation.

    * docs/pyglom_reference/Makefile.an:
	* docs/pyglom_reference/sphinx_sources/:
    An attempt to use sphinx instead of pydoc. sphinx is used by Python itself.
    I need to change my Python setup (not have Python in jhbuild) to test
    this properly, because I can't easily build pydoctor in my separate prefix.

2010-04-16  Murray Cumming  <murrayc@murrayc.com>

	Python: Really show warnings when modules can't be imported.

	* glom/python_embed/glom_python.cc: Add and use import_module() to make sure
	that we catch exceptions from boost::python::import(), so show the intended
	warnings instead of just crashing with an uncaught exception.
	Also correct the checks for empty/none boost::python::objects for imported
	modules. A simple ! is not what it seems.

2010-04-16  Murray Cumming  <murrayc@murrayc.com>

    Use mm-common for optional compiler warnings and to build libglom docs.

    * configure.ac: Use mm-common, removing macros/dk-warn.m4.
	* docs/libglom_reference/Doxyfile.in:
	* docs/libglom_reference/doxygen_to_devhelp.xsl:
	* docs/libglom_reference/Makefile.am: Generate libglom documentation
    properly usign build stuff copied from gtkmm.
	* docs/pyglom_reference/Makefile.am: A silly little initial attempt to
    have generated html for the glom python module, using pydoc.

2010-04-15  Murray Cumming  <murrayc@murrayc.com>

  Python field calculation: Fix a crash.

	* glom/libglom/python_embed/pygdavalue_conversions.cc:
	glom_pygda_value_as_boost_pyobject(): Add a PyDateTimeAPI call, as already
	done in glom_pygda_value_from_pyobject(), to prevent a crash (and valgrind
	warning about 0 dereference) when using this (silly, wrong) field calculation,
	though I can't reproduce it in a unit test:
	import datetime
  return (datetime.date.today() - record["date_of_birth"]).days / 365

2010-04-15  Murray Cumming  <murrayc@murrayc.com>

  Python module: Improve API documentation.

	* glom/python_embed/python_module/py_glom_module.cc: Added some options and
	text for docstrings, to improve the pydoc -w output.

1.14.0:

2010-04-14  Murray Cumming  <murrayc@murrayc.com>

	Fall back to the uninstalled .glade file to fix make distcheck.

	* Makefile.am: Define GLOM_PKGDATADIR_NOTINSTALLED as well as the existing
    GLOM_PKGDATADIR.
	* glom/glade_utils.h: get_glade_file_path(): Fall back to the uninstalled
    glade file if the installed one can't be found. This fixes make distcheck.

2010-04-14  Murray Cumming  <murrayc@murrayc.com>

    Glade utils: More error-checking.

	* glom/glade_utils.h:  helper_get_glade_widget_derived_with_warning():
    Catch the other 2 exception types that we now know that
    Gtk::Builder::create*() can throw.
	* glom/frame_glom.cc: create_database(): Use get_glade_widget_with_warning()
    to simplify the code. Our utility functions are now used everywhere.

2010-04-13  Murray Cumming  <murrayc@murrayc.com>

  Remove useless translatable strings.

	* glom/glom_developer.glade: Remove placeholder text from labels that will
	actually have their text set at runtime, so there's need actual need to have
	it in the glade file. They were even marked as translatable.
	Bug #615656 (Gianluca Ferri)

2010-04-12  Murray Cumming  <murrayc@murrayc.com>

  Python calculations and scripts: Fix regression in use of date and time fields.

	* glom/libglom/python_embed/py_glom_record.[h|cc]:
	Change PyGlomRecord_SetFields() to a member set_fields() method, and making
	more of the class private, finishing our conversion to boost::python.
	* glom/libglom/python_embed/py_glom_related.[h|cc]:
	Change PyGlomRelated_SetRelationships() to a set_relationships methods.
	* glom/libglom/python_embed/py_glom_relatedrecord.[h|cc]:
	Changed PyGlomRelatedRecord_SetRelationship() to a set_relationship() method.

	* glom/python_embed/glom_python.cc: glom_pygda_value_from_pyobject():
  Handle date, time, timestamp, geometric point values, whose code had been
  commented out since the port to boost::python.
	This fixes the test added in the previous commit, so glom calculations and
	scripts can again (it broke in unstable Glom 1.13) use date and time field
	values from the record.

2010-04-12  Murray Cumming  <murrayc@murrayc.com>

  Added test showing problem with date fields in python calculations.

	* tests/test_python_execute_func_date.cc: Added a test of dates as input
	values for record fields. This currently fails with this error from python,
	so I need to fix it in Glom:
	AttributeError: 'NoneType' object has no attribute 'year'

2010-04-12  Daniel Elstner  <danielk@openismus.com>

	Further clean up AX_BOOST_PYTHON_MURRAYC

	* macros/ax_boost_python_murrayc.m4: Simplify the logic of the checks
	and clean up the Bourne shell code.  Also, abort with a fatal error
	if the boost::python headers or library could not be found.

2010-04-12  Murray Cumming  <murrayc@murrayc.com>

    Slight AX_BOOST_PYTHON_MURRAYC() cleanup.

	* macros/ax_boost_python_murrayc.m4: Add necessary quotes, avoid ==,
    and use AC_LANG_PUSH/AC_LANG_POP instead of deprecated
    AC_LANG_SAVE/AC_LANG_CPLUSPLUS/AC_LANG_RESTORE. Noticed by Daniel Elstner,
    though we don't know if this solves any known problems yet.

2010-04-12  Murray Cumming  <murrayc@murrayc.com>

	Provide context for translations.

	* glom/application.cc:
	* glom/frame_glom.cc:
	* glom/mode_design/users/dialog_users_list.cc: Use the new (in glib 2.16)
    C_() macro to provide context for bare uses of "User" and "Developer",
    providing some explanation and allowing translators to use translate them
    differently, as may be required by some languages.
    Fixes bug #606931 (Urmas, André Klapper)

2010-04-12  Murray Cumming  <murrayc@murrayc.com>

  Fix glade loading.

	* glom/glade_utils.h: get_glade_widget_derived_with_warning(): Fix silly
	but fatal typo.

2010-04-11  Murray Cumming  <murrayc@murrayc.com>

  Simplify setting of the icon for windows.

	* glom/glade_utils.h: get_glade_widget_derived_with_warning():
	Call set_icon_name() on windows.
	* Several *.cc files: Don't bother calling set_icon_name() after calling
	get_glade_widget_derived_with_warning().

2010-04-10  Murray Cumming  <murrayc@murrayc-x61>

  dialog_run_with_help(): Get the help ID from the class.

  * glom/utils_ui.h: dialog_run_with_help(): Add a templated version that uses
  the static glade_id member, to avoid repeating this in the source code.
	* Several .cc files: Remove the ID parameter from most uses of
	dialog_run_with_help().

2010-04-10  Murray Cumming  <murrayc@murrayc.com>

  Glade instantiation: Simplify, make more robust, and test.

  * glom/glade_utils.h: get_glade_widget_derived_with_warning(),
  get_glade_developer_widget_derived_with_warning(): Add method overloads that
  don't take an ID. These require the class to have a static glade_id member.
  This associates the IDs with the class, instead of being in other files,
  to avoid duplication and to avoid using the wrong ones.
  * Many files: Use these new methods, to avoid mentioning glade IDs.
  * tests/test_glade_derived_instantiation.cc: Try to instantiate all the known
  derived glade dialogs.

2010-04-10  Murray Cumming  <murrayc@murrayc.com>

  Glade files: Move a client-only dialog to the correct file.

	* glom/glom_developer.glade:
	* glom/glom.glade: Move dialog_choose_date to glom.glade.
	* glom/mode_data/datawidget/datawidget.cc: on_button_choose_date():
	Adapted.

2010-04-10  Murray Cumming  <murrayc@murrayc.com>

  Application: Forget the global instance when it has been deleted.

  * glom/application.cc: Destructor: reset the static instance to 0,
  to avoid anything from retrieving the pointer to the deleted object.

2010-04-10  Murray Cumming  <murrayc@murrayc.com>

  Remove some unused code.

	* glom/base_db.cc: offer_item_formatting(): Remove a useless use of
	Gtk::Builder.

2010-04-10  Murray Cumming  <murrayc@murrayc.com>

  Notebook properties dialog: Fix a probable crash.

	* glom/base_db.cc: :offer_notebook(): Fix a typo in the glade ID.
	I'm working on code to prevent these kinds of errors, to apply when we branch.

2010-04-09  Daniel Borgmann  <danielb@openismus.com>

	Update NEWS file.

	* NEWS: Add entry.

2010-04-09  Daniel Borgmann  <danielb@openismus.com>

	Clean up Add Related Table dialog.

	* glom/glom_developer.glade: (dialog_add_related_table) Remove frame,
	fix spacings, align form elements in table.
	* glom/mode_design/dialog_add_related_table.cc: Add window icon.

2010-04-09  Daniel Borgmann  <danielb@openismus.com>

	Update translation dialogs.

	* glom/application.cc:
	* glom/glom_developer.glade:
	* glom/mode_design/script_library/dialog_script_library.cc:
	* glom/mode_design/translation/window_translations.cc:
	* glom/mode_design/users/dialog_groups_list.cc:
	Translation dialog updates, set missing window icons.

2010-04-09  Murray Cumming  <murrayc@murrayc.com>

  Reports: Fix a crash when opening the secondary fields dialog.

  * glom/glom_developer.glade: dialog_groupby_secondary_fields: Rename a
  button to match what the class's constructor expects.

2010-04-09  Armin Burgmeier  <armin@arbur.net>

	* win32/build-installer:
	* win32/glom.iss.in: Update for Glom 1.14.

2010-04-09  Armin Burgmeier  <armin@arbur.net>

	* Makefile.am: Do not install .desktop file on Windows.

2010-04-09  Daniel Borgmann  <danielb@openismus.com>

	Update dialogs.

	* glom/frame_glom.cc: Set window icons.
	* glom/glom_developer.glade: Update user dialogs.
	* glom/mode_design/layout/dialog_layout.cc: Set window icons.
	* glom/mode_design/users/dialog_groups_list.cc: Set window icons.

2010-04-08  Daniel Borgmann  <danielb@openismus.com>

	Use buttonbox for details view.

	* glom/mode_data/box_data_details.cc:
	* glom/mode_data/box_data_details.h:
	Use HButtonBox instead of HBox.

2010-04-08  Murray Cumming  <murrayc@murrayc.com>

  ImageGlom: Move scale_keeping_ratio() somewhere more sensible.

	* glom/utility_widgets/imageglom.[h|cc]: Move scale_keeping_ratio() to
	glom/utils_ui.[h]cc] as Utils::image_scale_keeping_ratio().
	* glom/utility_widgets/canvas/canvas_image_movable.cc:
	* glom/utility_widgets/db_adddel/db_adddel.cc:
	* glom/utility_widgets/flowtable_dnd.cc: Adapted.

2010-04-08  Murray Cumming  <murrayc@murrayc.com>

  glom/mode_data/datawidget/: Clean up classes, putting them in a namespace.

  * glom/mode_data/datawidget/: Removed Glom suffixes from class names
  and filenames, and put classes in a DataWidgetChildren sub-namespace,
  to make it clearer where we occasionally use these outside of DataWidget.

2010-04-08  Murray Cumming  <murrayc@murrayc.com>

  Cleaned glom/utility_widgets/ a little.

  * glom/utility_widgets/datawidget.[h|cc]: Moved to glom/mode_data/datawidget/
  because it is only used by the data-mode flowtable.
	* glom/utility_widgets/buttonglom.[h|cc]
	* glom/utility_widgets/checkglom.[h|cc]
	* glom/utility_widgets/combo_as_radio_buttons.[h|cc]
	* glom/utility_widgets/combochoices.[h|cc]
	* glom/utility_widgets/combochoiceswithtreemodel.[h|cc]
	* glom/utility_widgets/comboentryglom.c[h|cc]
	* glom/utility_widgets/comboglom.[h|cc]
	* glom/utility_widgets/dialog_choose_date.[h|cc]
	* glom/utility_widgets/dialog_choose_id.[h|cc]
	* glom/utility_widgets/entryglom.[h|cc]
	* glom/utility_widgets/labelglom.[h|cc]
	* glom/utility_widgets/textviewglom.[h|cc]
	* glom/utility_widgets/placeholder-glom.[h|cc]: Also move these to
  glom/mode_data/datawidget because they are only used by DataWidget.
	* glom/utility_widgets/alignment_justified.[h|cc]:
	* glom/utility_widgets/table_columns.[h|cc]: Deleted these unused classes.
  * Makefile_glom.am: Adapted.

2010-04-08  Daniel Borgmann  <danielb@openismus.com>

	Use button box for adddel widgets.

	* glom/utility_widgets/adddel/adddel_withbuttons.cc:
	* glom/utility_widgets/adddel/adddel_withbuttons.h:
	* glom/utility_widgets/db_adddel/db_adddel_withbuttons.cc:
	* glom/utility_widgets/db_adddel/db_adddel_withbuttons.h:
	Use ButtonBox instead of HBox.

2010-04-08  Daniel Borgmann  <danielb@openismus.com>

	Use button box for listview buttons.

	* glom/utility_widgets/db_adddel/db_adddel_withbuttons.cc:
	* glom/utility_widgets/db_adddel/db_adddel_withbuttons.h:
	Use ButtonBox instead of HBox to make buttons homogenous. Also change
	button order to match order used everywhere else (Add/Delete/Open).

2010-04-08  Daniel Borgmann  <danielb@openismus.com>

	Text and Image object Dialog adjustments.

	* glom/glom_developer.glade: Various dialog layout fixes.
	* glom/mode_design/layout/layout_item_dialogs/dialog_imageobject.cc:
	* glom/mode_design/layout/layout_item_dialogs/dialog_imageobject.h:
	* glom/mode_design/layout/layout_item_dialogs/dialog_textobject.cc:
	* glom/mode_design/layout/layout_item_dialogs/dialog_textobject.h:
	Update box variable name and add window icons.

2010-04-08  David King  <davidk@openismus.com>

	Update copyright information in about dialog

	* glom/application.cc: Update copyright year in about dialog.

2010-04-07  Murray Cumming  <murrayc@murrayc.com>

    Recent Files: Make sure that we remember these for saved-from-example files.

	* glom/application.cc: on_document_load(): Add an extra call to
    document_history_add() after successfully saving from an example.

2010-04-07  Daniel Borgmann  <danielb@openismus.com>

	Find bar adjustments.

	* glom/frame_glom.cc: Rename Quick Find to Quick Search and add
	mneomnic.
	* glom/glom.glade: Update find id dialog and remove frame.
	* glom/utility_widgets/datawidget.cc: Add window icon to find id
	dialog.

2010-04-07  David King  <davidk@openismus.com>

	Fix boost:python m4 macro with -Wl,--as-needed

	* macros/ax_boost_python_murrayc.m4: Specify libraries in LIBS, not
	LDFLAGS. See http://www.gentoo.org/proj/en/qa/asneeded.xml

2010-04-06  Daniel Borgmann  <danielb@openismus.com>

	Dialog adjustments.

	* glom/glom.glade: Spacing adjustments to make dialogs more HIG
	compliant.

2010-04-06  Daniel Borgmann  <danielb@openismus.com>

	Initial Password Dialog adjustments.

	* glom/glom_developer.glade: Initial Password Dialog tweaks.
	* glom/mode_design/dialog_initial_password.cc: Set window icon.

2010-04-06  Daniel Borgmann  <danielb@openismus.com>

	CSV Import Dialog adjustments.

	* glom/glom.glade: Import dialog tweaks.
	* glom/import_csv/dialog_import_csv.cc: Add window icon, change title
	order.

2010-04-06  Daniel Borgmann  <danielb@openismus.com>

	Dialog fixes.

	* glom/frame_glom.cc: Add window icons and fix capitalisation of
	primary texts (dialog text uses sentence capitalisation).

2010-04-06  Daniel Borgmann  <danielb@openismus.com>

	Set Progress Dialog default size.

	* glom/glom.glade: Set a reasonable default size for the progress
	dialog, that allows to read the title at least.

2010-04-06  Daniel Borgmann  <danielb@openismus.com>

	Select Field Dialog adjustments.

	* glom/glom_developer.glade: Spacing and mnemonic adjustments/fixes,
	remove frame label.
	* glom/mode_design/layout/dialog_choose_field.cc: Add window icon.

2010-04-06  Daniel Borgmann  <danielb@openismus.com>

	Progress dialog adjustments.

	* glom/dialog_progress_creating.cc: Add window icon.
	* glom/glom.glade: Center dialog on parent window.

2010-03-31  Daniel Borgmann  <danielb@openismus.com>

	Don't show error icon for empty recent documents.

	* glom/dialog_existing_or_new.cc: Also don't show error icon for
	empty recent documents.

2010-03-31  Daniel Borgmann  <danielb@openismus.com>

	Welcome Screen adjustments.

	* glom/dialog_existing_or_new.cc: Fix typo and use of properties, don't
	show error icon when no network sessions are available.
	* glom/glom.glade: Hide label and icon, spacing adjustments.

2010-03-31  Daniel Borgmann  <danielb@openismus.com>

	Improve application title.

	* glom/application.cc: Don't show colon in application title when
	table name is empty.

2010-03-31  Daniel Borgmann  <danielb@openismus.com>

	Remove unneded alert dialogs / TODO items.

	* glom/frame_glom.cc: No table warnings are not needed anymore
	for menu items, so remove them.

2010-03-31  Daniel Borgmann  <danielb@openismus.com>

	Set window icon for OK dialogs.

	* glom/utils_ui.cc: show_ok_dialog: Set window icon.

2010-03-30  Daniel Borgmann  <danielb@openismus.com>

	Set window icon for welcome screen.

	* glom/dialog_existing_or_new.cc: Set window icon.

2010-03-30  Daniel Borgmann  <danielb@openismus.com>

	Disable some menu items when no table is loaded.

	* glom/application.cc: update_table_sensitive_ui: Function to set
	sensitivity of menu items depending on whether a table is loaded.
	init_menus: Add table sensitive menu items to a list.
	* glom/application.h: Add list to hold table sensitive menu items.
	* glom/frame_glom.cc: Call update_table_sensitive_ui when needed.

2010-03-30  Murray Cumming  <murrayc@murrayc.com>

	Glade instantation test: Make it exit on failure.

	* tests/test_glade_toplevels_instantiation.sh: Use || exit 1, as in
    David's commit to the other files.

2010-03-30  David King  <davidk@openismus.com>

	Make DTD validation tests exit on failure

	* tests/test_dtd_file_validation.sh:
	* tests/test_glade_file_validation.sh: Append ‘ || exit 1’ to the
	xmllint call, to ensure that a validation failure leads to a failing
	test.

2010-03-30  Daniel Borgmann  <danielb@openismus.com>

	Capitalisation fixes.

	* glom/application.cc: Use lower case for short prepositions.

2010-03-30  Daniel Borgmann  <danielb@openismus.com>

	Fix mnemonics.

	* glom/application.cc: Add missing mnemonics and change double
	mnemonics.

2010-03-30  Murray Cumming  <murrayc@murrayc.com>

    Update the document DTD, to fix tests.

	* glom/glom_document.dtd: data_layout_button: Allow this to have a
    formatting child node, because we now allow this in the UI and save this.

2010-03-30  Murray Cumming  <murrayc@murrayc.com>

    Add a test to check instantiation of glade widgets.

    * Makefile_tests.am
	* tests/glade_toplevels_instantiation.cc: Added this code for an
    executable that will try to instantiate all GtkWindow and GtkDialog
    objects in a specified .glade file. It also checks that they are not
    visible by default.
	* tests/test_glade_toplevels_instantiation.sh: Added a tests script,
    run during make check, to run this executable on all our .glade files.

    * glom/glom.glade, glom_developer.glom: Fix small problems found by the
    test, removing an empty textbuffer top-level object and making all
    top-level objects non-visible by default.

2010-03-29  Daniel Borgmann  <danielb@openismus.com>

	Relationships Overview dialog adjustments.

	* glom/glom_developer.glade: Remove frame and adjust spacings for
	Relationships Overview dialog.

2010-03-29  Daniel Borgmann  <danielb@openismus.com>

	Correct mnemonic widgets.

	* glom/glom_developer.glade: Actually set the correct mnemonic
	widgets for Report Layout input labels.

2010-03-29  Daniel Borgmann  <danielb@openismus.com>

	Remove boldness from input labels.

	* glom/glom_developer.glade: Remove bold markup for Report Layout
	input labels.

2010-03-29  Daniel Borgmann  <danielb@openismus.com>

	Report Layout dialog adjustments.

	* glom/frame_glom.cc: Set Report Layout dialog window icon.
	* glom/glom_developer.glade: Report Layout dialog spacing
	adjustments and mnemonics fix.

2010-03-29  Daniel Borgmann  <danielb@openismus.com>

	Reports dialog adjustments.

	* glom/frame_glom.cc: Set Reports dialog window title.
	* glom/glom_developer.glade: Remove frame from Reports dialog.

2010-03-29  Daniel Borgmann  <danielb@openismus.com>

	Remove frame label on Fields dialog.

	* glom/box_reports.cc: Remove references to frame label.
	* glom/box_reports.h: Remove frame label member.
	* glom/frame_glom.cc: Set window icon for Fields and Relationships
	dialogs.
	* glom/glom_developer.glade: Adjust Fields and Relationships dialogs.
	* glom/mode_design/dialog_design.cc: Remove references to frame label.
	* glom/mode_design/dialog_design.h: Remove frame label member.
	* glom/mode_design/dialog_fields.cc: Remove references to frame label.
	* glom/mode_design/dialog_relationships.cc: Remove references to frame
	label.
	* glom/mode_design/print_layouts/box_print_layouts.cc: Remove
	references to frame label.
	* glom/mode_design/print_layouts/box_print_layouts.h: Remove frame
	label member.
	* glom/navigation/box_tables.cc: Remove references to frame label.

2010-03-29  Murray Cumming  <murrayc@murrayc.com>

    Avoid Operation Not Supported warnings at startup.

	* glom/application.cc:
	* glom/bakery/app_withdoc.cc:
	* glom/libglom/connectionpool_backends/postgres_self.cc:
	* glom/libglom/connectionpool_backends/sqlite.cc:
	* glom/libglom/document/bakery/document.cc:
	* glom/libglom/utils.cc:
	* glom/xsl_utils.cc: Avoid creating a Gio::File() from an empty URI,
    avoiding useless stdout warnings at startup.

2010-03-29  Daniel Borgmann  <danielb@openismus.com>

	Edit Field Definition Dialog adjustments.

	* glom/glom_developer.glade: Update alignment and spacings, add mnemonics.
	* glom/mode_design/fields/box_db_table_definition.cc: Set window icon.

2010-03-29  Daniel Borgmann  <danielb@openismus.com>

	Export Format dialog adjustments.

	* glom/filechooser_export.cc: Set icon name for export format dialog.
	* glom/glom_developer.glade: (Export Format) Remove frame, move Add
	button to the start.
	* glom/mode_design/layout/dialog_layout_export.cc: Rename treeview
	header to "Fields" to replace the label.

2010-03-29  Daniel Borgmann  <danielb@openismus.com>

	Print Layouts dialog adjustments.

	* glom/frame_glom.cc: Set title and transient for Print Layouts dialog.
	* glom/glom_developer.glade: Remove the frame from Print Layouts dialog.

2010-03-26  Murray Cumming  <murrayc@murraycs.com>

	Say when a chosen file doen't exist, and remove it from the history.

	* glom/libglom/document/bakery/document.[h|cc]: Add an enum for
    standard failure_codes, including a last enum values that custom codes
    should start after.
    read_from_disk(): Set a failure_code output variable here too, so we
    can detect non-existant files.
	* glom/libglom/document/document.h: Start the custom code after the last
    standard one.
	* glom/bakery/app_withdoc.cc: open_document(): Remove non-existant
    files from the recent files history.
	* glom/application.cc: ui_warning_load_failed(): Say if the file could not
    be found, instead of being mysterious. This happens for me often for
    recent files that I have deleted.

2010-03-26  Daniel Borgmann  <danielb@openismus.com>

	Adjust file chooser dialogs.

	* glom/dialog_existing_or_new.cc: Adjust title of file open dialog,
	set glom icon.
	* glom/utility_widgets/filechooserdialog_saveextras.cc: Set glom icon.

2010-03-26  Daniel Borgmann  <danielb@openismus.com>

	Fix filechooser title label.

	* glom/utility_widgets/filechooserdialog_saveextras.cc: Add colon and
	mnemonic to "Title" label.

2010-03-26  Daniel Borgmann  <danielb@openismus.com>

	Fix column spacing in connection dialog.

	* glom/glom.glade: Set column spacing in connection dialog to 12px.

2010-03-26  Daniel Borgmann  <danielb@openismus.com>

	Connection dialog adjustments.

	* glom/dialog_connection.cc: Add glom icon and remove maemo title hack
	as primary text does not exist anymore.
	* glom/glom.glade: Remove double title from connection dialog
	and make it HIG/GNOME conform.

2010-03-26  Daniel Borgmann  <danielb@openismus.com>

	Export dialog adjustments.

	* glom/filechooser_export.cc: Add glom icon and set mnemonic for Export
	button.

2010-03-26  Daniel Borgmann  <danielb@openismus.com>

	Adjustments for Import dialog.

	* glom/frame_glom.cc: Set window icon and update title text.

2010-03-26  Daniel Borgmann  <danielb@openismus.com>

	Adjustments for Tables dialog.

	* glom/application.cc: Use gtkmm API to set document icon.
	* glom/frame_glom.cc: Change Tables dialog title to "Edit Tables" to
	match the command name.
	* glom/glom.glade: Remove the frame.
	* glom/navigation/box_tables.cc: Change column name from Tables to Table.
	* glom/navigation/box_tables.h: Remove frame member.
	* glom/window_boxholder.cc: Set icon and default position to center on
	parent.

2010-03-25  Murray Cumming  <murrayc@murrayc.com>

    Glade files: Remove adjustment objects, simplifying window instantiation.

	* glom/glom_developer.glade: Remove useless (default, empty) adjustment
    objects, so we can load the windows with GtkBuilder without specifying
    them. Recent versions of Glade no longer seem to create these when they
    would just have default values.
	* glom/base_db.cc:
	* glom/frame_glom.cc:
	* glom/glom.glade:
	* glom/mode_design/fields/dialog_fielddefinition.cc:
	* glom/mode_design/layout/layout_item_dialogs/dialog_field_layout.c
	c:
	* glom/mode_design/layout/layout_item_dialogs/dialog_formatting.cc:
	* glom/mode_design/print_layouts/dialog_text_formatting.cc:
    Don't provide the id of the adjustment, removing the silly workaround.

2010-03-24  Daniel Borgmann  <danielb@openismus.com>

	Don't show error dialog when user cancels template creation.

	* glom/application.cc: Display error message when trying to create
	a document from template in client-only-mode.
	* glom/bakery/app_withdoc.cc: Don't display error message if the
	document is rejected, let the application decide about it.

1.13.9:

2010-03-23  Murray Cumming  <murrayc@murrayc.com>

    Refactored combo classes.

	* glom/utility_widgets/comboglomchoicesbase.[h|cc]:
    Split into combochoices.[h|cc] and combochoiceswithtreemodel.[h|cc] so
    that combo_as_radio_buttons.[h|cc] doesn't need to have an unused treemodel.

2010-03-23  Murray Cumming  <murrayc@murrayc.com>

    Formatting: Choices: Add a Display as radio buttons option.

	* glom/glom_developer.glade: formatting: choices: Add a Show As Radio
    Buttons checkbox.
	* glom/libglom/data_structure/layout/fieldformatting.[h|cc]:
    set/get_choices_restricted(): Add a show_as_radio_buttons output parameter.
	* glom/libglom/document/document.cc:
    load_after_layout_item_formatting(), save_after_layout_item_formatting():
    load and save the new formatting detail.
	* glom/mode_design/layout/layout_item_dialogs/box_formatting.[h|cc]:
    Handle the new checkbox and make sure that it is only sensitive when
    the choices are restricted, because radio buttons provide no way to enter
    freeform data.
	* glom/utility_widgets/comboglomchoicesbase.h: Make set_choices() and
    set_choices_with_second() virtual.
    * glom/utility_widgets/combo_as_radio_buttons.[h|cc]: A new widget that is
    a vbbox of radio buttons, with a combo-like API.
	* Makefile_glom.am: Mention the new files.
	* glom/utility_widgets/datawidget.cc: Refactor some repeated code into
    create_combo_widget_for_field() and create the radiobuttons widget when
    necessary.

2010-03-22  Murray Cumming  <murrayc@murrayc.com>

    Fix the distcheck. Don't use deprecated gtkmm API.

	* glom/utility_widgets/flowtable.cc:
	* glom/utility_widgets/flowtable_dnd.cc:
	* glom/utility_widgets/placeholder-glom.cc: Adapt to deprecated gtkmm API.
    Use get_has_window() and set_has_window() instead of get_flags(),
    unset_flags() and set_flags().

2010-03-21  Murray Cumming  <murrayc@murrayc.com>

    Small fixes to glade file.

	* glom/glom_developer.glade: Add some still-missing vbox orientation=vertical
	lines.

2010-03-19  Daniel Borgmann <danielb@openismus.com>

	* configure.ac: Make Glom build with autoconf 2.65.
	Patch from Fryderyk Dziarmagowski in GNOME bug #613179.

2010-03-16  David King  <davidk@openismus.com>

	Fix GtkVBox orientation in GtkBuilder files

	* glom/glom.glade:
	* glom/glom_developer.glade: Manually set the orientation of GtkVBox
	objects specified in the GtkBuilder files to ‘vertical’. See GNOME bug
	#587256 for details of the issue with Glade.

2010-03-16  Murray Cumming  <murrayc@murrayc.com>

  Tests: Check that the .glade files are valid XML.

  * Makefile_tests.am:
	* tests/test_glade_file_validation.sh: Add this text that the .glade files
	are basically valid XML. It would be nice to have a Glade DTD to validate
	them against too.
	We should also check that each top-level widget can be instantiated by
	GtkBuilder.

2010-03-16  Murray Cumming  <murrayc@murrayc.com>

  Add a startup script feature.

  * libglom/document/document.cc: Added get/set_startup_script().
  load_after(), save_before(): Load and save the startup script.

  * glom_developer.glade:
  * glom/mode_design/dialog_database_preferences.[h|cc]: Add a startup script tab.

  * libglom/python_embed/py_glom_ui.h: Move PythonUICallbacks into its own
  py_glom_ui_callbacks.h header.
  * glom/python_embed/python_ui_callbacks.[h|cc]: Add this derived callbacks
  class that has handlers that call methods in the application.
  * glom/mode_data/box_data.cc: execute_button_script(): Use the new callbacks
  class instead of using member methods here.
  * glom/application.cc: on_document_load(): Run the startup script, if any,
  after loading the document, using the new derived callbacks class.

  * Makefile_glom.am, Makefile_libglom.am: Mention the new files.

2010-03-13  David King  <davidk@openismus.com>

	Depend on gtkmm >= 2.19.2, fixing GNOME bug #612796

	* configure.ac: Bump glom gtkmm version requirement to >= 2.19.2 for
	Gtk::ToolPalette. Fixes GNOME bug #612796.

2010-03-13  David King  <davidk@openismus.com>

	Depend on libxml++ >= 2.23.1, fixing GNOME bug#612794

	* configure.ac: Bump libglom libxml++ version requirement to >= 2.23.1
	for xmlpp::Element::add_child_text_before(). Fixes GNOME bug #612794.

2010-03-09  Murray Cumming  <murrayc@murrayc.com>

    Initial Dialog: Do not crash sometimes if cancelling the file chooser.

	* glom/application.cc: offer_new_or_existing(): Show the dialog again if
    we get a 0 response, because we cannot (yet) prevent the dialog from
    doing this when the child file chooser dialog is cancelled. Fixes a crash
    if pressing the Select button instead of double-clicking on an item.
    Bug #612303 (David King)

1.13.8:

2010-03-08  Murray Cumming  <murrayc@murrayc.com>

    Slight update of Small Business example.

	* examples/example_smallbusiness.glom: Resave, with a new record with
    a picture of a polar bear for use on the www.glom.org website.
    The picture is from http://www.flickr.com/photos/mape_s/350700095/
    (Creative-Commons licensed, by Marieke IJsendoorn-Kuijpers)

2010-03-08  Murray Cumming  <murrayc@murrayc.com>

    Python button scripts: Rename print() to print_layout() and add start_new_record().

	* glom/application.[h|cc]
	* glom/frame_glom.[h|cc]
	* glom/libglom/python_embed/py_glom_ui.[h|cc]
	* glom/mode_data/box_data.[h|cc]
	* glom/mode_data/box_data_details.[h|cc]
	* glom/mode_data/notebook_data.[h|cc]
	* glom/python_embed/python_module/py_glom_module.cc:
	* tests/test_python_execute_script.cc:
    Add a ui.start_new_record() python method, and rename ui.print() to
    ui.print_layout() because print seems to be a python keyword that can't
    be used as a method name, seen when trying to use it in the unit test.

2010-03-08  Peter Penz  <ppenz@openismus.com>

	Fix the build with exceptions disabled.

	* glom/libglom/document/bakery/document_xml.cc:
	* glom/mode_design/iso_codes.cc: The exception handling is enabled by the
    define LIBXMLPP_EXCEPTIONS_ENABLED. But this is a typo, as libxml++ defines
    LIBXMLCPP_EXCEPTIONS_ENABLED.

2010-03-05  Murray Cumming  <murrayc@murrayc.com>

    Python button scripts: Add ui.print() and ui.print_reports(report_name).

	* glom/application.[h|cc]: Add print() and print_report(), calling
    methods in the frame widget.
	* glom/libglom/python_embed/py_glom_ui.[h|cc]: Add new print() and
    print_report() methods, adding callback slots for use by Glom.
	* glom/python_embed/python_module/py_glom_module.cc: Register the new
    Python methods.
	* glom/mode_data/box_data.[h|cc]: execute_button_script(): Handle the
    new signals, calling the new methods in Application.

2010-03-07  Murray Cumming  <murrayc@murrayc.com>

    Details: Align widgets in other columns too.

	* glom/utility_widgets/flowtable.[h|cc]: Added get_columns_count().
	* glom/mode_data/flowtablewithfields.[h|cc]: apply_size_group_to_label():
	Change this to apply_size_groups_to_label().
	align_child_group_labels(): Create a size group for each possible column,
	and call apply_size_groups_to_label() with them.

2010-03-06  Murray Cumming  <murrayc@murrayc.com>

	Details: Align widgets in the first columns of neighbouring layout groups.

	* glom/utility_widgets/flowtable.[h|cc]: Added get_column_for_first_widget(),
	to discover what column a widget is in, and whether it has even been assigned
	to a column yet (if the size has been allocated already.)
	FlowTableItem: Remember whether the item has a column number and what it is.
	on_size_allocate(): Remember the column numbers of items for later retrieval.
	* glom/mode_data/flowtablewithfields.[h|cc]: Info, add_field_at_position():
	Store the pointer to eventbox too, so we can later discover its column from
	the base FlowTable.
	Add align_child_group_labels(), to make all first-level labels in child
	flowtables share a single Gtk::SizeGroup, making them align.
	Add apply_size_group_to_labels() to actually add the labels to the size group.
	add_layout_group_at_position(): Call align_child_group_labels() on new
	sub-flowtables.
	on_size_allocate(): After the base class has allocated the spaces for the
	child widgets, after it therefore knows the column positions for the widgets,
	call apply_size_group_to_labels() to make them align.
	* glom/mode_data/box_data_details.cc: create_layout(): Call
	align_child_group_labels() to align items in top-level groups.

2010-03-06  Murray Cumming  <murrayc@murrayc.com>

  Details: Do not make field widgets too wide, so this fits on a laptop screen.

	* glom/utils_ui.cc: get_suitable_field_width_for_widget(): Do not add 150
	to all calculated widths. I don't know why this code ever did that.

1.13.7:

2010-02-28  Murray Cumming  <murrayc@murrayc.com>

    Python button scripts: Avoid a crash with buttons in lists.

	* glom/mode_data/box_data_list.[h|cc]: on_adddel_script_button_clicked():
	Run the script in the (existing) on_script_button_idle() idle handler because
	the script can cause the cell (that is emitting the signal) to be destroyed,
	by navigating to a different table. This fixes that crash.
	* glom/mode_data/box_data_list_related.cc: Do the same here.
	* glom/mode_data/notebook_data.cc: on_list_user_requested_details(): Use
	the same idle handler trick here, just in case.

2010-02-28  Murray Cumming  <murrayc@murrayc.com>

	Added unit test for the new button script ui python API.

	* Makefile_tests.am:
	* tests/test_python_execute_script.cc: Added unit test for the new button
	script ui python API.

2010-02-28  Murray Cumming  <murrayc@murrayc.com>

    PyGlomUI: Simplify the callbacks object.

	* glom/libglom/python_embed/py_glom_ui.[h|cc]: Use public sigc::slots instead
	  of signals, to simplify this.
	* glom/mode_data/box_data.cc
	  Box_Data::execute_button_script(): Adapt.

1.13.6:

2010-02-28  Murray Cumming  <murrayc@murrayc.com>

  Fix the python function tests.

	* glom/python_embed/glom_python.cc
	glom_execute_python_function_implementation,
	glom_evaluate_python_function_implementation: Import the glom python module
	before trying to create a boost::python::object(new PyGlomRecord), to avoid
	an exception in the tests.

2010-02-28  Murray Cumming  <murrayc@murrayc.com>

	Many files: Rename App_Glom to Application (in namespace Glom).

2010-02-28  Murray Cumming  <murrayc@murrayc.com>

  Python button scripts: Add show_table_details() and show_table_list().

	* Makefile_libglom.am:
	* glom/python_embed/python_module/py_glom_module.cc:
	* glom/libglom/python_embed/py_glom_ui.[h|cc]: Added a PyGlomUI object
	that can be passed to python functions in addition to the record object,
	with methods to navigate in the UI. So far there is just
	show_table_details() and show_table_list().
	* glom/glom_developer.glade: Script editor window: Mention the extra ui
	parameter.
	* glom/python_embed/glom_python.[h|cc]: Add a callback object parameter so
	scripts can tell the caller to change things in the UI.
  * glom/frame_glom.h: Made show_table() public so that the Application can
	call it.
	* glom/application.[h|cc]: Add show_table_details() and add_show_list()
	methods for the callbacks to call.
	* glom/mode_data/box_data.[h|cc]: Handle the callback signals, to actually do
	the navigation when a python script requests it.
	* glom/mode_design/layout/layout_item_dialogs/dialog_buttonscript.cc: Adapted.

2010-02-27  Murray Cumming  <murrayc@murrayc.com>

  Python: Prevent field calculations from changing the data in other fields.

	* glom/libglom/python_embed/py_glom_record.[h|cc]: Added set_read_only().
	* glom/python_embed/glom_python.[h|cc]:
	glom_evaluate_python_function_implementation(): Add a bool read_only
	parameter that defaults to true.
	glom_execute_python_function_implementation(): Pass read_only=false so
	scripts can write data to the database via the record object.

2010-02-27  Murray Cumming  <murrayc@murrayc.com>

  Increase required version of libgdamm.

	* configure.ac: Increase libgdamm dependency to the last one that doesn't
	need libgda 4.1/4.2. We actually need some API that was not in the older one.

2010-02-27  Murray Cumming  <murrayc@murrayc.com>

  Revert use of SqlBuilder because it requires libgda 4.1,
  which will not be packaged by the upcoming Ubuntu Lucid, which is an
  important version of an important distro.

2010-02-27  Murray Cumming  <murrayc@murrayc.com>

	More uses of SqlBuilder for SELECT statements.

2010-02-27  Murray Cumming  <murrayc@murrayc.com>

  Fix runtime problems with the use of SqlBuilder.

	* glom/base_db.[h|cc]: query_execute_select(), query_execute(): Catch more
  errors and output better debug and error text.
	get_database_preferences(): Don't bother catching exceptions already caught
	by query_execute*().
	add_standard_tables(): Fix a typo in the SQL query.
	insert_example_data(): Work around an inability in GdaSqlBuilder to INSERT
	a NULL value. I have asked about it on the mailing list.

2010-02-26  Murray Cumming  <murrayc@murrayc-desktop>

	Use Gnome::Gda::SqlBuilder

	* glom/base_db.[h|cc]: query_execute_select(), query_execute(),
	auto_increment_insert_first_if_necessary(),
	recalculate_next_auto_increment_value(),
	get_next_auto_increment_value(), get_database_preferences(),
	add_standard_table(), set_database_preferences(), insert_example_data(),
	set_field_value_in_database():
	Use Gnome::Gda::SqlBuilder to simplify query building and to make it
	safer.
	Most of this work was actually by Johannes Schmid for Openismus.

2010-02-26  Murray Cumming  <murrayc@murrayc.com>

	Fixed the tests build.

	* tests/test_python_execute_func.cc:
	* tests/test_python_execute_func_date.cc: Updated for the
	extra parameters for glom_evaluate_python_function_implementation().

2010-02-25  Murray Cumming  <murrayc@murrayc.com>

	Python functions: Allow setting of values in the record via [].

	* glom/python_embed/python_module/py_glom_module.cc: Specify a setitem(),
	so python code can use [] syntax to set the record's field values as
	well as getting them.
	* glom/libglom/python_embed/py_glom_record.[h|cc]:
	PyGlomRecord_SetFields(): Take and store the primary key details and value,
	and use it in setitem() to UPDATE the value in the database.
	* glom/python_embed/glom_python.[h|cc]:
	glom_execute_python_function_implementation(),
	glom_evaluate_python_function_implementation():
	Take the primary key field and value.
	* glom/base_db.cc:
	* glom/base_db_table_data.cc:
	* glom/mode_data/box_data.cc:
	* glom/mode_design/fields/dialog_fieldcalculation.cc:
	* glom/mode_design/layout/layout_item_dialogs/dialog_buttonscript.cc:
	Adapted.

2010-02-22  Murray Cumming  <murrayc@murrayc.com>

	Avoid showing %20 in the window title.

	* glom/libglom/document/bakery/document.cc: get_name():
	Use Gio::FileInfo::get_display_name() instead of
	Glib::filename_display_basename() or Glib::filename_display_name(), to avoid
	showing %20 in the window title bar when there are spaces in the file name.
	Noticed by Daniel Borgmann.

1.13.5:

2010-02-08  Peter Penz <ppenz@openismus.com>

	libglom: Fix build issue for Maemo.

	* glom/libglom/data_structure/glomconversions.cc: get_text_for_gda_value():
	Add an ifdef for the disabled-exceptions build.


2010-02-22  Murray Cumming  <murrayc@murrayc.com>

	Python functions: Fix regression since the switch to boost::python.

	* glom/python_embed/python_module/py_glom_module.cc: PyRelatedRecord:
	Fix a typo on the getitem() and len() declarations so we can really
	get a related record.

2010-02-22  Murray Cumming  <murrayc@murrayc.com>

	Python functions: Avoid a crash.

	* glom/python_embed/glom_python.cc:
	glom_evaluate_python_function_implementation(): When calling the
	function object, catch exceptions instead of crashing.

2010-02-12  Murray Cumming  <murrayc@murrayc.com>

	Glom Python: Minor code improvement.

	* glom/python_embed/glom_python.cc: glom_evaluate_python_function_implemention():
	Use the extra brackets trick to have boost::python::object and handle
	on one line, so I have to care less about handle<>.

2010-02-12  Murray Cumming  <murrayc@murrayc.com>

	Disable broken import tests.

	* Makefile_tests.am: Comment out the use of the import tests during
	make check. They hang most of the time, which is just stopping distcheck
	from working. We need to fix these (and or the importing itself).
	Then we can reenable them.

2010-02-11  Murray Cumming  <murrayc@murrayc.com>

	libglom/python_embed/: get_item(): Pass object by const reference.

	* glom/libglom/python_embed/py_glom_record.[h|cc]:
	* glom/libglom/python_embed/py_glom_related.[h|cc]:
	* glom/libglom/python_embed/py_glom_relatedrecord.[h|cc:
	getitem(): Pass the object by const &.

1.13.4:

2010-02-11  Murray Cumming  <murrayc@murrayc.com>

	Rename boost::python m4 macro.

	* configure.ac:
	* macros/ax_boost_python.m4: Rename to ax_boost_python_macro.m4 and
	rename the defined m4 macro, to avoid confusion with the cleaner (but
	not working) original.

2010-02-11  Murray Cumming  <murrayc@murrayc.com>

	Fix the build, due to file not added to git.

	* glom/libglom/python_embed/pygdavalue_conversions.cc: Added missing
	file to git.

2010-02-11  Murray Cumming  <murrayc@murrayc.com>

	Fixes for the boost::python configure checks.

	* configure.ac: AC_SUBST(PYTHON_CPPFLAGS) so our python checks can
	use it.
	* macros/ax_boost_python.m4: Use the previously-discovered python
	CPPFLAGS and LIBS so our checks really work.

2010-02-10  Murray Cumming  <murrayc@murrayc.com>

	Use boost::python instead of the Python C API, simplifying the code.

	* configure.ac: Check for boost::python.
	* Makefile.am:
	* Makefile_glom.am: Use boost::python CFLAGS and LIBS.
	* macros/ax_boost_python.m4: Added this macro from
	http://www.nongnu.org/autoconf-archive/ax_boost_python.html
	and hacked it to make it actually work.

	* glom/python_embed/glom_python.cc: Use BOOST_PYTHON_MODULE() instead
	of the obscure Python C API structs and fields that were here and in
	the other .cc files.
	* glom/main.cc:
	* glom/libglom/python_embed/py_glom_record.[h|cc]
	* glom/libglom/python_embed/py_glom_related.[h|cc]
	* glom/libglom/python_embed/py_glom_relatedrecord.[h|cc]
	* glom/python_embed/python_module/py_glom_module.[h|cc]:
	* tests/test_python_execute_func.cc:
	Use boost::python, for instance via boost::python::object, to
	simplify memory management.

	* Makefile_libglom.am:
	* glom/libglom/python_embed/pygdavalue_conversions.[h|c]:
	Change this to a .cc file, using C++, using boost::python.

2010-02-08  Peter Penz <ppenz@openismus.com>

	libglom: Fix build issue for Maemo.

	* glom/libglom/data_structure/glomconversions.cc: get_text_for_gda_value():
	Add an ifdef for the disabled-exceptions build.

1.13.3:

2010-02-03  Michael Hasselmann  <michaelh@openismus.com>

	Fixed a crash that got uncovered by the previous commit

	* glom/libglom/utils.cc (build_sql_select_fields_to_get): Warn about layout
	items that are null and skip them.

2010-02-03  Michael Hasselmann  <michaelh@openismus.com>

	Added a guard clause when adding relationships from fields

	* glom/libglom/utils.cc (add_to_relationships_list): If an invalid layout item
	is passed then its relationship cannot be queried. Libglom users can also force
	layout item fields that are null into this function, hence an additional guard
	clause was added.

2010-02-02  Murray Cumming  <murrayc@murrayc.com>

	Do not include pygtk.h

	* glom/libglom/python_embed/py_glom_record.h:
	* glom/libglom/python_embed/py_glom_relatedrecord.h:
	* glom/python_embed/glom_python.cc: Include pygobject.h instead of
	pygtk/pygtk.h, because we do not use anything from pygtk, or link to it.

2010-01-31  Murray Cumming  <murrayc@murrayc.com>

	Command-line parsing: Added some checks.

	* glom/main.cc: Test the command-line argument filepath for existence and
	check that it's not a directory, so it fails before even showing UI.

2010-01-31  Murray Cumming  <murrayc@murrayc.com>

	Relationships Overview: Avoid GTK+ warnings.

	* glom/mode_design/relationships_overview/dialog_relationships_overview.cc:
	Constructor: Call add_accel_group(), which fixes the warnings during
	destruction mentioned in bug #607938.

2010-01-31  Murray Cumming  <murrayc@murrayc.com>

	Relationships Overview: Maybe fix a hang/crash.

	* glom/mode_design/relationships_overview/dialog_relationships_overview.[h|cc]:
	Signal handlers: Take sigc::bind() RefPtr parameters by value instead of by
	const &, to avoid having to use sigc::ref() or worry if it works.
	Save sigc::connections in a list so we can disconnect signal handlers when
	deleting items bound with sigc::bind(). Do this in the destructor too, which
	seems to fix the valgrind errors in bug #594737, though not the
	instance of invalid non-instantiatable type" warning.

2010-01-27  Michael Hasselmann  <michaelh@openismus.com>

	Fixed the parser to perform stateless async file operations

	* glom/import_csv/csv_parser.[h|cc]: The parser relied on a member variable for
	its async giomm operations, which was able to cause interleaving state
	changes to it, corrupting the object in the worst case. This commit uses the
	source object as a slot parameter to avoid this state problem (working around
	BGO bug #608269).

	* tests/import/utils.[h|cc]: During import tests, break mainloop on file
	read errors (e.g., no file at all).

2010-01-27  Michael Hasselmann  <michaelh@openismus.com>

	Added a test for BGO bug #607938

	* tests/import/data/albums.csv: Real-world example data used for the CSV
	import.

	* tests/import/utils.[h|cc]: Add the possibility to feed a filename into the
	ImportTest directly.

	* tests/import/test_parsing.cc: Test the CSV import of a whole file.

2010-01-27  Michael Hasselmann  <michaelh@openismus.com>

	Added a g_return_if_fail check for invalid URLs

	* glom/import_csv/csv_parser.cc: Do not start the async reading if the file
	object is invalid.

2010-01-27  Murray Cumming  <murrayc@murrayc.com>

	Use Gtk::ToolPalette from the latest gtkmm version, instead of
	EggToolPalette (C) from libegg.

2010-01-26  Murray Cumming  <murrayc@murrayc.com>

	libglom: Correct includes.

	* glom/libglom/*.h: Use the full include libglom/ path for headers, to
	avoid confusion and make life easier for other users of libglom.

2010-01-25  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/numeric_format.h: Remove unnecessary
	include of privileges.h.

2010-01-25  Murray Cumming  <murrayc@murrayc.com>

	Allow new files to have quotes in their titles.

	* glom/frame_glom.cc:
	connection_request_password_and_choose_new_database_name():
	Remove quotes (and other unusual characters) from the generated
	database name, to avoid errors from the database backend.
	Bug #607957 (Michael Hasselmann)

2010-01-24  Michael Hasselmann  <michael@taschenorakel.de>

	Fixed out-ouf-bounds access during CSV imports

	* glom/import_csv/dialog_import_csv.cc (get_field_for_column): Added boundary
	check for direct field access. Fixes bug #607938.

2010-01-24  Murray Cumming  <murrayc@murrayc.com>

	* ldtp/central-info.xml.example: Added an example central-info.xml, as
	mentioned in the README.

1.13.2:

2010-01-24  Murray Cumming  <murrayc@murrayc.com>

	Details: Buttons: Use horizontal aligment from formatting.

	* glom/mode_data/flowtablewithfields.cc: add_button_at_position():
	Use a Gtk::HBox with either pack_start() or pack_end(), putting it in the
	FlowTable with expand=true to have alignment in the button's space, if we
	don't want the FlowTable's default (left) alignment.

2010-01-24  Murray Cumming  <murrayc@murrayc.com>

	Details: Static Text items: Use horizontal alignment from formatting.

	* glom/utility_widgets/labelglom.[h|cc]: Add a constructor that does not
	take alignment values, like the Gtk::Label base class, so we can easily
	use the default for vertical alignment.
	* glom/mode_data/flowtablewithfields.cc: add_textobject_at_position():
	Use expand=true when adding the widget to the FlowTable, so that labels can
	have the full space in which to actually have alignment.
	* glom/utility_widgets/layoutwidgetbase.cc: apply_formatting: Use appropriate
	multi-line justification for labels, as a user would expect when setting
	horizontal alignment.

2010-01-23  Murray Cumming  <murrayc@murrayc.com>

	Details: Buttons: Use background color from formatting.

	* glom/mode_data/flowtablewithfields.cc: add_button_at_position(): Call
	apply_formatting on the button, not the label, so it has a chance to do the
	right thing on the right widget.

2010-01-23  Murray Cumming  <murrayc@murrayc.com>

	Details: Static Text items: Use background color from formatting.

	* glom/utility_widgets/labelglom.cc: Do not call set_visible_window(false)
	because we really need a visible child X window to be able to change the
	background color.

2010-01-23  Murray Cumming  <murrayc@murrayc.com>

	Details: Static Text items and Buttons: Use foreground color from formatting.

	* glom/utility_widgets/layoutwidgetbase.cc: apply_formatting(): Use the
	foreground color for labels (static text items and buttons).

2010-01-22  Murray Cumming  <murrayc@murrayc.com>

	Details: Static Text items: Use formatting.

	* glom/utility_widgets/labelglom.[h|cc]: Added get_label(), because this
	really has a label as a child.
	* glom/utility_widgets/layoutwidgetbase.cc: apply_formatting(): Use get_label()
	to make formatting work on static text items too.

2.13.1:

2010-01-22  Murray Cumming  <murrayc@murrayc.com>

	Fixed compiler warnings.

	* glom/libglom/data_structure/layout/layoutitem_field.cc:
	get_formatting_used_horizontal_alignment():
	* glom/print_layout/canvas_layout_item.cc: apply_formatting(): Fixed
	compiler warnings.

2010-01-22  Murray Cumming  <murrayc@murrayc.com>

	Make libglom-1.14 install in parallel with libglom-1.12.

	* glom/libglom/glom-1.12.pc.in: Rename to glom-1.14.pc.in
	* configure.ac: Change the libglom ABI version variable and specify the
	changed .pc.in file.
	* Makefile.am, Makefile_libglom.am: Adapt.
	* glom/python_embed/python_module/py_glom_module.[h|cc]: Mention
	2.14 instead of 2.14.
	* tests/test_load_python_library.cc: Adapt.

	* glom/libglom/document/document.cc:
	get_latest_known_document_format_version(): Increment.

2010-01-22  Murray Cumming  <murrayc@murrayc.com>

	Really use formatting for multi-line fields.

	* glom/utility_widgets/textviewglom.[h|cc]: Added get_textview().
	* glom/utility_widgets/layoutwidgetbase.cc: apply_formatting():
	Get the appropriate child for buttons and textviews, making this work
	for textviews (multi line fields), but it still does not work for
	labels (static text items) and buttons.

2010-01-22  Murray Cumming  <murrayc@murrayc.com>

	Allow custom text formatting of Buttons as well as text items and fields.

	* glom/libglom/data_structure/layout/layoutitem_button.[h|cc]:
	Derive from LayoutItem_WithFormatting.
	* glom/libglom/document/document.[h|cc]: Make loading/saving of
	formatting generic so we get it for free whenever a new class
	derives from LayoutItem_WithFormatting.
	* glom/mode_data/flowtablewithfields.cc:
	on_dnd_add_layout_item_button(): Try to apply the formatting to
	the button's label, though it doesn't seem to work.

2010-01-22  Murray Cumming  <murrayc@murrayc.com>

	Allow editing of formatting for static text items.

	* glom/mode_design/layout/layout_item_dialogs/dialog_formatting.[h|cc]:
	Added generic formatting (not choices, not default/custom) dialog
	for static text items and maybe others.
	* glom/mode_design/layout/layout_item_dialogs/box_formatting.[h|cc]:
	set_formatting(): Add optional bool paramters to hide numeric formatting
	and choices.
	* glom/base_db.[h|cc]: Added offer_item_formatting() to use this dialog.
	* glom/mode_design/layout/dialog_layout_details.cc(): Allow editing of
	the formatting for static text items instead of just fields.

	* glom/utility_widgets/db_adddel/db_adddel.cc:
	construct_specified_columns_cellrenderer(): Apply the formatting to
	any LayoutItem_WithFormatting, not just fields.
	* glom/mode_data/flowtablewithfields.cc: add_textobject_at_position():
	Try to apply the formatting to the label, but it doesn't seem to work.

2010-01-22  Murray Cumming  <murrayc@murrayc.com>

	Add LayoutItem_WithFormatting as a Field/StaticText common base class.

	* glom/libglom/data_structure/layout/layoutitem_withformatting.[h|cc]:
	Added LayoutItem_WithFormatting.
	* glom/libglom/data_structure/layout/layoutitem_text.[h|cc]:
	* glom/libglom/data_structure/layout/layoutitem_field.[h|cc]:
	Derive from Layout_WithFormatting, so we can use the base class
	polymorphically, making it easier to support formatting for static text
	items.
	* glom/utility_widgets/layoutwidgetbase.[h|cc]: apply_formatting(),
	* glom/print_layout/canvas_layout_item.[h|cc]: apply_formatting():
	Make this generic for LayoutItem_WithFormatting.

2010-01-22  Murray Cumming  <murrayc@murrayc.com>

	Show the alternative colors for negatives in fields with choices too.

	* glom/utility_widgets/comboentryglom.cc: set_value():
	* glom/utility_widgets/comboglom.cc: set_value(): Use the alternative
	negative color feature here too.

2010-01-21  Murray Cumming  <murrayc@murrayc.com>

	Field Formatting: Text Formatting: Add horizontal alignment option.

	* glom/libglom/data_structure/layout/fieldformatting.[h|cc]:
	Added get/set_horizontal_alignment().
	* glom/libglom/data_structure/layout/layoutitem_field.[h|cc]:
	Added get_formatting_used_horizontal_alignment() to interpret the
	AUTO alignment depending on the fields details.
	* glom/libglom/document/document.cc:
	load_after_layout_item_formatting(), save_before_layout_item_formatting():
	load/save the new setting.

	* glom/glom_developer.glade: window_formatting: Added the alignment combo.
	* glom/mode_design/layout/layout_item_dialogs/box_formatting.[h|cc]:
	Show/Save the alignment.
	* glom/utility_widgets/db_adddel/db_adddel.cc: apply_formatting():
	* glom/utility_widgets/entryglom.cc: set_layout_item():
	* glom/utility_widgets/comboentryglom.cc: set_layout_item():
	Set xalign from get_formatting_used_horizontal_alignment().

2010-01-16  Murray Cumming  <murrayc@murrayc.com>

	Field Formatting: Negative values color: Make this just a bool check box.

	* glom/libglom/data_structure/numeric_format.[h|cc]: Use just a bool
	to say if negative values should be shown in an alternative color.
	Add static get_alternative_color_for_negatives() to get that color.
 	* glom/libglom/data_structure/layout/fieldformatting.cc:
 	get_text_format_color_foreground_to_use(): Updated the implementation.
 	* glom/libglom/document/document.cc:
	load_after_layout_item_formatting(), save_before_layout_item_formatting():
	Updated.

	* glom/glom_developer.glade: window_formatting: Show only a checkbox, not
	a color too, for the alternative color for negatives.
	* glom/mode_design/layout/layout_item_dialogs/box_formatting.[h|cc]:
	Updated.

2010-01-15  Michael Hasselmann  <michaelh@openismus.com>

	Add forgotten header to libglom's Makefile

	* Makefile_libglom.am: libglom_include_HEADERS forgot to mention utils.h
	although it was mentioned in the *_la_SOURCES.


2010-01-15  Michael Hasselmann  <michaelh@openismus.com>

	Updated the comment for NumericFormat's default precision

	* glom/libglom/data_structure/numeric_format.h (get_default_precision): The
	precision applies to the decimal places only, not the whole number. Comment
	updated.

2010-01-15  Murray Cumming  <murrayc@murrayc.com>

	Field Formatting: Allow an alternative color for negative values.

	* glom/libglom/data_structure/numeric_format.[h|cc]:
	Added m_foreground_color_for_negatives.
	* glom/libglom/data_structure/layout/fieldformatting.[h|cc]:
	Added get_text_format_color_foreground_to_use().
	* glom/libglom/document/document.cc:
	load_after_layout_item_formatting(), save_before_layout_item_formatting():
	load/save the new setting.

	* glom/glom_developer.glade: window_formatting: Added negatives color
	and checkbox to the numeric formatting tab.
	* glom/mode_design/layout/layout_item_dialogs/box_formatting.[h|cc]:
	Show/Save the color.
	* glom/utility_widgets/db_adddel/db_adddel.cc:
	treeviewcolumn_on_cell_data()_
	* glom/utility_widgets/entryglom.cc: set_value():
	Use the color for negatives if appropriate.
	* glom/print_layout/canvas_layout_item.cc: Add a TODO to use it here too.

1.12.5 (stable):

2010-01-20  Murray Cumming  <murrayc@murrayc.com>

	Fix a crash in previous commit.

	* glom/utility_widgets/db_adddel/db_adddel.cc: get_fixed_cell_height():
	Fixed a null-pointer crash when also checking LayoutItem_Text items,
	though the UI doesn't actually allow the font to be specified for them
	yet.

2010-01-20  Murray Cumming  <murrayc@murrayc.com>

	List View: Don't chop off the bottom of text when using large fonts.

	* glom/utility_widgets/db_adddel/db_adddel.cc: get_fixed_cell_height():
	Use the font description from the FieldFormatting, to get a more
	suitable max height for all columns.
	remove_all_columns(): Set m_fixed_cell_height back to 0 so it
	will be recalculated for the new columns.
	Fixes bug #607023 (Michael Hasselmann)

2010-01-14  Murray Cumming  <murrayc@murrayc.com>

	libglom: Some API documentation.

	* glom/libglom/data_structure/layout/layoutitem_field.h:
	* glom/libglom/data_structure/layout/usesrelationship.h:
	Added doxygen comments at request of Michael Hasselmann.

2010-01-14  Murray Cumming  <murrayc@murrayc.com>

	Rename get_stringstream_precision_default().

	* glom/libglom/data_structure/glomconversions.[h|cc]:
	get_stringstream_precision_default(): Rename this to the slighly-better
	named (because it's not mentioning implementation)
	NumericFormat::get_default_precision() in
	* glom/libglom/data_structure/numeric_format.[h|cc]: and document it
	vaguely.

2010-01-14 Michael Hasselmann <michaelh@openismus.com>

	Make the default precision used for stringstreams available for libglom users

	* glom/libglom/data_structure/glomconversions.[h|cc]
	(get_stringstream_precision_default): Wrap the constant used into a function
	and export it in the headers. Users of libglom need it to show the same
	precision for Glom's numeric type.

2010-01-14  Murray Cumming  <murrayc@murrayc.com>

	Minor simplification.

	* glom/libglom/data_structure/glomconversions.cc:
	get_stringstream_precision_default(): Simplify this function, for
	Michael to see.

2010-01-14  Michael Hasselmann  <michaelh@openismus.com>

	Make the default precision used for stringstreams available for libglom users

	* glom/libglom/data_structure/glomconversions.[h|cc]
	(get_stringstream_precision_default): Wrap the constant used into a function
	and export it in the headers. Users of libglom need it to show the same
	precision for Glom's numeric type.


2010-01-12  Murray Cumming  <murrayc@murrayc.com>

	Music Collection Example: Changed a layout.

	* examples/example_music_collection.glom: Albums: List View:
	Add some related records to show a problem in Qlom.

2010-01-08  Murray Cumming  <murrayc@murrayc.com>

	Correct use of locales when creating text representations.

	* glom/main.cc:  Set std::locale::global() to the user's current locale,
        forcing us to imbue streams to whatever we actually want.
	* glom/libglom/connectionpool_backends/postgres_self.cc: startup():
	Do not use Utils::string_from_decimal() for the port number, because it
	is meant to use the user's locale, but we need it in the C locale.
	* glom/libglom/data_structure/field.cc: to_file_format(): Use
	std::locale::classic() when we want the C locale, not std::locale(),
	which means the user's locale, which was previously the C one by chance.
	* glom/libglom/utils.cc: string_from_decimal(): Imbue the stream
	as wanted.

2010-01-07  Michael Hasselmann  <michaelh@openismus.com>

	Fix potential encoding error for currency symbols

	* glom/libglom/data_structure/glomconversions.cc (get_text_for_gda_value):
	Glom's numeric type can be prefixed with a currency symbol. If the symbol
	cannot be represented in the user's locale it would hide all data for the
	column. This is fixed by using a fallback conversion for the symbol.
	Fixes bug #606349.

2010-01-07  Armin Burgmeier  <armin@arbur.net>

	* win32/build-installer:
	* win32/glom.iss.in: Install glom_1_12.pyd instead of glom.pyd. Bug
	#605593.

1.12.4:

2009-12-30  Murray Cumming  <murrayc@murrayc.com>

  Dnd layout: Avoid a crash when dragging to empty space.

	* glom/utility_widgets/flowtable_dnd.cc: on_drag_data_received():
	Avoid dereferencing a null group.
	Bug #599232

2009-12-30  Murray Cumming  <murrayc@murrayc.com>

	Dnd layout: Avoid a crash.

	* glom/utility_widgets/flowtable_dnd.cc: on_drag_data_received():
	Use a dynamic_cast<> to avoid memory corruption with the MI class.
	Bug #599232

2009-12-16  Armin Burgmeier  <armin@arbur.net>

	* win32/build-installer:
	* win32/glom.iss.in: Add missing libpangoft2-1.0-0.dll. Bug #599966.

2009-12-14  Murray Cumming  <murrayc@murrayc.com>

	* glom.desktop.in.in: Remove the Application category because
	krazy2 says it is deprecated.

2009-12-10  Murray Cumming  <murrayc@murrayc.com>

	FlowTableDnd: Some refactoring.

	* glom/utility_widgets/flowtable_dnd.[h|cc],
	* glom/mode_data/flowtable_withfields.[h|cc]: Make FlowTableDnd less
	aware of LayoutItems, though it is still not yet generic enough.
	* glom/utility_widgets/test_flowtable_dnd.cc:
	* glom/Makefile_tests.am: Added test_flowtable_dnd.

2009-12-10  Murray Cumming  <murrayc@murrayc.com>

	* examples/example_film_manager.glom: Added silly example data,
	fixing bug #600859 (Michael Hasselmann)

2009-12-10  Murray Cumming  <murrayc@murrayc.com>

	Tests: Validate all examples against the DTD, and correct the DTD.

	* tests/dtd/test_example_sqlite: Renamed to test_file_validation.sh.
	* glom/Makefile_tests.am: Adapted.
	* glom/libglom/document/document.cc: save_before(): Correct the saving
	of group privileges so they are really inside the group nodes. Avoid
	saving unnamed groups, as seen in the example files.
	* glom/glom_document.dtd: Several corrections to fix the validation of
	the example files, though I don't like that DTDs don't seem to give
	us any way to say that the sequence of child elements is irrelevant.
	I don't like enforcing the sequence.

2009-12-10  Murray Cumming  <murrayc@murrayc.com>

	Fix distcheck.

	* Makefile.am:
	* Makefile_tests.am: Fix the distcheck by disting the DTD validation
	test script and the .glom file that it uses.
	* glom/libglom/init.cc: Redefine Python's PyDateTime_IMPORT macro,
	to avoid a compiler warning. See http://bugs.python.org/issue7463
	* glom/main.cc: Avoid including Python's datetime.h, to avoid the same
	compiler warning.

2009-12-09  Murray Cumming  <murrayc@murrayc-desktop>

	Tests: Complete the test_python_execute_func_date test.

	* glom/libglom/python_embed/pygdavalue_conversions.c
	(glom_pygda_value_from_pyobject): Use g_date_new_dmy() so the GDate
	is really completely initialized, avoiding errors about invalid dates.
	* tests/test_python_execute_func_date.cc: Check the return type and
	value, by comparing the python result with the current date.
	Bug is now really fixed #603686. (Andrew Ruthven)

2009-12-09  Murray Cumming  <murrayc@murrayc.com>

	Fix the crash when calling python functions that return dates.

	* glom/libglom/python_embed/pygdavalue_conversions.c
	(glom_pygda_value_from_pyobject): Call the macro PyDateTime_IMPORT here,
	though it was already called in libglom_init(). I don't know why this
	fixes the crash, but it does. Bug #603686. (Andrew Ruthven)

2009-12-08  Murray Cumming  <murrayc@murrayc.com>

	Tests: Added glom_evaluate_python_function_implementation() tests.

	* Makefile_tests.am:
	* tests/test_python_execute_func.cc:
	* tests/test_python_execute_func_date.cc: Added two unit tests for
	Glom::glom_evaluate_python_function_implementation(). The date one
	currently fails, as in bug #603686. (Andrew Ruthven)

2009-12-07  Murray Cumming  <murrayc@murrayc.com>

	Python: Trying to stop the PyDateTime_Check() crash.

	* glom/libglom/init.cc: libglom_init(): Call the PyDateTime_IMPORT
	macro, which is needed to stop PyDateTime_Check() and PyDate_Check()
	from crashing, at least in my simple test case. It still crashes in
	Glom though.
	* glom/main.cc: Do not initialize Python here because Glom::init()
	already did it, though doing it twice does not seem to be a problem.

2009-12-04  Murray Cumming  <murrayc@murrayc-desktop>

	Rename some functions to avoid fear of linking to the wrong one.

	* glom/libglom/python_embed/pygdavalue_conversions.[h|cc]:
	pygda_value_from_pyobject(), pygda_value_as_pyobject(): Add a glom_
	prefix so we know we are not using the copy in pygda.
	* glom/python_embed/glom_python.cc:
	* glom/libglom/python_embed/py_glom_record.cc:
	* glom/libglom/python_embed/py_glom_relatedrecord.cc: Adapted.

2009-12-04  Murray Cumming  <murrayc@murrayc.com>

	Field Definitions: Default value: Fix crash when selecting a date.

	* glom/utility_widgets/datawidget.cc: offer_field_list(),
	offer_field_layout(), offer_related_record_id_find(): Avoid crashes
	caused by calling set_transient_for() with a null parent window,
	for instance from the field definitions dialog.

2009-12-04  Murray Cumming  <murrayc@murrayc.com>

	Field Definitions: Show default value widget for date fields.

	* glom/utility_widgets/datawidget.cc: Constructor: show the
	hbox_parent widget, so the widgets always show up for the default value
	in the field definitio dialog for date fields. The details view must
	be doing this via a show_all() somewhere.

2009-12-03  Murray Cumming  <murrayc@murrayc.com>

	Related Records layout: Field formatting: Choices: Fix related choices.

	* glom/mode_design/layout/dialog_layout_details.[h|cc]
	* glom/mode_design/layout/dialog_layout_list_related.[h|cc]:
	Add virtual get_fields_table() and use this in
	on_button_field_formatting() so that the formatting dialog shows
	relationships for the to table instead of the parent table, when
	editing formatting for a field in a related records portal.
	Bug noticed by Michael Hasselmann and Andrew Ruthven.
	* glom/mode_design/layout/layout_item_dialogs/dialog_field_layout.c:
	Removed some debug output.

2009-12-03  Murray Cumming  <murrayc@murrayc.com>

	Allow use of example documents that mention an unsupported backend.

	* glom/application.cc: check_document_hosting_mode_is_supported():
	Don't check the backend if it is an example document because the user
	will choose it when saving anyway.

2009-11-17  Murray Cumming  <murrayc@murrayc.com>

	tests: dtd: Now passes.

	* glom/libglom/document/bakery/document_xml.cc: get_node_document():
	Added commented-out code to write the DOCTYPE declaration, if we ever
	want to specify the PUBLIC DTD idenitifier and URI in each document.
	Let's avoid that for now because we'd have to make sure that it's
	hosted properly.
	* tests/dtd/test_example_sqlite: Do not use --valid because that
	seems to always require a DTD in the document's DOCTYPE declaration.
	--dtdvalid seems to do the same thing already, but with the specified
	DTD.

2009-11-17  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom_document.dtd: Mention the xmlns attribute because DTD
	validation doesn't know about XML namespaces.

2009-11-17  Murray Cumming  <murrayc@murrayc.com>

	Document: Ensure that the xmlns ID is always in saved documents.

	* glom/libglom/document/bakery/document_xml.cc: get_node_document():
	Make sure that the xmlns ID is added, even when the root node already
	exists, for instance when opening existing documents.

	* examples/example_film_manager.glom:
	* examples/example_lesson_planner.glom:
	* examples/example_music_collection.glom:
	* examples/example_project_manager.glom:
	* examples/example_smallbusiness.glom:
	* examples/sqlite/test_sqlite_music/test_sqlite_music.glom:
	Add the xmnls ID, to help to identify the MIME type of these documents.

2009-11-17  Murray Cumming  <murrayc@murrayc.com>

	Document saving: Remove unncessary empty singular_title nodes.

	* glom/libglom/document/document.cc: save_before_translations():
	Do not create empty singular_title nodes.
	* examples/example_smallbusiness.glom: Resaved.

2009-11-17  Murray Cumming  <murrayc@murrayc.com>

	Partly fix the DTD validation test.

	* glom/glom_document.dtd: table: Correct the syntax for the child
	elements, to use ?, instead of | because they are all optional, instead
	of being alternatives for each other.
	Add the print_layouts element.
	* Makefile_tests.am: Change the order so the sometimes-hanging import
	tests are at the end, to make the tests more useful.

2009-11-13  David King  <davidk@openismus.com>

	* configure.ac: Fix check for SQLite and libgettextpo.

2009-11-12  David King  <davidk@openismus.com>

	* glom/glom_document.dtd: Update to more completely validate example
	documents.
	* Makefile_tests.am:
	* tests/dtd/test_example_sqlite: Add a test that attempts to validate
	an example SQLite Glom document against glom_document.dtd.

2009-11-10  David King  <davidk@openismus.com>

	* configure.ac: Fix incorrect conditional for Maemo libgettextpo check.

2009-11-06  Murray Cumming  <murrayc@murrayc.com>

	Fix a crash when specifying a static image on the layout.

	* glom/utility_widgets/imageglom.cc: on_menupopup_activate_select_file():
	Check for a null parent window pointer to avoid a crash, fixing bug
	#600954 (Michael Hasselmann).

2009-11-06  David King  <davidk@openismus.com>

	* configure.ac:
	* Makefile_glom.am: Do not link to libgettextpo on Maemo, and
	additionally do not check for it either.

2009-11-04  David King  <davidk@openismus.com>

	* glom.xml: Add Maemo-specific category for classification of .glom
	files as "documents".

2009-11-04  David King  <davidk@openismus.com>

	* Makefile_glom.am: Statically link to libgettextpo on Maemo, as
	Gettext is available in the SDK and autobuilder but not on the device.

1.12.3:

2009-10-30  Murray Cumming  <murrayc@murrayc.com>

	List views and related records portals: Enough space for titles.

	* glom/utils_ui.[h|cc]: get_suitable_field_width_for_widget():
	Optionally calculate enough space for the title too, for TreeView
	columns.
	* glom/utility_widgets/db_adddel/db_adddel.cc: treeview_append_column():
	When choosing a default column width, make sure there's enough for the
	title too.

2009-10-30  Murray Cumming  <murrayc@murrayc.com>

	List views and related records portals: Avoid zero-width columns.

	* glom/utility_widgets/db_adddel/db_adddel.cc: treeview_append_column():
	Except on maemo, don't try to auto-expand a non-rightmost column,
	because that does not seem to be possible with fixed-height-mode,
	which we use for performance.

2009-10-30  David King  <davidk@openismus.com>

	* configure.ac:
	* glom/main.cc: Initialize libossomm on Maemo, to register a DBus
	service.

2009-10-28  David King  <davidk@openismus.com>

	* configure.ac:
	* Makefile.am:
	* glom.desktop.in.in:
	* glom.service.in: Add DBus service file for Maemo 5, and install to
	the correct location as determined by the osso-af-settings pkg-config
	file. Adjust the installation location of the glom.desktop file on
	Maemo.

2009-10-28  Murray Cumming  <murrayc@murrayc.com>

	Do not mark an empty string for translation.

	* glom/dialog_connection.cc: set_confirm_existing_user_note():
	Do not do _(""), fixing bug #599868 (André Klapper).

2009-10-27  Murray Cumming  <murrayc@murrayc.com>

	Trying to ignore unwanted column resize signals.

	* glom/utility_widgets/db_adddel/db_adddel.[h|cc]:
	Removed unused set_column_width().
	construct_specified_columns_cellrenderer(): Added an InnerIgnore, though
	we already use one in construct_specified_columns().
	on_treeview_column_resized(): Check if we should ignore signals.
	Do not cast an int size to a guint, because it could be -1.

2009-10-27  Murray Cumming  <murrayc@murrayc.com>

	Avoid runtime warnings about 0 size TreeViewColumn.

	* glom/utility_widgets/db_adddel/db_adddel.cc: construct_specified_columns(),
	treeview_append_column(): Avoid calling TreeViewColumn::set_fixed_width()
	with a 0 size, avoiding a runtime assertion.

2009-10-27  Murray Cumming  <murrayc@murrayc.com>

	Fix some warnings.

	* glom/dialog_existing_or_new.cc: get_service_info(): Replace a 0 with
	(void*)0 to avoid a warning after my change on 2009-10-13.
	* glom/libglom/data_structure/has_title_singular.cc():
	operator==(): Actually use the src parameter.

2009-10-27  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/db_adddel/db_adddel.cc: treeview_append_column():
	Don't try to put -1 in a guint for the column width.

2009-10-25  Murray Cumming  <murrayc@murrayc.com>

	BaseDb::query_execute*(): Const corrections.

	* glom/base_db.[h|cc]: query_execute(), query_execute_select():
	Const corrections and indentation corrections.

2009-10-21  Armin Burgmeier  <armin@arbur.net>

	* Makefile_libglom.am: Link against winsock on Windows.

	* glom/application.cc (constructor): ifdefed out the avahi callbacks
	setup on Windows.

	* glom/dialog_existing_or_new.cc (constructor): ifdefed out the code
	that expands the network item on Windows (because it doesn't exist
	there).

	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool.cc: ifdefed out the avahi callback setup
	function, moved pgwin32_is_admin to main.cc.

	* glom/main.cc: Moved pgwin32_is_admin from connectionpool.cc.

	* glom/libglom/spawn_with_feedback.cc: Added <glibmm/fileutils.h>
	include, required for the Windows build.

	* glom/mode_design/print_layouts/print_layout_toolbar_button.cc:
	* glom/utility_widgets/layouttoolbar.cc:
	* glom/utility_widgets/layouttoolbarbutton.cc:
	* glom/xsl_utils.cc: Fixed the construction to path files
	relative to the executable on Windows: Glib::build_filename does take
	only two arguments, not three.

	* win32/build-installer:
	* win32/glom.iss.in: Updated.

2009-10-21  Armin Burgmeier  <armin@arbur.net>

	* macros/mm-python.m4: Fix the python library lookup on Windows: Avoid
	a python error if get_config_var('LIBS') is None and include
	$PREFIX/libs and $EXEC_PREFIX/libs in the search path because this is
	where the official Python installer puts the library in.

2009-10-19  David King  <davidk@openismus.com>

	* Makefile_libglom.am: Add missing backslash, fixing commit
	e38fcaab322d4774faae2ecb707cdf67f84dd6ea.

2009-10-19  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Adapt for latest hildonmm changes.

	* glom/utility_widgets/comboentryglom.cc:
	* glom/utility_widgets/comboglom.cc: get/set_active() changed to
	set_selected() and we now have an iter-base get/set_selected() for the
	PickerButton so we don't need to get the TouchSelector.

2009-10-16  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Fix the build for the latest hildonmm.

	* glom/navigation/maemo/pickerbutton_table.cc:
	* glom/utility_widgets/comboentryglom.cc:
	* glom/utility_widgets/comboglom.cc: Adapt to changed (simpler)
	TouchSelector API.

2009-10-16  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Fix my previous commit.

	* glom/utility_widgets/datawidget.cc: set_child_size_by_field(): Move
	the ifdefs around so normal fields get sensible sizes again on Maemo.

2009-10-16  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Make TextViews small to begin with.

	* glom/utility_widgets/datawidget.cc: set_child_size_by_field(): On
	Maemo, do not increase the height of the TextView, even if specified in
	the layout, because HildonTextViews expand automatically on Maemo when
	entering more text.

2009-10-16  Murray Cumming  <murrayc@murrayc.com>

	Maemo: When adding related records, show the foreign key value.

	* glom/mode_data/box_data_portal.cc: on_maemo_appmenubutton_add():
	Actually show the field value that links the new related record to the
	parent record, though this is a bit hacky and will only work for
	autogenerated keys.

2009-10-16  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Actually show new related record in the list.

	* glom/mode_data/box_data_portal.[h|cc]: on_maemo_appmenubutton_add():
	* glom/mode_data/notebook_data.[h|cc]: Constructor:
	Update the window when the maemo details window is hidden, for instance
	to show the new related record in the portal.

2009-10-16  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/document.cc: load_after(), save_before():
	Avoid crashes when load/saving singular_titles.

2009-10-16  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Allow Relationships to have singular titles too. Use them.

	* glom/libglom/data_structure/has_title_singular.[h|cc]: Added this new
	base class, to be inherited by any TranslatableItem that could also have
	a singular form.
	* glom/libglom/data_structure/table_info.[h|cc]:
	* glom/libglom/data_structure/relationship.[h|cc]: Derive
	from HasTitleSingular, instead of just having the methods in TableInfo.
	* glom/libglom/document/document.[h|cc]: Added
	get_table_title_singular() to match the existing get_table_title().
	* glom/mode_data/box_data_portal.[h|cc]: Added get_title_singular() to
	match the existing get_title() and use it in the details window title
	and AppMenu Add Related button.
	* glom/mode_data/notebook_data.cc: Use the singular table title for the
	details window title.

2009-10-15  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Show a new Details window when adding related records.

	* glom/mode_data/box_data_portal.[h|cc]:
	* glom/mode_data/box_data_calendar_related.[h|cc]:
	* glom/mode_data/box_data_list_related.[h|cc]:
	Remove the just-added do_add_record() virtual method.
	Instead add a Box_Data_Details and parent window to Box_Data_Portal,
	used to show a details window for a new related record in
	on_maemo_appmenubutton_add().
	Move some code from Box_Data_List_Related::on_adddel_record_added() to
	Box_Data_Portal::make_record_related() to make this easier.

2009-10-15  Murray Cumming  <murrayc@murrayc.com>

	Developer: Tables: Add singular title.

	* glom/libglom/data_structure/tableinfo.[h|cc]: Add
	get/set_title_singular(), using a member TranslatableItem, to hold
	the singular form (such as Album instead of Albums) for use in the UI
	for users.
	* glom/libglom/document/document.cc: save_before(), load_after():
	Load and save the singular table titles as a new node.
	* glom/glom_document.dtd: Mentin the new node, though I don't think
	we document translation nodes properly.
	* glom/navigation/box_tables.[h|cc]: In developer mode, show the column
	so the user can enter a singular title.

2009-10-15  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Details: Show table title in window title.

	* glom/mode_data/notebook_data.cc: show_details(): On Maemo, mention the
	table title in the window title, though this again shows that we need to
	ask the designer for the singular form for the table's items.

2009-10-15  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Show Add Related buttons when showing portals on details.

	* glom/application.[h|cc]: Removed unused on_menu_add_record().
	* glom/mode_data/box_data_portal.[h|cc]: On Maemo, add a Hildon::Button
	to the application's AppMenu on realize, removing it on unrealize.
	Added a virtual do_add_record() that is called when the button is
	clicked.
	* glom/mode_data/box_data_calendar_related.[h|cc]:
	* glom/mode_data/box_data_list_related.[h|cc]: Added do_add_record()
	overrides, though they are empty so far.

2009-10-13  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Add a Add Record to the App Menu and remove it from the List View.

	* glom/application.cc: init_menus(): Add an Add Record item to the
	AppMenu on Maemo.
	* glom/frame_glom.[h|cc]: Added on_menu_add_record() on Maemo, calling
	Notebook_Data::do_menu_file_add_record().
	* glom/mode_data/box_data_details.[h|cc]: Added do_new_record().
	* glom/mode_data/notebook_data.[h|cc]: Added do_menu_file_add_record()
	to call the Box_Data_Details::do_new_record().
	* glom/utility_widgets/db_adddel/db_adddel.h: Made start_new_record()
	public and documented it.
	* glom/utility_widgets/db_adddel/db_adddel_withbuttons.[h|cc]: Remove
	the Add button on Maemo.

2009-10-13  Murray Cumming  <murrayc@murrayc.com>

	* *.cc: Replace use of NULL with 0, because this is C++.
	Replace use of != NULL with nothing.

2009-10-12  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/db_adddel/db_adddel.cc:
	* glom/utility_widgets/flowtable.h:
	* glom/utility_widgets/flowtable_dnd.cc: Correct non-maemo build
	problems after merging from the maemo5 branch.

2009-10-12  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Details: Put scrollbar against the right edge, as per spec.

	* glom/window_boxholder.[h|cc]: On Maemo, use an Alignment with no
	padding at the right, instead of just a window border, to match the UI
	spec.

2009-10-12  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Details: More correct padding, maybe.

	* glom/utility_widgets/flowtable.[h|cc]: Change set_padding() to
	set_column_padding() and set_row_padding(), allowing different padding
	between rows and between columns, as per Maemo's UI specifications.

2009-10-11  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Use Hildon buttons for Open, Find and ... buttons.

	* glom/utility_widgets/datawidget.cc: Constructor: Use Hildon::Buttons.

2009-10-08  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/comboentryglom.cc: init(): On Maemo, remove the
	duplicate first column and do not expand the first column.

2009-10-08  Murray Cumming  <murrayc@murrayc-x61>

	Maemo 5: List view: Subtly improve the separating lines.

	* glom/utility_widgets/db_adddel/db_adddel.cc: treeview_append_column():
	On Maemo, use an "x-pad" of HILDON_MARGIN_DEFAULT for the cell
	renderers, because Mathias Hasselmann says that is required for Maemo 5.

2009-10-08  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Use a PickerButton with TouchSelector for combo boxes on details views.

	* glom/utility_widgets/comboentryglom.[h|cc]:
	* glom/utility_widgets/comboglom.[h|cc]: On Maemo, derive from
	Hildon::PickerButton instead of Gtk::ComboBox*, with a member
	TouchSelector/TouchSelector. However, the ID field seems to be shown
	twice.

2009-10-08  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Actually show new list views and related records portals.

	* glom/utility_widgets/db_adddel/db_adddel.cc:
	construct_specified_columns(): Use while(TouchSelector::remove_column())
	to actually remove old view columns, so we actually see an effect when
	navigating to a new table, and so we don't see old data in related
	records tables.

2009-10-07  Murray Cumming  <murrayc@murrayc.com>

	Tests: Import: Fixed the no-exceptions build.

	* tests/import/utils.cc: Fixed the no-exceptions build.

2009-10-06  Daniel Elstner  <daniel.kitta@gmail.com>

	Support Automake silent rules

	* configure.ac: Call the AM_SILENT_RULES macro if it is defined.
	* Makefile.am (.rc.res): Prefix command with $(AM_V_GEN) to suppress
	the echoing of the command line if silent rules are enabled.
	* Makefile_libegg.am (eggmarshalers.h), (eggmarshalers.c): ditto.

1.12.2:

2009-10-05  Murray Cumming  <murrayc@murrayc.com>

	Import: Handle large unquoted text (binary image data).

	* glom/import_csv/csv_parser.cc: on_idle_parse(): When we reach the
	end of the buffer without finding a newline, store all of the remaining
	text instead of just since the last quote, so we don't discard parts
	of large unquoted text, such as parts of binary image data.
	This seems to break the test_fail_on_non_matching_quotes test, but
	the tests are too hard to run until we have removed the idle handling
	(and its timing problems) from CSvParser.

	* glom/libglom/data_structure/field.cc: to_file_format(): Also
	escape carriage-returns, just in case.
	* tests/import/test_parsing.cc: Comment out the
	test_skip_on_no_ending_newline test, because I see no reason why we
	would want to ignore last lines with no newline.

2009-10-06  Murray Cumming  <murrayc@murrayc.com>

	Maemo: List: Click to view details.

	* glom/utility_widgets/db_adddel/db_adddel.[h|cc]: Connect to
	TouchSelector::signal_changed to respond to clicks on the list. Note that
	a drag to pan (scroll) does not cause that signal to be emitted.
	* glom/utility_widgets/db_adddel/db_adddel_withbuttons.[h|cc]: On Mameo,
	remove the Delete and Edit buttons because deleting can be done via the
	details window (viewable on Maemo). The Add button is still there and is ugly.

2009-10-06  Murray Cumming  <murrayc@murrayc.com>

	DbAddDel: Expand an appropriate column.

	* glom/libglom/data_structure/layout/layoutitem.[h|cc]: get_display_width():
	Remove the bool return and just return the value, because 0 already means no
	specified width.
	* glom/libglom/document/document.cc:
	* glom/mode_design/layout/dialog_layout_details.cc:
	* glom/print_layout/canvas_layout_item.cc: Adapt.

	* glom/utility_widgets/db_adddel/db_adddel.[h|cc]:
	Added get_column_to_expand() to choose the last expandable (text, no specified
	width) column.
	treeview_append_column(): Add a bool expand property and use it.
	construct_specified_columns(): Expand the expandable column, to avoid
	wasting space or expanding an inappropriate column.

2009-10-05  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Allow editing of hidden tables (only) via its details window.

	* glom/mode_data/box_data_list_related.cc: enable_buttons(): Add a maemo
	ifdef around m_AddDel.set_allow_view_details().

2009-10-05  Murray Cumming  <murrayc@murrayc.com>

	Maemo: List: Use only 2 columns by default, so some have enough space.

	* glom/libglom/document/document.cc: get_data_layout_groups_plus_new_fields():
	Restrict maemo to 2 list columns by default.

2009-10-05  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Related Records / AddDel: Use icon-only Hildon buttons.

	* glom/utility_widgets/db_adddel/db_adddel_withbuttons.[h|cc]: Use Hildon
	Buttons, with only icons.

2009-10-05  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Hide group titles by default.

	* glom/libglom/data_structure/translatable_item.[h|cc]:
	Added clear_title_in_all_locales().
	* glom/libglom/document/document.cc:
	maemo_restrict_layouts_to_single_column_group(): Also clear the group titles
	to make the default maemo layout more compact.

2009-10-05  Murray Cumming  <murrayc@murrayc-desktop>

	Export: Correct problems in the binary data for images: Escape newlines.

	* glom/libglom/data_structure/field.cc: to_file_format(): Escape
	newlines as \012 instead of removing them, because this is probably
	what gda_binary_to_string() intends.

2009-10-05  Murray Cumming  <murrayc@murrayc.com>

	Export: Correct problems in the binary data for images.

	* glom/libglom/data_structure/field.cc: to_file_format(): Escape
	newlines and quotes in binary data text, to workaround libgda bug
	https://bugzilla.gnome.org/show_bug.cgi?id=597390
	* glom/frame_glom.cc: export_data_to_stream(): Double check that
	image data contains no newlines or quotes.
	* glom/libglom/utils.cc: string_replace(): Avoid an endless loop
	when the search_for input parameter is empty.
	This fixes bug #593304 (Michael Hasselmann)

2009-10-04  Murray Cumming  <murrayc@murrayc.com>

	Fix regression: Actually show field choices again in combo boxes.

	* glom/libglom/utils.cc: get_choice_values(): Move the list_values.push_back()
	out of the ifdef block so we actually show field choices again in the combo
	boxes. This was broken by the commit from Johannes on 2009-07-30.
	Hopefully ldtp tests will avoid this in future.

2009-10-02  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Really fall back to the standard layout if there is no maemo layout.

	* glom/libglom/document/document.cc: get_data_layout_groups_plus_new_fields():
	Really fall back to the standard layout if there is no maemo layout.
	When creating a default layout, restrict the column count to 1.

2009-10-02  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Avoid multi-column details layouts.

	* glom/libglom/document/document.[h|cc]:
	Added maemo_restrict_layouts_to_single_column_group().
	* glom/application.cc: on_document_load(): On maemo, call it to make the
	layout more suitable by default, if no custom maemo layout is defined.

2009-10-02  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Fix the build.

	* glom/frame_glom.cc:
	* glom/import_csv/dialog_import_csv.cc:
	* glom/import_csv/dialog_import_csv_progress.cc: Added no-exceptions ifdefs,
	and corrected the hildonmm code.

1.12.1:

2009-10-02  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/utils.h|cc]: build_sql_select_fields_to_get():
	Removed the unused extra_join parameter.
	* glom/base_db.cc: Adapted.

2009-10-02  Murray Cumming  <murrayc@murrayc.com>

	Related Records: Fix doubly-related records portals, such as a list of
	an Artist's publishers (via their albums).

	* glom/libglom/utils.[h|cc]: build_sql_select_with_where_clause():
	Move some code into build_sql_select_fields_to_get(), so we can get the
	list of fields to get without the rest of the SQL.
	* glom/base_db.cc: set_found_set_where_clause_for_portal():
	Use build_sql_select_fields_to_get() to GROUP BY the full field list
	instead of just the primary key, as required by recent PostgreSQL,
	and probably by the SQL specification.
	We should investigate SELECT DISTINCT again to simplify this.

2009-10-02  Michael Hasselmann  <michaelh@openismus.com>

	Import: Cleanup, added comments.

2009-10-01  Michael Hasselmann  <michaelh@openismus.com>

	Import: Made import working again, changed import logic

	* glom/import_csv/csv_parser.[h|cc] (fetch_next_row): This method allows
	iterating over the parser's cache without the need for a max row/column
	count. Potential issue with valid empty rows during import needs to be fixed.

	* glom/import_csv/dialog_import_csv.[h|cc]: Removed logic based on row counts.
	It turned out that most places didn't need access to get_row_count() anyway.

	* glom/import_csv/dialog_import_csv_progess.cc: Switched import to use the
	parser's new fetch_next_row() API. Not tested for large files yet.

2009-09-29  Murray Cumming  <murrayc@murrayc.com>

	Doubly-related Records: Correct the SQL.

	* glom/base_db.cc: set_found_set_where_clause_for_portal():
	For doubly-related records, use the correct relationship for the GROUP BY to
	avoid a SQL error about a non-existant field. We must have been lucky before.

	However, we now need to fix the SQL error (maybe new in a recent PostgreSQL
	version) about not mentioning all viewed fields in the GROUP BY.

2009-09-29  Murray Cumming  <murrayc@murrayc.com>

	Design: Related Records Portal: Prevent use of inappropriate relationships.

	* glom/mode_design/layout/dialog_layout_list_related.cc:
	on_combo_relationship_changed(): Do not allow the related record to show
	relationships that would require duplicate values in unique fields to show
	multiple records. Noticed by Alessio C.

2009-09-29  Murray Cumming  <murrayc@murrayc.com>

	LayoutGroup: Added accessors for columns count, hiding the member variable.

	* glom/libglom/data_structure/layout/layoutgroup.[h|cc]: Made m_columns_count
	private and added get/set_columns_count() so I can see when this is changing.
	* glom/libglom/data_structure/layout/layoutgroup.h:
	* glom/libglom/document/document.cc:
	* glom/mode_data/flowtablewithfields.cc:
	* glom/utility_widgets/dialog_flowtable.cc: Adapted.

2009-09-29  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Actually allow details to be opened.

	* glom/utility_widgets/db_adddel/db_adddel.cc: get_item_selected():
	Use Hildon::TouchSelector::get_selected() instead of get_active() so it
	actually works for rows other than the first one.
	See hildon bug https://bugs.maemo.org/show_bug.cgi?id=4640,
	though the error might be in our maemomm C++ code to work around that.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Find: Show the quickfind.

	* glom/frame_glom.cc: Constructor: On Maemo, put the quickfind widgets in
	the separate find window.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	Create QuickFind buttons in code, instead of Glade.

	* glom/frame_glom.cc:
	* glom/glom.glade: Create the QuickFind widgets in code instead of in
	Glade so we can adapt them for Maemo and put them in the separate Find
	window.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	Initial dialog: Expand the network item.

	* glom/dialog_existing_or_new.cc: Constructor: Expand the Network
	item, because it helps to explain what it is, particularly on Maemo
	where there are no treeview row arrows.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	* glom/frame_glom.[h|cc]: Maemo: Show the Find UI in a separate window.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Find: Use only the details view.

	* glom/mode_find/notebook_find.[h|cc]: Hide the list view (and tabs) on Maemo.
	This needs to be a separate window too.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Show the table name in the AppMenu. Added a Find Button.

	* glom/application.cc: update_window_title(): Update the picker button here
	too.
	init_menus(): Add a Find button for the AppMenu.
	* glom/navigation/maemo/pickerbutton_table.cc: set_table_name(): Actually
	set the row as active.
	* glom/dialog_existing_or_new.cc: Make sure the first row is visible,
	even on Maemo. Otherwise it looks strange.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	Initial dialog: Expand the network item.

	* glom/dialog_existing_or_new.cc: Constructor: Expand the Network
	item, because it helps to explain what it is, particularly on Maemo
	where there are no treeview row arrows.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	Fix a crash.

	* glom/dialog_existing_or_new.cc: Move some assertions so this works
	again in non-client-only mode.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	client-only mode: Ifdef out unused code.

	* glom/dialog_existing_or_new.[h|cc]: Ifdef out unused code for the new
	document notebook tab in client-only mode.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Removed icons from dialogs.

	* glom/glom.glade: Comment out icons in our maemo5 branch.

2009-09-28  Murray Cumming  <murrayc@murrayc.com>

	Client-only mode: Change the initial dialog label.

	* glom/dialog_existing_or_new.cc: Constructor: Change the label text if in
	client-only mode, to avoid mentioning creation of documents.

2009-09-25  Murray Cumming  <murrayc@murrayc.com>

	Fix the build with gtkmm < 2.18.

	* glom/utility_widgets/flowtable.cc: Correct the use of
	GTKMM_MINOR_VERSION to fix the build with older gtkmm versions.

2009-09-25  Michael Hasselmann  <michaelh@openismus.com>

	Import: More code cleanup in tests

	* glom/import_csv/csv_parser.cc (set_file_and_start_parsing): Fail on empty
	file uri.

	* tests/import/*: Removed the ugly mainloop singleton, among other cleanups.

2009-09-25  Murray Cumming  <murrayc@murrayc-desktop>

	Cleanup.

	* glom/glom.glade: Really revert a bad merge from the maemo5 branch.
	* glom/libglom/connectionpool_backends/postgres_self.cc: Do not have
	actual newlines in string literals.

2009-09-25  Murray Cumming  <murrayc@murrayc.com>

	Fix the build with gtkmm < 2.18.

	* glom/utility_widgets/flowtable.cc: Correct the use of
	GTKMM_MINOR_VERSION to fix the build with older gtkmm versions.

2009-09-25  Murray Cumming  <murrayc@murrayc-desktop>

	Import tests: Fixed.

	* tests/import/utils.[h|cc]: run_parser_from_buffer(): Added a
	version that takes a std::string, to make the common case more robust.
	* tests/import/test_parsing.cc:
	* tests/import/test_signals.cc: Fix the tests by not incorrectly
	taking the length of the raw arrays, which caused the temp files to
	contain garbage.

2009-09-25  Murray Cumming  <murrayc@murrayc-desktop>

	Import tests: Handle encoding errors.

	* tests/import/utils.cc: Handle signal_encoding_error too, because this
	is one way that the parser can stop.
	Increase the timeout because an infinite loop is unlikely (and not
	currently happening).

2009-09-25  Murray Cumming  <murrayc@murrayc.com>

	tests/import/: Small cleanup.

	* tests/import/test_parsing.cc:
	* tests/import/utils.[h|cc]: Use a sigc::slot instead of the ugly
	(because not typedefed) function pointer type.

2009-09-25  Murray Cumming  <murrayc@murrayc.com>

	Removed some debug output.

	* glom/libglom/data_structure/glomconversions.cc: parse_time():
	* tests/test_parsing_time.cc: Removed debug output.

2009-09-25  Michael Hasselmann  <michaelh@openismus.com>

	Import: Changed the signature of line_scanned handler

	* glom/import_csv/dialog_import_csv.[h|cc]: Changed the signare of
	on_parser_line_scanned, to use CsvParser::type_row_strings. It does not
	change anything, as the handler didn't even use the parameters.

	Import: Fixed tests to fit new parser API

	* glom/import_csv/csv_parser.[h|cc]: Added a finished_parsing signal since the
	max_row count logic is flawed
	(https://bugzilla.gnome.org/show_bug.cgi?id=588233#c16). Also moved common
	parts of on_stream_read(.) (now on_buffer_read(.)) into
	copy_buffer_and_continue_reading(.), to avoid copy'n'paste bugs.

	* tests/import/utils.[h|cc]: Added mainloop functionality to trigger the idle
	parse sequence of the CsvParser for the testcases.

	* tests/import/test_[parsing,signals].cc: Fixed the tests to fit new parser
	API.

1.12.0:

2009-09-25  Murray Cumming  <murrayc@murrayc.com>

	Command spawning: Really check the return value.

	* glom/libglom/spawn_with_feedback.cc:
	execute_command_line_and_wait_until_second_command_returns_success():
	Actually check the return value of the first command, so we can fail
	immediately (with stderr output) when, for instance, postgresql
	fails to read the configuration file due to changed options, such as
	no longer recognizing max_fsm_pages in PostgreSQL 8.4

2009-09-25  Murray Cumming  <murrayc@murrayc.com>

	Replace some NULLs with 0 because this is C++, not C.

	* glom/libglom/connectionpool_backends/postgres.cc:
	* glom/libglom/connectionpool_backends/postgres_self.cc:
	* glom/libglom/spawn_with_feedback.cc: Replace NULLs with 0.

2009-09-25  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Fix the non-exceptions build again.

	* glom/print_layout/canvas_print_layout.cc: Added ifdefs around KeyFile
	calls. I wonder why I only noticed this now.

2009-09-24  Murray Cumming  <murrayc@murrayc.com>

	Self-Hosting: Use the new ident configuration for PostgreSQL 8.4.

	* glom/libglom/spawn_with_feedback.[h|cc]: Added an
	execute_command_line_and_wait() overload that has an output parameter
	for the stdout from the command.
	* glom/libglom/connectionpool_backends/postgres_self.[h|cc]:
	Added a get_postgresql_utils_version_as_number() utiltity method,
	and use it in set_network_shared() to use a different syntax for
	Postgres 8.4, hopefully fixing bug #595608 (Fryderyk Dziarmagowski)

2009-09-24  Murray Cumming  <murrayc@murrayc.com>

	Self-Hosting: Retry the connection just-long-enough.

	* glom/libglom/connectionpool_backends/postgres.[h|cc]: attempt_connect():
	Add a throw() declaration because we know that this really never throws,
	though other similar methods do.
	* glom/libglom/connectionpool_backends/postgres_self.cc: connect():
	If not network-shared then retry every second when the connection fails,
	because the (default) password really must be correct. Seems to work,
	requiring 6 retries on my system.
	However, we must still wait a hard-coded time to be sure of failure
	if the password is not the default one, for instance when network sharing.
	* glom/libglom/spawn_with_feedback.cc:
	execute_command_line_and_wait_until_second_command_returns_success():
	Remove the hacked 8-second wait here.

2009-09-23  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Details: Do not show buttons.

	* glom/mode_data/box_data_details.[h|cc]: ifdef out the buttons for maemo.
	* glom/glom.glade: Hack a HildonStackableWindow into the maemo5 branch
	to avoid a warning with our get_widget_derived() call.

2009-09-23  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_data/box_data_details.cc: Rename the HBox member variables
	to make their purposes clearer.

2009-09-23  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Use Hildon::StackableWindow.

	* glom/bakery/app_withdoc_gtk.h:
	* glom/window_boxholder.h: Use Hildon::StackableWindow instead of just
	Hildon::Window because this always seems to be the right thing to do.

2009-09-23  Murray Cumming  <murrayc@murrayc.com>

	Renamed Dialog_Glom to Window_BoxHolder.

	* glom/dialog_glom.[h|cc]: Renamed to window_boxholder.[h|cc] to make
	its purpose clearer.
	* glom/frame_glom.[h|cc]:
	* glom/mode_data/notebook_data.[h|cc]:
	* Makefile_glom.am: Adapted.

2009-09-22  Murray Cumming  <murrayc@murrayc.com>

	Dialog_Glom: Make this a little less stupid, so we can ifdef for Maemo.

	* glom/dialog_glom.[h|cc]: Derive from Window, not Dialog.
	Constructor: Add the provided box instead of requiring us to add it
	explicitly (to the Dialog's vbox).
	* glom/frame_glom.cc:
	* glom/mode_data/notebook_data.cc: Adapt.

2009-09-22  Murray Cumming  <murrayc@murrayc.com>

	On Maemo, show the details in a separate window.

	* glom/mode_data/notebook_data.[h|cc]: On maemo, hide the tabs, and don't
	add the details box to the notebook. Instead add it to a window and show that
	window instead of switching to a details tab when details are requested.


2009-09-21  Murray Cumming  <murrayc@murrayc.com>

	import tests: Fix the no-exceptions build.

	* tests/import/test_parsing.cc:
	* tests/import/test_signals.cc: Fix the build without exceptions.

2009-09-21  Johannes Schmid <jschmid@openismus.com>

	* Makefile_tests.am:
	Fixed make dist. The sources of tests/test_python_module weren't
	given which broke at least with automake-1.10

2009-09-21  Murray Cumming  <murrayc@murrayc.com>

	Export: Use .csv file extension to match the filter when importing.

	* glom/utils_ui.[h]cc]: Added get_filepath_with_extension() to add
	(if necessary) a specified file extension to a filepath.
	* glom/frame_glom.cc: on_menu_file_export(): Add a .csv file
	extension if not already specified, so we automatically see the
	export file in the file chooser when importing.

2009-09-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/dialog_import_csv.cc: get_data(): Avoid out-of-bounds crashes
	when accessing the vector of vectors. Note that this check is
	already in the appropriate place in the import_csv_refactored branch.
	This makes bug #593304 slighly clearer, though it is now an endless
	loop with debug output.

2009-09-21  Murray Cumming  <murrayc@murrayc.com>

	Import dialog: Set the number of sample rows to 2 by default.

	* glom/dialog_import_csv.cc: Set the number of sample rows to 2
	by default, not 0.
	* glom/frame_glom.cc: Hack around another (!) GtkBuilder warning about
	a secondary top-level object (textbuffer).

2009-09-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/glom-1.0.pc.in: Rename to glom-1.12.pc.in to match
	the .so name and header install location. Noticed by Chris Coulson.

2009-09-18  Michael Hasselmann  <michaelh@openismus.com>

	Import tests: made them quiet

	* Makefile_tests.am, test/import/utils.[cc|h],
	tests/import/test_[parsing|signals].cc: Only report on failure. Moved common
	parts into an utility namespace.

2009-09-18  Murray Cumming  <murrayc@murrayc.com>

	CsvParser: Make this an actual parser, with a sane API.

	* glom/dialog_import_csv.[h|cc]:
	* glom/dialog_import_csv_progress.[h|cc]: Move into glom/import_csv/
	* glom/import_csv/: Added file_encodings.[h|cc], moving the encodings
	list into it. This is similar to mode_design/iso_codes.[h|cc].
	* glom/import_csv.[h|cc]: Rename to glom/import_csv/csv_parser.[h|cc]
	to match the class name.
	Move actual parsing (and the vector of row/column data) into
	CsvParser, leaving the dialogs to just respond to signals and get
	data via get methods.

	However, this breaks the import tests, because they add data to
	the parser directly using m_raw. They must be changed to read actual
	files, or maybe we could add some intermediate level of API that they
	could test.

2009-09-18  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Use some Hildon widgets.

	* glom/utility_widgets/entryglom.[h|cc]:
	* glom/utility_widgets/textviewglom.h: Use Hildon::TextView and Hildon::Entry.

2009-09-18  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Add a full configure example for maemo in a comment,
		to help my memory.
	* glom/dialog_import_csv.cc: Fix a typo to fix the build on maemo.

2009-09-18  Murray Cumming  <murrayc@murrayc-desktop>

	CsvParser: Made some API private.

	* glom/dialog_import_csv.[h|cc]: get_field_for_column(): Return a
	sharedptr<const>, not a silly const sharedptr<>&.
	* glom/dialog_import_csv_progress.cc:
	* glom/import_csv.[h|cc]: add get_state() and get_rows_count(). Make
	some API private to make it clearer what needs to be done to make
	this a real self-contained class.

2009-09-18  Murray Cumming  <murrayc@murrayc.com>

	CSV Import: Minor code style changes.

	* glom/dialog_import_csv.cc:
	* glom/dialog_import_csv_progress.cc:
	* glom/import_csv.[h]cc]: Prefix the state enum with STATE_.
	Use 0 instead of NULL because this is C++. Remove some debug output.
	Make signal type and variable names consistent with other code.
	* tests/import/test_signals.cc: Add a last std::endl.

2009-09-18  Murray Cumming  <murrayc@murrayc.com>

	Tests: Stop using valgrind by default.

	* Makefile_tests.am: Do not run all tests under valgrind. valgrind is
	for humans to read, and make check has no way to know if the result is
	appopriate or not. Run things under valgrind when you want to.

2009-09-17  Michael Hasselmann <michaelh@openismus.com>

Refactoring Dialog_Import_CSV: created testcase for the CsvParser's signal emission

	* Makefile_tests.am: all tests now run within valgrind by default since mem
	leaks in testcases are potential mem leaks in the application. Parameters might
	need tweaking.

	* glom/import_csv.cc (CsvParser::on_idle_parse): Fixed a missing negation in a
	conditional, which was wrongfully leading to signal emissions. Found by the
	import signals testcase.

	* test/import/test_parsing.cc: Fixed a null byte issue when setting the raw
	contents of the parser.

	* test/import/test_signals.cc: This testcase checks the CsvParser's signal
	emission on varying input. The basic idea was to have on testcase for each
	code path that leads to a signal emission in glom/import_csv.cc, even if that
	leads to overlapping code coverage tests with the parser testcase.

2009-09-17  Johannes Schmid  <jschmid@openismus.com>

	* Makefile_libglom.am: Don't link libglom
	statically on maemo. (#594355)

2009-09-17  Johannes Schmid  <jschmid@openismus.com>

	* glom/application.cc: offer_new_or_existing():
	Replace a TODO comment with g_assert_val_if_reached() because
	reaching this branch would mean that the dialog returned
	an unhandled response.

2009-09-17  Johannes Schmid  <jschmid@openismus.com>

	* regression_tests/test_python_module.cc:
	* Makefile_tests.am:
	Added a regression test for the loading of the python modules.
	Unfortunately this test doesn't trigger the crash bug that
	happens on exit() on the maemo platform.

2009-09-17  Johannes Schmid  <jschmid@openismus.com>

	* glom/main.cc:
	Really check if pygda module is available. A typo caused
	the check for the glom module twice while the gda module
	wasn't checked at all

2009-09-14  Johannes Schmid  <jschmid@openismus.com>

	* glom/dialog_import_csv.cc:
	Fixed maemo non-exception build of CsvParser refactoring.

2009-09-14  Murray Cumming  <murrayc@murrayc.com>

	Main Window: Correct (again) the order of Records/Found widgets.

	* glom/glom.glade: main_window: Put the Records:/Found: widgets in
	sub-hboxes, and change their order by hand in the .glade file because
	GtkBuilder and Glade do not seem to interpret the file in the same way.

1.11.2:

2009-09-14  Murray Cumming  <murrayc@murray.com>

	* glom/frame_glom.cc:
	* glom/utility_widgets/flowtable.cc: Fixed warnings-as-errors build
	problems with the latest gtkmm.

2009-09-11  Michael Hasselmann <michaelh@openismus.com>

	Refactoring Glom::Dialog_Import_CSV: first parser tests created

	* Makefile_tests.am, tests/import.sh,
	tests/import/test_parsing.cc: The first tests for the CsvParser
	are ready. Basic input is tested but no real world examples yet. Run with 'make
	check TESTS=tests/import.sh' to run tests with valgrind.

	Renamed regression_tests folder to tests

	* tests, Makefile_tests.am: Changed paths accordingly.

2009-09-09  Michael Hasselmann <michaelh@openismus.com>

	Refactoring Glom::Dialog_Import_CSV

	* ChangeLog, Makefile_glom.am, glom/dialog_import_csv.[h|cc],
	glom/import_csv.[h|cc], glom/dialog_import_csv_progress.cc: Moved the inlined
	Parser class from the Dialog_Import_CSV class to the new CsvParser class.  The
	CsvParser already handles the line scanning and encoding conversion but is
	supposed to take over the file reading responsibility as well.  In order to
	allow the Dialog_Import_CSV class to parse a scanned line into its tree model
	the parser emits a lineScanned signal, with the currently scanned line as
	parameter.
	Bug #588233.

2009-09-08  Johannes Schmid <jschmid@openismus.com>

	 Bug 594357 -  Maemo: sqlite behaves strange

	 * glom/utility_widgets/db_addel/glom_db_treemodel.cc:
	 DbTreeModel::create():
	 Create the correct DataAccessWrapper in both codepaths and not only
	 in the exception code path. That makes no difference for postgres but
	 is needed for sqlite.

2009-09-08  Johannes Schmid <jschmid@openismus.com>

	 Bug 594357 -  Maemo: sqlite behaves strange

	 * glom/utility_widgets/db_addel/glom_db_treemodel.cc:
	 DbTreeModel::create():
	 Create the correct DataAccessWrapper in both codepaths and not only
	 in the exception code path. That makes no difference for postgres but
	 is needed for sqlite.

2009-09-07  Murray Cumming  <murrayc@murrayc.com>

	* glom/box_reports.[h|cc]:
	* glom/navigation/box_tables.[h|cc]: Comment out some save_to_document()
	methods in client-only mode.

2009-09-07  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.cc:
	* glom/frame_glom.cc: Fix tiny typos to fix the non-maemo build.

2009-09-05  Murray Cumming  <murrayc@murrayc.com>

	Maemo: ifdef out useless menu code.

	* glom/application.[h|c]]: Ifdef out any menu-building code because
	it must be completely replaced by Hildon::AppMenu code on Maemo.
	* glom/mode_data/notebook_data.cc: Constructor: Hide the notebook
	tabs, in preparation for just showing the list, with the details in a
	separate window on Maemo.

2009-09-05  Murray Cumming  <murrayc@murrayc.com>

	connection_request_password_and_attempt(): Fix a crash in client-only mode.

	* glom/frame_glom.[h|cc]: connection_request_password_and_attempt():
	Move some decision-making into handle_request_password_connection_error,
	to allow us to handle the no-exception API better, though this is
	clearer anyway, or would be without the ifdefs.

2009-09-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.cc: on_document_load(): Add a ! to really check
	for unsupported backends.

2009-09-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.cc: check_document_hosting_mode_is_supported():
	Correct and ifdef to an ifndef.

2009-09-05  Murray Cumming  <murrayc@murrayc.com>

	Maemo: Use Hildon::FileChooserDialog for opening files.

	* glom/application.[h|cc]: Remove unused (and unnecessary since the new
	initial dialog) on_menu_file_open() and on_menu_file_close() overrides
	and ui_file_select_open_with_browse().
	* glom/dialog_existing_or_new.cc: on_select_clicked(): Use
	Hildon::FileChooserDialog on Maemo.
	* glom/bakery/app_withdoc_gtk.cc: Remove the uncommented undef of
	GLOM_ENABLE_MAEMO - no more nasty hacks please. Instead comment-out
	the set_menu() call with a TODO, leaving the rest of the maemo-specific
	code working.

2009-09-05  Murray Cumming  <murrayc@murrayc.com>

	Check for unsupported hosting modes.

	* glom/application.[h|cc]:
	Added check_document_hosting_mode_is_supported() to warn the user
	if the build cannot use the hosting mode in the file, and call it from
	on_document_load().
	* glom/libglom/document/bakery/document.cc: load(), load_from_data():
	Call set_is_new(false) so we can check for this in
	App/View::on_document_load(), to avoid complaining about an unused
	default hosting mode.

2009-09-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.cc: offer_new_or_existing(): In the client-only build,
	actually handle the enum for opening an existing file in client mode.

2009-09-05  Murray Cumming  <murrayc@murrayc.com>

	offer_new_or_existing(): Add Gtk::Builder error handling .

	* glom/application.cc: offer_new_or_existing(): Add error handling to
	show how GtkBuilder complains about Atk objects in .glade files on
	Maemo, and actually fails.

2009-09-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/print_layout/canvas_print_layout.cc:
	* glom/utility_widgets/imageglom.cc: Fix the build when -fno-exceptions
	is used.

2009-09-05  Murray Cumming  <murrayc@murrayc.com>

	Added dlopen test of the python library.

	* glom/libglom/test_connectionpool.cc:
	* glom/libglom/test_document.cc: Fixed the build without exceptions.
	* Makefile_tests.am: Added test_load_python_library, using dlopen()
	to show the numpunct linker error (bug #594142) without actually using
	python.

2009-09-04  Daniel Elstner  <daniel.kitta@gmail.com>

	Do not try to catch non-existing MetaStructError

	* glom/base_db.cc (Base_DB::get_fields_for_table_from_database):
	For now, catch Glib::Error instead of Gnome::Gda::MetaStructError,
	which does not exist.

2009-09-04  Murray Cumming  <murrayc@murrayc.com>

	Avoid compiler warnings.

	* configure.ac: Add a comment about using the PYTHON environment
	variable to specify the python version.
	* glom/dialog_existing_or_new.cc:
	* glom/dialog_import_csv_progress.cc:
	* glom/utility_widgets/canvas/canvas_group_resizable.cc: Avoid some
	compiler warnings, mostly about missing returns in unlikely
	situations.

2009-09-04  Murray Cumming  <murrayc@murrayc.com>

	Mention the failed python module name on stdcerr.

	* glom/python_embed/glom_python.cc: glom_python_module_is_available(),
	gda_python_module_is_available(): Output a hint to the command-line too,
	in case maemo crashes when showing UI as mine does at the moment,
	and to mention the exact python module name that failed.

2009-09-04  Murray Cumming  <murrayc@murrayc.com>

	Fix the client-only non-maemo build on maemo.

	* configure.ac: Correct the AS_IF() calls so that we really do not
	need iso-codes in client-only mode.
	* glom/print_layout/canvas_layout_item.cc:
	* glom/print_layout/canvas_print_layout.cc:
	* glom/printoperation_printlayout.cc: Fix the build without
	exceptions, without properties and without default signal handlers,
	with ifdefs.

	* glom/base_db.cc: get_fields_for_table_from_database(): Actually add
	a no-exceptions ifdef for the use of Gda::MetaStruct::complement()
	instead of just ifdefing it out for Maemo.
	* glom/mode_data/notebook_data.cc:
	* glom/utility_widgets/adddel/adddel.cc:
	* glom/utility_widgets/db_adddel/db_adddel.cc:
	* glom/utility_widgets/entryglom.cc:
	* glom/utility_widgets/imageglom.cc:
	Likewise, ifdef the use of get_accessible on GTKMM_ATKMM_ENABLED instead
	of GLOM_ENABLE_MAEMO, to fix the client-only non-maemo build on Maemo.
	Again, please stop abusing the MAEMO ifdef for hacks without even a TODO.

2009-09-04  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_design/layout/layout_item_dialogs/dialog_buttonscript.h:
	Removed unnecessary GLOM_ENABLE_CLIENT_ONLY ifndef.

2009-09-04  Murray Cumming  <murrayc@murrayc.com>

	Moved more design-only classes to glom/mode_design/

	* glom/libglom/data_structure/iso_codes.[h|cc]:
 	* glom/utility_widgets/comboentry_currency.cc
	* glom/mode_design/translation/:
	Moved to glom/mode_design/.
	* glom/Makefile_glom.am, *.[h|cc]:
	* po/POTFILES.in: Adapted.
	* configure.ac: Make use of iso-codes dependent on client-only, not
	maemo, because that actually makes sense.

1.11.1:

2009-09-03  Murray Cumming  <murrayc@murrayc.com>

	* Makefile_tests.am: Fixed a tiny typo to fix the tests build.

2009-09-03  Murray Cumming  <murrayc@murrayc.com>

	Move some non-layout print_layout code back out of mode_design

	* glom/mode_design/print_layouts/canvas_layout_item.[h|cc]:
	* glom/mode_design/print_layouts/canvas_print_layout.[h|cc]:
	Moved to glom/print_layout/, because they are used by client-only mode
	too.
	* glom/Makefile_glom.am, *.[h|cc]: Adapted.
	* po/POTFILES.in: Update for moved files.

2009-09-03  Murray Cumming  <murrayc@murrayc.com>

	Moved many developer-mode files into glom/mode_design/ now that our
	non-recursive build allows that without linker errors.

	* glom/combobox_fields.[h|cc]:
	* glom/combobox_relationship.[h|cc]:
	* glom/layout_item_dialogs/:
	* glom/mode_data/dialog_choose_field.[h|cc]:
	* glom/mode_data/dialog_choose_relationship.[h|cc]:
	* glom/mode_data/dialog_layout*.[h|cc]:
	* glom/mode_data/treestore_layout.[h|cc]:
	* glom/layout_item_dialogs/:
	Moved to glom/mode_design/layout/
	* glom/reports/report_builder.[h|cc]: Moved to glom/
	* glom/reports/dialog_layout_report.[h|cc]"
	* glom/reports/treestore_report_layout.[h|cc]:
	Moved to glom/mode_design/report_layout/
	* glom/database_preferences.[h|cc]:
	* glom/relationships_overview/: Moved to
	glom/mode_design/
	* glom/glom_developer.glade:
	* glom/dialog_new_self_hosted_connection.[h|cc]:Rename to
	glom/mode_design/dialog_initial_password.[h|cc], renaming the class too,
	because that's what this is now.
	* glom/utility_widgets/dialog_layoutitem_properties.[h|cc]: Removed
	this unused class.
	* glom/Makefile_glom.am, *.[h|cc]: Adapted.

2009-09-03  Murray Cumming  <murrayc@murrayc.com>

	libglom: Avoid client-only build changes: partial recommit of revert.

	* glom/libglom/appstate.cc:
	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool_backends/backend.h:
	* glom/libglom/connectionpool_backends/postgres.h:
	* glom/libglom/connectionpool_backends/postgres_central.h:
	* glom/libglom/connectionpool_backends/postgres_self.h:
	* glom/libglom/connectionpool_backends/sqlite.h:
	* glom/libglom/document/document.h: Remove mention of
	GLOM_ENABLE_CLIENT_ONLY from comments because we no longer use it in
	libglom.
	* glom/libglom/connectionpool_backends/postgres.cc: attempt_connect():
	Do not use Gda::CONNECTION_OPTIONS_READ_ONLY just because exceptions
	are disabled in the build. Please stop using vaguely-related ifdefs
	to hack changes in. In this case it would be GLOM_ENABLE_CLIENT_ONLY,
	but we don't want that option in libglom anymore.

2009-09-01  David King  <davidk@openismus.com>

	* glom/glom.glade: Fix an interesting warning, where the quickfind
	Gtk::Entry was described in the glade file as having focus, even
	though it was set to be not visible, and therefore not realized.

2009-09-01  David King  <davidk@openismus.com>

	* glom/dialog_existing_or_new.cc:
	* glom/utility_widgets/db_adddel/db_adddel.cc: Use Gtk::StockID
	constructor with builtin stock items so that GTK+ warnings are not
	triggered.

2009-09-01  Johannes Schmid  <jschmid@openismus.com>

	* glom/base_db.cc: Fixed small build problem with disabled exceptions

2009-09-01  Johannes Schmid  <jschmid@openismus.com>

	* glom/libglom/connectionpool_backends/postgres.cc:
	Also use SQL_IDENTIFIERS_CASE_SENSITIVE on maemo
	* glom/base_db.cc:
	enable the use gda_meta_store_sql_identifier_quote() on maemo

	These were hacks used before libgda 4.0.4 was available on maemo

2009-08-31  David King  <davidk@openismus.com>

	Revert "Really never use config.h in libglom."

	This reverts commit 8d73f2051fb624e145505b3587a12d89ed3c8326.

	The change gave no benefits, but did break any project that used libglom
	and autoheader.

2009-08-31  Johannes Schmid  <jschmid@openismus.com>

	* Makefile_test.am: Fixed make dist (probably automake-1.11 is more
	clever but it does not build with automake-1.10 because it assumes
	that the test programs have sources in form of xxx.c and not xxx.cc

2009-08-27  Murray Cumming  <murrayc@murrayc.com>

	Avoid GTK+ warnings.

	* glom/glom_developer.glade: Set GtkAdjustment page_size to 0 to
	avoid new GTK+ warnings.
	* glom/layout_item_dialogs/dialog_field_layout.cc:
	* glom/mode_design/fields/dialog_fielddefinition.cc:
	* glom/mode_design/print_layouts/dialog_text_formatting.cc:
	More nasty workarounds for GtkBuilder bug #575714, which is still not
	fixed.

2009-08-27  Murray Cumming  <murrayc@murrayc.com>

	Remove a nasty hack that would become a runtime bug.

	* glom/libglom/connectionpool_backends/sqlite.cc: Revert the previous
	hack by Johannes, which misused GLIBMM_EXCEPTIONS_ENABLE to
	avoid use of CONNECTION_OPTIONS_SQL_IDENTIFIERS_CASE_SENSITIVE. We will
	just update libgdamm on Maemo Fremantle instead.

2009-08-27  Murray Cumming  <murrayc@murrayc.com>

	Really never use config.h in libglom.

	* glom/libglom/*.cc: Remove some remaining includes of config.h
	instead of libglom_config.h.
	* glom/libglom/libglom_config.h.in: Add GETTEXT_PACKAGE,
	PACKAGE_TARNAME, though I suspect that libglom requires different
	build stuff for translations.
	Added POSTGRES_UTILS_PATH and EXEEXT.

2009-08-27  Murray Cumming  <murrayc@murrayc.com>

	Update NEWS and increase version.

	* NEWS:
	* configure.ac: Update in anticipation of a release.
	* regression_tests/test_signal_reemit.cc: Avoid an unused parameter
	warning.

2009-08-27  Johannes Schmid <jschmid@openismus.com>

	* glom/libglom/connectionpool_backends/sqlite.c:
	Fixed build issues on maemo platform

2009-08-26  Murray Cumming  <murrayc@murrayc.com>

	Fix a time parsing regression.

	* glom/libglom/libglom_config.h.in: Moved HAVE_STRPTIME here from
	config.h (which should maybe not be generated by autoheader),
	to the test_parsing_time regression.
	* glom/libglom/data_structure/iso_codes.cc: Include libglom_config.h
	instead of config.h, after moving ISO_CODES_PREFIX there.

2009-08-26  Murray Cumming  <murrayc@murrayc.com>

	Tests: Correct the return values.

	* regression_tests/test_parsing_time.cc:
	* regression_tests/test_signal_reemit.cc: Return EXIT_SUCCESS or
	EXIT_FAILURE properly.

2009-08-26  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: remove_quotes(): Implement this simply, just removing
	start and end quotes. However, I do not think this should be
	necessary:
	http://bugzilla.gnome.org/show_bug.cgi?id=593154

2009-08-25  Murray Cumming  <murrayc@murrayc.com>

	Comment out use of gda_sql_identifier_remove_quotes().

	* glom/base_db.cc: remove_quotes(): Comment out use of
	gda_sql_identifier_remove_quotes() with a stdcerr warning because
	it is deprecated and I get a weird undefined reference error and we
	need to change how we use this anyway. To fix the build.

2009-08-25  Johannes Schmid <jschmid@openismus.com>

	Fixed remaing maemo build problems

	* autogen.sh: Don't hardcode automake-1.10
	* glom/application.cc:
	* glom/base_db.cc:
	* glom/dialog_invalid_data.cc:
	* glom/filechooser_export.cc:
	* glom/glade_utils.cc:
	* glom/glade_utils.h:
	* glom/main.cc:
	* glom/utility_widgets/datawidget.cc:
	* glom/utility_widgets/imageglom:
	Fixed error handling of Gtk::Builder (change in gtkmm 2.14)

	* glom/mode_data/flowtablewithfields.cc:
	* glom/mode_data/flowtablewithfields.h:
	Fixed vfuncs problem

2009-08-21  Daniel Elstner  <danielk@openismus.com>

	Do not use .pyd extension on non-Windows systems

	* Makefile.am (pymod_ldflags): Set variable conditionally and use
	the "-shrext .pyd" option only on Windows hosts.

2009-08-21  Michael Hasselmann  <michaelh@openismus.com>

	* glom/libglom/connectionpool_backends/sqlite.cc: Fix typos to fix the build.
	Bug #592576

2009-08-21  Murray Cumming  <murrayc@murrayc.com>

	Document::get/set_connection_user(): Don't save this in the document.

	* glom/libglom/document/document.[h|cc]: get/set_connection_user():
	Document these as not being saved in the document, because it makes no sense
	to save a single user there, because Glom is a multi-user system.
	* glom/dialog_connection.cc: load_after(), save_before(): Don't save the user
	in the document.

2009-08-19  David King  <davidk@openismus.com>

	* glom.am:
	* libegg.am:
	* libglom.am:
	* tests.am: Remove unused .am files.
	* glom/libglom/test_document_with_layout.cc: Remove unused file,
	identical to glom/libglom/test_document.cc.
	* ChangeLog: Fix some formatting.

2009-08-04  Murray Cumming  <murrayc@murrayc.com>

	Rename included .am files.

	* *.am: Rename to Makefile_*.am so they are grouped together.
	* Makefile.am: Include the new filenames.

2009-07-31  Johannes Schmid <jschmid@openismus.com>

	* configure.ac: Add dependency on hildon-fmmm

	* glom/application.cc:
	* glom/utils_ui.cc: Comment out most hildon stuff for now

	* glom/bakery/app_withdoc.cc:
	* glom/bakery/app_withdoc_gtk.cc:
	* glom/xsl_utils.cc:
	Fix Gio exception handling

	* glom/base_db.cc:
	* glom/base_db_table_data.cc:
	* glom/dialog_existing_or_new.cc:
	* glom/dialog_import_csv.cc:
	* glom/dialog_invalid_data.cc:
	* glom/filechooser_export:
	* glom/glom_privs.cc:
	* glom/mode_data/box_data_calendar_related.cc:
	* glom/mode_data/box_data_details.cc:
	* glom/mode_data/box_data_portal.cc:
	* glom/mode_data/notebook_data.cc:
	* glom/reports/report_builder.cc:
	Fixed Gda exception handling, most notable and often get_value_at()

	* glom/glade_utils.h
	* glom/glade_utils.cc: Fixed GtkBuilder usage (though this seems to be a bug
	in Gtkmm)

	* glom/mode_data/flowtablewithfields.h:
	* glom/notebook_glom.cc:
	* glom/utility_widgets/flowtable.cc:
	* glom/utility_widgets/entryglom.cc:
	* glom/utility_widgets/imageglom.cc:
	* glom/utility_widgets/placeholder-glom.cc:
	* glom/utility_widgets/placeholder-glom.h:
	* glom/utility_widgets/dialog_image_progress.cc:
	Use signals instead of virtual methods, disable accesibility on maemo

	* glom/utility_widgets/canvas/*.cc: Use get/set_property() instead of the
	direct property access when properties are disabled

	* glom/utility_widgets/adddel/adddel.cc:
	* glom/utility_widgets/datawidget.cc:
	* glom/utiltiy_widgets/db_adddel/db_adddel.cc:
	* glom/utility_widgets/db_adddel/glom_db_treemodel.cc:

2009-07-30  Johannes Schmid <jschmid@openismus.com>

	* autogen.sh: Use automake-1.10 explicitly

	* glom/libglom/connectionpool.cc:
	* glom/libglom/connectionpool_backends/postgres.cc:
	* glom/libglom/data_structure/field.cc:
	* glom/libglom/data_structure/fieldtypes.cc:
	* glom/libglom/document/bakery/document.cc:
	* glom/libglom/python_embed/py_glom_relatedrecord.cc:
	* glom/libglom/spawn_with_feedback.cc:
	* glom/libglom/utils.cc:
	Fix exception and client-only related problems on maemo platform. Also
	fixed some TODOs that were related.

	In sum this allows to build glom master on maemo fremantle.

2009-07-28  Daniel Elstner  <danielk@openismus.com>

	Build and run tests on make check

	* Makefile.am (AM_DEFAULT_SOURCE_EXT): Make use of the Automake default
	_SOURCES feature for building single-source-file programs.
	(noinst_PROGRAMS): Move to tests.am.
	* tests.am (check_PROGRAMS): List all test executables here, so they
	are only built on make check.
	(TESTS): List unit test programs from the regression_tests/ directory.

2009-07-28  Daniel Elstner  <danielk@openismus.com>

	Use deprecated libtool macros for Maemo's sake

	* configure.ac (LT_PREREQ), (LT_INIT): Comment-out.
	(AC_PROG_LIBTOOL): Use old-style and deprecated M4 macro to initialize
	libtool because the Maemo development environment still ships with the
	ancient libtool 1.4.
	(AC_DISABLE_STATIC), (AC_LIBTOOL_WIN32_DLL): Call old-style macros to
	set libtool options, instead of passing flag arguments to LT_INIT().

2009-07-27  Murray Cumming  <murrayc@murrayc.com>

	ldtp tests: Correct the English in the error messages.

	* ldtp/common.py:
	* ldtp/database-creation/create-db.py:
	* ldtp/fields-edit/fields-edit.py: Correct the English in the error messages.

2009-07-27  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/dialog_image_progress.cc: on_stream_read(): Add casts
	to avoid compiler warnings, to fix distcheck.

2009-07-27  Murray Cumming  <murrayc@murrayc.com>

	Add more delay so that self-hosting does not fail sometimes.

	* glom/libglom/spawn_with_feedback.cc:
	execute_command_line_and_wait_until_second_command_returns_success(): Wait
	for extra 8 seconds instead of 3, so that postgresql startup has really
	finished. The delay was not enough since I removed the debug output, which
	was probably providing extra delay.
	This is unpleasant.

2009-07-25  Daniel Elstner  <danielk@openismus.com>

	List auto-generated files in MAINTAINERCLEANFILES

	* Makefile.am (MAINTAINERCLEANFILES): Clean up the macros/*.m4 files
	installed by autogen.sh, as well as the eggmarshalers.[ch] files.

2009-07-25  Daniel Elstner  <danielk@openismus.com>

	Pass --automake option to gnome-doc-prepare

	* autogen.sh: Invoke gnome-doc-prepare with the --automake option to
	tell it that Automake will take care of installing its macro files.

2009-07-25  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: get_fields_for_table_from_database():
	Use gda_meta_store_sql_identifier_quote() as mentioned in bug #589607
	to maybe make this work with uppercase in the table name.

2009-07-24  Daniel Elstner  <danielk@openismus.com>

	Assign copyright of my work to Openismus GmbH

	* configure.ac: Reassign the copyright which I had assigned to myself
	temporarily to Openismus GmbH instead, as I did the work in my position
	as an employee.
	* *.am: ditto,
	* macros/mm-python.m4: ditto.

2009-07-24  Daniel Elstner  <danielk@openismus.com>

	Split Makefile.am into logically separate parts

	* glom.am: New file for building the glom binary itself.
	* libglom.am: New file for building the libglom library.
	* libegg.am: New file for building the libegg static library.
	* tests.am: New file for building the test programs.
	* Makefile.am: Move logical chunks into the separate files listed
	above, and pull them in as Automake include files.

2009-07-24  Daniel Elstner  <danielk@openismus.com>

	Invoke gnome-doc-common from autogen.sh

	* autogen.sh: Execute "gnome-doc-common --copy" to install the files
	omf.make and xmldocs.make into the source tree.

2009-07-24  Daniel Elstner  <danielk@openismus.com>

	Use G_GSIZE_FORMAT instead of a cast

	* glom/libglom/python_embed/pygdavalue_conversions.c: Change format
	specifier for GType to "%" G_GSIZE_FORMAT and remove the explicit cast
	again.  I forgot that this is C code, so GType will always be gsize --
	at least with recent versions of GLib.

2009-07-24  Daniel Elstner  <danielk@openismus.com>

	Use format "%lu" for GType and add cast

	* glom/libglom/python_embed/pygdavalue_conversions.c: Change format
	specifier in g_warning() message back from "%u" to "%lu", and add an
	explicit cast to unsigned long.  Looks like GLib silently changed the
	type of GType from gulong to gsize, except when using a C++ compiler
	with a 64 bit target.  (Yes, really.)

2009-07-24  Daniel Elstner  <danielk@openismus.com>

	Suppress warning for missing field initializers

	* configure.ac (GLOM_WXXFLAGS): Add -Wno-missing-field-initializers to
	the warning options at level max or higher, so that the Python module
	code will build with both Python 2.5 and Python 2.6 without producing
	warnings.

2009-07-24  Murray Cumming  <murrayc@murrayc.com>

	Catch unknown command-line options.

	* glom/main.cc: Put try/catch around the Gtk::Main instantiation
	because I noticed that it throws an exception if you provide an
	unknown option.

2009-07-24  Murray Cumming  <murrayc@murrayc.com>

	Use CONNECTION_OPTIONS_SQL_IDENTIFIERS_CASE_SENSITIVE.

	* glom/libglom/connectionpool_backends/postgres.cc:
	* glom/libglom/connectionpool_backends/sqlite.cc: When calling
	Gda::Connection::open_from_string(), use the new
	CONNECTION_OPTIONS_SQL_IDENTIFIERS_CASE_SENSITIVE option so the libgda
	API really does what we mean without needing any weird quoting.

2009-07-23  Murray Cumming  <murrayc@murrayc.com>

	Fix the build with Python 2.5, bringing back the warnings for others.

	* glom/libglom/python_embed/py_glom_record.cc:
	* glom/libglom/python_embed/py_glom_related.cc:
	* glom/libglom/python_embed/py_glom_relatedrecord.cc:
	* glom/libglom/python_embed/pygdavalue_conversions.c: Remove the extra
	struct field initialization to fix the build with Python 2.5.

2009-07-23  Daniel Elstner  <danielk@openismus.com>

	Make libegg object files depend on eggmarshalers

	* Makefile.am ($(*libegg*_a_OBJECTS)): Make all object files of
	libeggutil.a and libeggtoolpalette.a depend on the generated source
	files eggmarshalers.[ch].  This ensures that the marshaler files are
	generated before any of the libegg objects are compiled, but avoids
	having to resort to BUILT_SOURCES for that purpose.
	(*_libeggtoolpalette_a_LIBADD): Remove dependency on libeggutil.a
	again, as it is not required for linking the static library itself.

2009-07-23  Daniel Elstner  <danielk@openismus.com>

	* Makefile.am (*_libeggtoolpalette_a_LIBADD): List libeggutil.a as
	dependency.

2009-07-23  Daniel Elstner  <danielk@openismus.com>

	* glom/bakery/app_withdoc.cc: Fix build with -Werror.
	* glom/dialog_import_csv.cc: ditto,
	* glom/libglom/python_embed/py_glom_record.cc: ditto,
	* glom/libglom/python_embed/py_glom_related.cc: ditto,
	* glom/libglom/python_embed/py_glom_relatedrecord.cc: ditto,
	* glom/libglom/python_embed/pygdavalue_conversions.c: ditto,
	* glom/mode_design/fields/dialog_fielddefinition.cc: ditto,
	* glom/utility_widgets/dialog_image_progress.cc: ditto.

2009-07-23  Daniel Elstner  <danielk@openismus.com>

	Switch to non-recursive build process

	* macros/mm-pkg.m4: New file, defining the MM_PKG_CONFIG_SUBST macro.
	* macros/mm-python.m4: New file, defining the MM_CHECK_MODULE_PYTHON
	macro to replace the old and messy AM_CHECK_PYTHON_HEADERS.
	* acinclude.m4: Remove file which defined AM_CHECK_PYTHON_HEADERS.

	* Makefile.am: Merge the contents of the Makefile.am files from all
	subdirectories into a single top-level Makefile.am, with the exception
	of docs/user-guide/Makefile.am.  Add the full subdirectory prefix to
	all listed files and change the Automake variable names accordingly.
	Get rid of the intermediate static libraries previously created for
	each source subdirectory, and list the source files directly in the
	toplevel target's SOURCES variable.  Overall, refactor and modernize
	the build rules and organization.
	* **/Makefile.am: Except for docs/user-guide/Makefile.am, remove the
	Makefile.am files recursively from all subdirectories.

	* config.h.in: Remove file, and use autoheader to generate it.
	* autogen.sh: Replace with a modern minimalistic script which lets
	autoreconf do the bulk of the work.
	* configure.ac: Massive refactoring.  Adapt to the new non-recursive
	build organization.  Modernize the M4 and shell code, and make use of
	newer Autoconf and Automake constructs to simplify many checks.  Also
	make minor corrections to a number of tests and definitions.

	* glom/application.cc: Remove the need for GLOM_ICON_DIR by setting
	the window icon by name instead of loading the image file directly.
	Use PACKAGE_VERSION in place of VERSION.
	* glom/dialog_existing_or_new.cc: Use a subdirectory of GLOM_DOCDIR
	in place of GLOM_EXAMPLES_DIR.  Remove GLOM_EXAMPLES_DIR_ALTERNATIVE.

	* glom/utils_ui.cc: Replace DATADIR by GLOM_DATADIR.
	* glom/libglom/connectionpool.cc: Remove GLOM_SAVE_DATADIR hack, which
	is not necessary anymore as DATADIR is not globally defined anymore.
	* glom/libglom/connectionpool_backends/postgres_self.cc: ditto,
	* glom/libglom/spawn_with_feedback.cc: ditto,
	* glom/main.cc: ditto. Also replace LOCALEDIR by GLOM_LOCALEDIR, and
	output PACKAGE_STRING instead of VERSION in response to the --version
	command-line option.  Replace PACKAGE and VERSION by their modern
	Automake equivalents.
	* glom/xsl_utils.cc: Remove GLOM_SAVE_DATADIR hack, and replace
	GLOM_XSLTDIR with a subdirectory of GLOM_PKGDATADIR.

	* glom/mode_data/box_data_calendar_related.cc: Replace GLOM_GLADEDIR
	by a combination of GLOM_PKGDATADIR and a subdirectory name.
	* glom/mode_design/print_layouts/print_layout_toolbar_button.cc: Use
	a subdirectory of GLOM_PKGDATADIR in place of GLOM_ICON_DIR.
	* glom/utility_widgets/layouttoolbar.cc: ditto,
	* glom/utility_widgets/layouttoolbarbutton.cc: ditto.

	* glom/python_embed/glom_python.cc: Include generated config.h for the
	definition of GLOM_ABI_VERSION_UNDERLINED.
	* glom/python_embed/python_module/py_glom_module.cc: ditto.

2009-07-22  David King  <davidk@openismus.com>

	* glom/libglom/glom-1.0.pc.in: Add libxml++ dependency, needed for
	Bakery headers.

2009-07-23  David King  <davidk@openismus.com>

	* glom/libglom/init.cc: Check that GThread is supported before calling
	Glib::thread_init(). This fixes a crash, as otherwise g_thread_init()
	can be called twice.

2009-07-22  Johannes Schmid  <jschmid@openismus.com>

	* configure.ac: Fixed typo with libepc

2009-07-21  David King  <davidk@openismus.com>

	* glom/libglom/glom-1.0.pc.in:
	* glom/libglom/*/Makefile.am: Use GLOM_ABI_VERSION in place of "1.0" so
	that installed headers go into the correct, ABI-specific directory.

2009-07-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/glom-1.0.pc.in: Remove the bakery dependency, because no part
	of Glom now depends on the bakery shared library.
	I suspect that libglom should depend on python somehow, but we will see.

2009-07-17  Murray Cumming  <murrayc@murrayc.com>

	Use an xmlns ID for the MIME-type registration.

	* glom/libglom/document/bakery/document_xml.[h|cc]: set_dtd_root_node_name():
	Take an optional xmlns ID and write this in the document.
	* glom/libglom/document/document.cc: Constructor: Specify a
	http://glom.org/glom_document xmlns ID. I don't think this needs to exist.
	This will make it easier for the MIME-type system to detect the file's MIME
	type.
	* glom.xml: (MIME-type detection rules): Add a root-XML rule, that checks
	for the xmlns and the root node name. We keep the string check too for
	legacy.

2009-07-10  Murray Cumming  <murrayc@murrayc.com>

	Export: Don't open the format dialog behind the FileChooser dialog.

	* glom/frame_glom.cc: on_menu_file_export(): Set the FileChooser dialog as
	transient so that the other dialog (opened from the FileChooser) is not
	behind the FileChooser.
	Ubuntu Launchpad bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/397409
	(elmergato)

2009-07-10  Murray Cumming  <murrayc@murrayc.com>

	Really save field changes again.

	* glom/libglom/document/document_glom.cc: set_table_fields():
	Avoid the broken attempt at optimization, so that field changes are always
	saved, for instance when changing them via the Field Definition dialog.
	Ubuntu Launchpad bug
	https://bugs.launchpad.net/ubuntu/+source/glom/+bug/394507
	(elmergato)

2009-07-10  Murray Cumming  <murrayc@murrayc.com>

	* glom/dialog_import_csv.cc: advance_field(): Do not skip characters after
	the ".

2009-07-10  Murray Cumming  <murrayc@murrayc.com>

	* glom/dialog_import_csv.cc: on_idle_parse(): Ignore newlines in quotes when
	dividing the input into "lines" to give to handle_line().

2009-07-10  Murray Cumming  <murrayc@murrayc.com>

	Import: Handle "" as ". Fix a crash.

	* glom/dialog_import_csv.[h|cc]: Use typedefs to simplify code.
	advance_field(): Handle "" (escaped ") inside quotes.
	field_data_func(): Avoid a crash if not enough data was found.

2009-07-09  Murray Cumming  <murrayc@murrayc.com>

	Import: " is the only quote character, as per the CSV RFC.

	* glom/dialog_import_csv.cc: advance_field(): Parse only " as
	start/end quotes, not ', as per the CSV RFC.

	Part of Ubuntu bug
	https://bugs.launchpad.net/ubuntu/+source/glom/+bug/394894
	(elmergato)

2009-07-08  Murray Cumming  <murrayc@murrayc.com>

	Correct the export to use the CSV format as per the RFC "specification".

	* glom/frame_glom.cc: export_data_to_stream(): For text fields, add
	" as per the CSV RFC.
	* glom/libglom/data_structure/field.cc: to_file_format(): Escape
	" as "". Note that we do not try to escape newlines. This is per the
	CSV RFC.
	* glom/libglom/utils.cc: string_replace(): In the loop, do not check
	what has already been processed, to avoid an infinite loop.

	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/394894
	(elmergato)

2009-07-07  Murray Cumming  <murrayc@murrayc.com>

	Catch libgda meta-store exceptions.

	* glom/base_db.cc: get_table_names_from_database():
	* glom/libglom/connectionpool.cc: connect(): Added try/catch around
	calls to Gda::Connection::update_meta_store_*() because they now
	throw a MetaStoreError exception, though we do not know why yet.

2009-07-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/dialog_existing_or_new.h: #include config.h to avoid a crash
	with the client-only build due to ABI code-size confusion.

2009-07-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.cc: init_menus_file(): Initialize
	m_toggleaction_network_shared to avoid a crash.

2009-07-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.cc:
	* glom/bakery/app_withdoc_gtk.[h|cc]: Remove the toolbar widget because
	we hide it anyway.

2009-07-05  Murray Cumming  <murrayc@murrayc-x61>

	* glom/application.cc: update_network_shared_ui(): Un-ifndef this for
	client-only.

2009-07-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/*.[h|cc]: Move some ifndefs around to fix the client-only build.

2009-07-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/document.cc: load_after(): Remove old code
	to check for developer mode in client-only builds.

2009-07-04  Murray Cumming  <murrayc@murrayc.com>

	Fix loading of the versioned python module.

	* configure.ac:
	* glom/Makefile.am:
	* glom/python_embed/Makefile.am:
	* glom/python_embed/glom_python.cc:
	* glom/python_embed/python_module/Makefile.am:
	* glom/python_embed/python_module/py_glom_module.cc:
	* glom/python_embed/python_module/py_glom_module.h: Use glom_1_12
	instead of glom-1.12 because - and . are not valid in python module
	names. I wish I knew of any standard way to do parallel install of
	different versions of python modules.

2009-07-04  Murray Cumming  <murrayc@murrayc.com>

	libglom: Remove use of GLOM_ENABLE_MAEMO because it is about UI.

	* glom/libglom/utils.cc:
	* glom/libglom/connectionpool.cc: Remove use of GLOM_ENABLE_MAEMO so
	because there should be no UI-specific login in libglom.
	* glom/libglom/document/document.[h|cc]: Remove
	get_active_layout_platform() because we no longer use GLOM_ENABLE_MAEMO.
	* glom/base_db.[h|cc]: Add a get_active_layout_platform(document)
	here instead.
	* glom/libglom/libglom_config.h.in: Moved GLOM_ENABLE_MAEMO to
	config.h.in because it is now only used in the app, not in libglom.

	* glom/base_db_table_data.cc:
	* glom/frame_glom.cc:
	* glom/mode_data/box_data.cc:
	* glom/mode_data/box_data_details.cc:
	* glom/mode_data/notebook_data.cc:
	* glom/relationships_overview/dialog_relationships_overview.cc:
	* glom/utility_widgets/adddel/adddel.cc:
	* glom/utility_widgets/datawidget.cc:
	* glom/utility_widgets/dialog_choose_id.cc:
	* glom/utils_ui.h:
	* glom/xsl_utils.cc: Adapted, using config.h instead of libglom_config.h

2009-07-04  Murray Cumming  <murrayc@murrayc-x61>

	libglom: Always enable developer-mode (!client-only) API.

	* glom/libglom/*.[h|cc]: Remove use of ENABLE_CLIENT_ONLY ifdefs,
	so we can allow parallel install of full and
	client-only versions.

2009-07-04  Murray Cumming  <murrayc@murrayc.com>

	Remove ifdefs from libglom to allow parallel install of sqlite- and
	PostgreSQL-using versions of Glom.

	* glom/libglom/connectionpool_backends/postgres.h:
	* glom/libglom/connectionpool_backends/postgres_central.h:
	* glom/libglom/connectionpool_backends/sqlite.h:
	* glom/libglom/document/document.[h|cc]:
	* glom/libglom/test_connectionpool.cc: Remove ifdefs that remove
	PostgreSQL or Sqlite API so that libglom always offers all features and
	always has the same ABI (ignoring no-exceptions/no-vfuncs
	alternative-glibmm-api versions). This will allow us to parallel install
	the full and client-only versions.

	* glom/libglom/libglom_config.h.in: Move GLOM_ENABLE_POSTGRESQL/SQLITE
	config.h.in because we now only use it in the application, not in libglom.
	* glom/application.cc:
	* glom/dialog_connection.cc:
	* glom/frame_glom.cc:
	* glom/utility_widgets/filechooserdialog_saveextras.cc:
	* glom/utility_widgets/filechooserdialog_saveextras.h:
	Include config.h to get these
	definitions.

2009-07-03  Murray Cumming  <murrayc@murrayc.com>

	Allow parallel installs of libglom major versions.

	* configure.ac: Define GLOM_ABI_VERSION as 1.12.
	* glom/Makefile.am:
	* glom/libglom/Makefile.am:
        * glom/python_embed/Makefile.am
	* glom/python_embed/python_module/Makefile.am:
	* regression_tests/Makefile.am: Add a 1.12 suffix to
	the libglom shared library name and the glom python module name.
	This must be changed in several places when the ABI version changes
	because we cannot use a variable in most of these places.
	Define it also as a macro for the .cc files, so Glom can import the
	correct version of the Glom python module
	- for instance, import glom-1.12.
	* glom/python_embed/glom_python.cc:
	* glom/python_embed/python_module/py_glom_module.cc: Import the
	correct version in python.

2009-07-03  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac:
	* glom/Makefile.am:
	* glom/libglom/Makefile.am:
	* glom/libglom/python_embed/Makefile.am:
	* glom/python_embed/glom_python.cc:
	* glom/python_embed/python_module/Makefile.am:
	* glom/python_embed/python_module/py_glom_module.cc:
	* ldtp/database-creation/create-db.py:
	* regression_tests/Makefile.am:

2009-09-30  Armin Burgmeier  <armin@openismus.com>

	* ldtp/fields-edit/fields-edit.py: Added a new test which tests adding
	a new field to an existing table. More operations to test, such as
	changing and removing existing fields, can be added later.

	* ldtp/fields-edit/postgres-central.xml:
	* ldtp/fields-edit/postgres-self.xml:
	* ldtp/fields-edit/sqlite.xml: XML Data files for the new test.

	* ldtp/test.xml: Added it to the test suite, so that it can be run
	with ldtprunner.

2009-06-28  Armin Burgmeier  <armin@openismus.com>

	* ldtp/database-templates/SQLite:
	* ldtp/database-templates/PostgresCentral: Added database templates
	for two of the three backends. These can be copied and then opened to
	have a database available for LDTP tests to test.

	* ldtp/common.py: Added create_test_database and delete_test_database
	functions which create or remove a database to test, from such a
	template database, respectively.

	* ldtp/database-creation/create-db.py: Use the delete_test_database
	function from common on cleanup, remove own delete_database function.

2009-06-30  Armin Burgmeier  <armin@openismus.com>

	* ldtp/database-creation/create-db.py: Changed the name of the created
	database table (for empty databases) to TestTable, so that we test
	that table names with capital letters work correctly.

2009-06-30  Armin Burgmeier  <armin@openismus.com>

	* glom/base_db.cc (get_fields_for_table_from_database): Make this work
	for table names which need quotation, and return unquoted field names.
	This fixes bug #587051.

2009-06-30  Murray Cumming  <murrayc@murrayc.com>

	get_table_names_from_database(): Remove quotes.

	* glom/base_db.cc: get_table_names_from_database(): Remove quotes when they
	are (sometimes) in the meta data. I complained on the gnome-db mailing list
	about us having to do this.

2009-06-29  Murray Cumming  <murrayc@murrayc.com>

	Allow many fields to be added to layouts (or the export format) at once.

	* glom/mode_data/dialog_choose_field.[h|cc]: Added get_fields_list() in
	addition to the existing get_field_list(), and allow multiple selection.
	* glom/base_db.[h|cc]: offer_field_list(): Rename to
	offer_field_list_select_one_field().
	Added offer_field_list() that returns a list of fields, allowing multiple
	selection.

	* *.[h|cc]: Adapted to use the appropriate function, allowing, for instance,
	the export dialog to use multiple selection to add many fields at once.

	Ubuntu Launchpad bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/393231
	(elmergato)

2009-06-29  Murray Cumming  <murrayc@murrayc.com>

	Export: Offer File overwrite confirmation.

	* glom/frame_glom.cc: on_menu_file_export():
	* glom/translation/window_translations.cc: on_button_export():
	Call Gtk::FileChooser::set_do_overwrite_confirmation() so the user is
	warned when overwriting a file.
	Ubuntu Launchpad bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/393229
	(elmergato)

2009-06-29  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/spawn_with_feedback.cc: ifdef out the debug output.

2009-06-29  Murray Cumming  <murrayc@murrayc.com>

	Reduce debug output.

	* glom/libglom/data_structure/glomconversions.[h|cc]:
	sanity_check_date_text_representation_uses_4_digit_years(): Make the debug
	output optional.
	* glom/main.cc: Added a --debug-date-check option, to avoid the debug out
	about 4-digit dates normally.

	* glom/dialog_existing_or_new.cc: list_examples_at_path(): Comment out debug
	output.
	* glom/libglom/connectionpool.cc: connect(): Comment out debug output that
	showed the (previously slow) meta update calls.

2009-06-28  Murray Cumming  <murrayc@murrayc.com>

	Print exception messages to stdout.

	* ldtp/database-creation/create-db.py: When catching the exception,
	print it to stdout, because it does not seem to appear in the log file.
	* ldtp/common.py: Corrected the English of some exception messages.

2009-06-28  Murray Cumming  <murrayc@murrayc.com>

	Fix an error check.

	* glom/xsl_utils.cc: transform_and_open(): Fix the check for a failed
	gtk_show_uri(), so we really check. Noticed while stealing this code
	for vidrot.

2009-06-27  Armin Burgmeier  <armin@openismus.com>

	* ldtp/database-creation/postgres-central-empty.xml:
	* ldtp/database-creation/postgres-self-empty.xml:
	* ldtp/database-creation/sqlite-empty.xml: Added missing files.

	* ldtp/database-creation/create-db.py: Allow passing the datafilename
	as an argument when the script is called directly, not by ldtprunner.

	* ldtp/README: Updated the section on how to execute a single test
	script.

2009-06-26  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/document/bakery/document.h: Document that failure_code
	should be >= 1, so that we can detect whether the document could not
	be opened because it couldn't be read from disk, or a custom error
	code was set.

	* glom/libglom/document/document.h: Set the value of
	LOAD_FAILURE_CODE_FILE_VERSION_TOO_NEW to 1, to honor the requirement
	explained above. This fixes showing the wrong error message when the
	document could not be loaded from disk.

2009-06-26  Armin Burgmeier  <armin@openismus.com>

	* glom/application.cc (existing_or_new_new): When the new database
	could be created successfully, then add the document to the recent
	files list.

2009-06-26  Armin Burgmeier  <armin@openismus.com>

	* glom/frame_glom.cc
	(connection_request_password_and_choose_new_database_name): Remember
	the port also for centrally hosted documents when a successful
	connection could be made.

	* ldtp/database-creation/create-db.py: For empty documents, call the
	initial table 'test_table', not 'TestTable', because of bug #587051.

2009-06-26  Armin Burgmeier  <armin@openismus.com>

	* glom/dialog_glom.h:
	* glom/dialog_glom.cc: Added an optional second parameter to the
	constructor, to specify a title name for the dialog.

	* glom/frame_glom.cc: Set the title of the tables dialog to "Tables",
	so that it can be accessed via LDTP.

	* glom/glom.glade: Also change the title of that dialog, even though
	it's not used, since only the window's child widget is loaded from the
	glade file.

	* glom/utility_widgets/adddel/adddel.h:
	* glom/utility_widgets/adddel/adddel.cc: Added a
	set_treeview_accessible_name() function, to set the accessible name of
	the AddDel's TreeView.

	* glom/navigation/box_tables.cc: Set an accessible name for the
	TreeView, to be able to access it via LDTP.

	* glom/utility_widgets/filechooserdialog_saveextras.cc: Set an
	accessible name for the database title text entry.

	* ldtp/common.py (select_backend): Added a dialog_title parameter, as
	the dialog has a different title when creating a new, empty document.
	(wait_for_database_open): Rely on the database title being 'Test', not
	'Small Business Example'.

	* ldtp/database-creation/create-db.py: Change the database title of
	the newly created database to 'Test'. Support creating new, empty
	documents, and reopen the document after it has been closed, to make
	sure the document has been saved correctly.

	* ldtp/database-creation/postgres-central-example.xml:
	* ldtp/database-creation/postgres-self-example.xml:
	* ldtp/database-creation/sqlite-example.xml: Moved from the files
	without -example, set the <example> tag to 1.

	* ldtp/database-creation/postgres-central-example.xml:
	* ldtp/database-creation/postgres-self-example.xml:
	* ldtp/database-creation/sqlite-example.xml: Same with <example> set
	to 0.

	* ldtp/test.xml: Added the three new files which create an empty
	document instead of creating one from the Small Business Example.

2009-06-24  Armin Burgmeier  <armin@openismus.com>

	* ldtp/common.py: Work around bug #586291, added a function to enter
	the connection credentials into the connection dialog if using a
	centrally hosted database. Added mapping of backend name to button
	texts in the database creation dialog.

	* ldtp/database-creation/postgres-central.xml:
	* ldtp/database-creation/postgres-self.xml:
	* ldtp/database-creation/sqlite.xml: Removed the button texts from
	the data XML files.

	* ldtp/database-creation/create-db.py: Generalized the script so that
	it also handles central hosting. Delete the newly created centrally
	hosted database at the end. This requires pygda from git for now.

	* ldtp/database-creation/create-central-db.py: Removed, as central
	hosting is also handled by create-db.py now.

2009-06-24  Armin Burgmeier  <armin@openismus.com>

	* glom/glom.glade: Added a title to the connection dialog window, and
	added accessible names for the entries, to be able to use them via
	LDTP.

	* ldtp/README: Describe how to set the login credentials required
	to test creating a centrally hosted database.

	* ldtp/common.py: Moved useful code from
	ldtp/database-creation/create-db.py into functions in this file, so
	other tests can use them, too.

	* ldtp/database-creation/create-db.py: Adapt accordingly.

	* ldtp/database-creation/create-central-db.py:
	* ldtp/database-creation/postgres-central.xml: Added a new test script
	and data XML which tests creating a centrally hosted database.

	* ldtp/test.xml: Added the new script file.

2009-06-24  Armin Burgmeier  <armin@openismus.com>

	* glom/application.cc (on_document_load): Only provide a known user
	name and password for self-hosted databases, and ask the user for the
	database password for centrally-hosted ones.

	* glom/frame_glom.cc (connection_request_password_and_attempt): Show
	the connection dialog for centrally hosted connections, and fix trying
	to login with the same (wrong) credentials all the time without giving
	the user a chance to correct them. This fixes bug #586684.

2009-06-22  Armin Burgmeier  <armin@openismus.com>

	* glom/application.cc (on_document_load): If we load an example file,
	set the connection port in the document to 0, and enable trying other
	ports, instead of using the (arbitrary) values from the example file.
	This allows trying out various standard ports for postgresql when
	centrally-hosting the document and fixed creating a centrally-hosted
	database from an example file.

	* glom/dialog_connection.cc (connect_to_server_with_connection): On a
	successful connection, set try other ports to false in the document,
	as we found a working port and don't need to try all the other ports
	next time.

	* glom/frame_glom.cc
	(connection_request_password_and_choose_new_database_name): When
	creating a centrally-hosted database, remember the user name in the
	document, to be able to connect to the database from the saved
	document later. Actually, we would also need to save the password to
	do this correctly, though I wonder whether it's a good idea to save
	the user's database password in the .glom file.

2009-06-22  Armin Burgmeier  <armin@openismus.com>

	* glom/frame_glom.cc:
	(connection_request_password_and_choose_new_database_name): Fixed a
	mistyped #ifdef, so that creating a centrally-hosted database does not
	lead to a crash.

2009-06-20  Armin Burgmeier  <armin@openismus.com>

	* ldtp/database-creation/create-db.py: Read the data what backend to
	use from the a data XML file, instead of as a function's argument.

	* ldtp/database-creation/self-hosted.py:
	* ldtp/database-creation/sqlite.py: So we don't need these anymore.

	* ldtp/database-creation/postgres-self.xml:
	* ldtp/database-creation/sqlite.xml: Instead, the data is specified in
	these data XML files.

	* ldtp/test.xml: Adapt accordingly.

2009-06-17  Armin Burgmeier  <armin@openismus.com>

	* ldtp/README: Added a README file explaining how to run the tests.

2009-06-17  Armin Burgmeier  <armin@openismus.com>

	* ldtp/common.py: Added a common function to launch glom and wait for
	its windows to appear into a new separate python script file.

	* ldtp/database-creation/create_db.py: Added a function to create a
	new database, with the backend to use as an argument. This allows to
	reuse the existing code to test other backends.

	* ldtp/database-creation/self-hosted.py: Adapted accordingly.

	* ldtp/database-creation/sqlite.py: Added a test file to check whether
	SQLite database creation works.

	* ldty/test.xml: Added the test to create an SQLite database.

2009-06-08  Armin Burgmeier  <armin@openismus.com>

	* ldtp/database-creation/self-hosted.py: Added a LDTP test script
	which checks creation of a new self-hosted database from the Small
	Business Example file.

	* ldtp/test.xml: Added an XML file for ldtprunner. Run "ldtprunner
	test.xml" to execute the test.

2009-06-08  Armin Burgmeier  <armin@openismus.com>

	* glom/utility_widgets/db_adddel/db_adddel.cc: Added an accessible
	name for the TreeView.

	* glom/utility_widgets/imageglom.h:
	* glom/utility_widgets/imageglom.cc:
	* glom/utility_widgets/entryglom.h:
	* glom/utility_widgets/entryglom.cc: Set an accessible name, based on
	the layout item's name.

2009-06-08  Armin Burgmeier  <armin@openismus.com>

	* glom/utility_widgets/layoutwidgetbase.cc: Initialize m_pLayoutItem
	in client only mode, to avoid an uninitialized pointer in that case.

2009-06-04  Murray Cumming  <murrayc@murrayc.com>

	Show a specific error message when the flie format is too new.

	* glom/libglom/document/bakery/document.[h|cc]:
	* glom/libglom/document/bakery/document_xml.[h|cc]: load(),
	load_after(): Take a int& failure_code output parameter to allow
	derived document classes to report a custom failure code.
	* glom/libglom/document/document.[h|cc]: load_after(): Return a
	custom failure_code for a too-new file version.
	* glom/bakery/app_withdoc.[h|cc]:
	Add a virtual ui_warning_load_failed(int failure_code) method that
	derived classes can override to respond to their own failure codes,
	with a generic default error message.
	open_document(), open_document_from_data(): Use the new method instead
	of hard-coding the error message.

	* glom/application.[h|cc]:
	open_browsed_document(), on_menu_developer_changelanguage(): Adapt.
	Add an override of ui_warning_load_failed() to show
	our custom error dialog in response to our custom failure code.
	* glom/libglom/test_document.cc: Apapted.

	Exceptions might be purer and need less code changes, but they would
	just be a container for an int failure code and it would be easier to
	not catch the error.
	This fixed bug #567102.

2009-06-04  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/layout/layoutitem_portal.cc:
	get_navigation_relationship_specific(): Remove unnecessary this-> to
	be consistent with the rest of the code.

2009-06-04  Murray Cumming  <murrayc@murrayc.com>

	Related records portal: Hide the row button when navigation is none.

	* glom/libglom/data_structure/layout/layoutitem_portal.h:
	Add documentation for get/set_navigation_relationship_specific(),
	get/set_navigation_type() and the enum.

	* glom/mode_data/box_data_list_related.cc: enable_buttons():
	Disable editing of details when the portal has NAVIGATION_NONE.
	* glom/utility_widgets/db_adddel/db_adddel.cc:
	construct_specified_columns(): Set the button column visibility
	according to the member variable set in set_allow_view_details(),
	because the button column often does not exist when that is actually
	called.
	This completes bug #574360.

2009-06-04  Murray Cumming  <murrayc@murrayc.com>

	Update the DTD for portal navigation and save space in XML.

	* glom/glom_document.dtd: Update for the portal navigation changes,
	as promised in bug #574360
	* glom/libglom/document/document.cc: save_before_layout_group():
	Do not even create the portal_navigation_relationship node if it is the
	default ("automatic"), to save space in the XML file.

2009-06-04  Murray Cumming  <murrayc@murrayc.com>

	Clean up the code to load/save portal navigation options.

	* glom/libglom/document/document.cc: load_after_layout_group():
	Loading the portal's navigation options: Use == instead of
	ustring::compare() because this is not C.
	Explicitly default to automatic, removing the comment about defaulting
	to the default in the Portal's class to preserve the deprecated file
	format. This is more obvious.
	save_before_layout_group(): Simplify the code.
	Do not write GLOM_ATTRIBUTE_PORTAL_NAVIGATIONRELATIONSHIP_MAIN because
	a) It is deprecated (should be read but not written) and b) It is not
	read or used anywhere else anyway.
	Use constants for the possible attribute values, instead of copy/pasting
	the same string constants in several places.

2009-06-04  Murray Cumming  <murrayc@murrayc.com>

	Store script module code in child text nodes.

	* glom/libglom/document/document.cc: load_after(), save_before():
	Store the (importable) python script library modules in a child text
	node instead of an attribute, as we do elsewhere, dealing with a TODO
	that I found in the DTD.
	* glom/glom_document.dtd: Update appropriately.

1.11.0:

2009-06-01  Murray Cumming  <murrayc@murrayc.com>

	Remove ifdefs for disabled gtkmm vfuncs.

	* glom/mode_data/flowtablewithfields.cc:
	* glom/utility_widgets/db_adddel/cellrenderer_buttonimage.cc:
	* glom/utility_widgets/db_adddel/cellrenderer_buttonimage.h:
	* glom/utility_widgets/db_adddel/cellrenderer_buttontext.cc:
	* glom/utility_widgets/db_adddel/cellrenderer_buttontext.h:
	* glom/utility_widgets/db_adddel/db_adddel_withbuttons.cc:
	* glom/utility_widgets/db_adddel/db_adddel_withbuttons.h:
	* glom/utility_widgets/db_adddel/glom_db_treemodel.cc:
	* glom/utility_widgets/db_adddel/glom_db_treemodel.h:
	* glom/utility_widgets/flowtable.cc:
	* glom/utility_widgets/flowtable.h: Remove ifdefs for disabled gtkmm vfuncs,
	because they are now enabled in Maemo 5 (Fremantle).

2009-05-29  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool.cc: After invalidating a cached
	connection, disconnect from the cached connection's "finished" signal,
	to prevent the signal handler from being called later (other code
	might still have a reference to the connection at the
	invalidate_connection point). Also added a TODO comment, because this
	can still happen in rare cases. This fixes initial records not being
	shown after creating a database from an example file.

2009-05-27  Armin Burgmeier  <armin@openismus.com>

	* glom/mode_data/notebook_data.cc: Added an accessible name for the
	notebook, so that it can be accessed via LDTP.

2009-05-28  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Remove the mention of the eggcolumnchooser subdirectory, to
	fix the build.

2009-05-26  Armin Burgmeier  <armin@openismus.com>

	* glom/glom.glade: Added a window title to the initial dialog, and
	accessible names for the two tree views in it, so they are easily
	accessible from LDTP.

2009-05-25  Armin Burgmeier  <armin@openismus.com>

	* glom/dialog_existing_or_new.cc (constructor): Create the top level
	list elements before setting the cell data func, to avoid the cell
	data func being called before all the list elements have been added.
	This happended when Glom was launched via LDTP, leading to a crash.

2009-05-20  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/backend.h:
	* glom/libglom/connectionpool_backends/postgres.h:
	* glom/libglom/connectionpool_backends/sqlite.h: Added
	get_public_schema_name() virtual function and implementations for both
	backends.

	* glom/libglom/connectionpool.cc: Only update the meta store tables
	for the public schema of the corresponding backend. This considerably
	speeds up the initial meta store update. This requires latest libgdamm
	from git.

2009-05-10  Murray Cumming  <murrayc@murrayc.com>

	Disables the Open button next to ID fields if the field is empty.

	* glom/utility_widgets/datawidget.[h|cc]:
	Added private update_go_to_details_button_sensitivity() method and
	called it whenever the value is changed by the user or set via
	set_value(). Fixes bug #565023.

2009-05-07  Murray Cumming  <murrayc@murrayc.com>

	Allow non-network-shared connections when using IPv6.

	* glom/libglom/connectionpool_backends/postgres_self.cc:
	DEFAULT_CONFIG_PG_HBA_LOCAL: Add an entry in IPv6 syntax, because
	something seems to be more IPv6-like in Ubuntu Jaunty.

2009-05-07  Murray Cumming  <murrayc@murrayc.com>

	Pass some sharedptr&s as const.

	* glom/utility_widgets/flowtable_dnd.h: on_dnd_add_layout_item()
	* glom/mode_data/flowtablewithfields.[h|cc]: on_dnd_add_layout_item(),
	on_entry_edited(), on_entry_open_details_requested(),
	on_dnd_add_layout_item(): Pass the sharedptr& as const.

2009-05-07  Murray Cumming  <murrayc@murrayc.com>

	Fixed minor compiler warnings and removed some virtuals.

	* glom/mode_data/flowtablewithfields.h: Made methods non-virtual where
	the virtual is unnecessary and misleading.

	* glom/utility_widgets/adddel/eggcolumnchooser/: Removed.
	* several: Fixed minor compiler warnings.

2009-05-07  Armin Burgmeier  <armin@arbur.net>

	* glom/glom.glade:
	* glom/utility_widgets/dialog_image_progress.h:
	* glom/utility_widgets/dialog_image_progress.cc:
	* glom/utility_widgets/Makefile.am: Added a dialog which loads an
	image and shows progress of the operation.

	* glom/utility_widgets/imageglom.h:
	* glom/utility_widgets/imageglom.cc: Use this dialog when the user
	selects an image to load, to indicate progress for large images.

2009-05-05  Armin Burgmeier  <armin@arbur.net>

	* glom/libglom/sharedptr.h: Added operator!=.

	* glom/mode_data/flowtablewithfields.h:
	* glom/mode_data/flowtablewithfields.cc: Added set_other_field_value
	which is the same as set_field_value except that it does not set the
	value for widget that belongs to the passed layout item's widget
	itself. This can be used if that very widget already contains the new
	value to avoid setting it again. Especially when dealing with large
	images this brings an essential speedup.

	* glom/mode_data/box_data_details.cc (on_flowtable_field_edited): Use
	set_other_field_value, so that we don't set the value for the field
	which the user already changed again.

	* glom/utility_widgets/imageglom.h:
	* glom/utility_widgets/imageglom.cc: Store the original data of the
	image file, and return it in get_value(), instead of creating a PNG
	from the raw image data, to speed up loading a large image file.

	* glom/utils_ui.cc (get_pixbuf_for_gda_value): When loading images
	from the database, allow all image types, not just PNGs.

	* glom/xsl_utils.cc: Include gtk/gtk.h to fix the build for me.

2009-04-24  Murray Cumming  <murrayc@murrayc.com>

	Don't network share new documents from (old) examples.

	* glom/libglom/document/document.cc: load_after(): Only assume network-sharing
	for older documents if it's not an example, so we don't have to resave all the
	examples.

2009-04-23  Murray Cumming  <murrayc@murrayc.com>

	Fix loading of old self-hosted files, broken since defaulting to no sharing.

	* glom/libglom/document/document.cc:
	get_latest_known_document_format_version(): Increase the number because we
	have added nodes/attributes.
	load_after(): For older document formats, read network_sharing as on if it
	is false (not mentioned).

2009-04-23  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.cc: on_document_load(): Avoid false unexpected error warning.

2009-04-22  Michael Hasselmann  <michaelh@openismus.com>

	Allow to disable navigation in the related record layout.

	* glom/libglom/data_structure/layout/layoutitem_portal.[h|cc] ctor(),
	[set|get]_navigation_relationship_specific(), [set|get]_navigation_type(),
	set_navigation_type(): Replaced the flag for whether a specific navigation
	relationship should be used with an enum type, since we now have an
	additional state (no navigation relationship) in the Glom::LayoutItem_Portal
	class. Additionally, this internal state no longer needs to be exported so
	[set|get]_navigation_relationship_specific() can now be called without
	supplying a boolean output parameter.
	* glom/libglom/document/document.cc load_after_layout_group(),
	save_before_layout_group(): Added load and save support for the
	no-navigation-relationship option.
	* glom/mode_data/box_data_portal.cc get_suitable_table_to_view_details():
	Return an empty table name if the navigation relationship type was set to
	none.
	* glom/mode_data/dialog_layout_list_related.[h,cc] ctor(), update_ui(),
	save_to_document(), glom/glom_developer.glade: Insert a third choice ("none")
	for the navigation radio buttons.
	* glom/mode_data/dialog_layout_calendar_related.cc update_ui(),
	save_to_document(): Replaced calls to
	LayoutItem_Portal::[set|get]_navigation_relationship_specific() that still
	used a boolean output parameter.
	Bug #574360.

2009-04-17  Murray Cumming  <murrayc@murrayc.com>

	Makes navigation work to alternate specified relationships.

	* glom/mode_data/flowtablewithfields.cc: on_portal_user_requested_details():
	Don't default to navigating to just the immediate related table. Instead,
	always use the navigation options, by always calling
	LayoutItem_Portal::get_suitable_record_to_view_details().
	Bug #579172 (Michael Hasselmann)

2009-04-11  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: add_standard_groups(): Give the developer group
	SUPERUSER rights, fixing a problem in another patch I am working on.
	I am surprised that this was not a problem before - maybe because the
	user (instead of the group) always had superuser rights via the
	command line database initialization.

2009-04-10  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.[h|cc] init_menus_file(): Add a File/Share On Network
	toggle menu item. Added update_network_shared_ui() to ensure that it
	is checked when appropriate.
	open_browsed_document(), on_document_load():
	Call update_network_shared_ui().
	* glom/frame_glom.[h|cc]: on_menu_file_toggle_share(): Handle the
	new menu item, to change the configration and restart the server.

	* glom/libglom/document/document.cc: Added set_network_shared(),
	get_network_shared(). load_after(), save_before(): Save it in the
	document. This is the default that will be used when opening a document.
	It defaults to not shared.
	* glom/glom_document.dtd: Document the new network_shared XML attribute.

	* glom/libglom/connectionpool.[h|cc]: get_and_connect(): Only start avahi
	publishing if we are shared on the network.
	set_network_shared(): Added this private function to change the configuration.
	initialize(), startup(): Added network_shared parameter.
	cleanup(): Call invalidate_connection() to prevent use of a connection
	to a stopped server.,
	* glom/libglom/connectionpool_backends/backend.[h|cc]: initialize,
	  startup, set_network_shared(): Same change as for ConnectionPool.
	* glom/libglom/connectionpool_backends/postgres_self.[h|cc]:
	initialize(): set_network_share(): Move config file writing to
	set_network_share() and use different pg_hba.conf contents depending on
	whether we are shared on the network.
	startup(): Ensure that the configuration is correct.

2009-04-09  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool.cc: get_and_connect(): Check that
	m_backend is not null, to avoid a critical warning at startup.

2009-04-09  Murray Cumming  <murrayc@murrayc.com>

	* glom/python_embed/glom_python.[h|cc]:
	Added glom_python_module_is_available() and
	gda_python_module_is_available().
	* glom/main.cc: Use them to do some extra runtime sanity checking,
	warning the user if their install is broken.

2009-04-09  Michael Hasselmann <michaelh@openismus.com>

	Fix crash if "Connect to Server" is cancelled and then a document is opened.

	* glom/libglom/connectionpool_backends/backend.h:
	Introduced new error code FAILURE_NO_BACKEND which shall be used to
	detect logical errors in the backend implementations.
	* glom/libglom/connectionpool_backends/postgres_self.cc (connect):
	Set error correctly if no self-hosted instance is active.
	* glom/libglom/connectionpool.cc (connect, cleanup):
	Added a g_return_val_if_fail to check whether there is a backend to
	connect to. Also reset m_ready_to_connect flag to false during
	cleanup, which stops Glom from behaving funnily if the user supplies
	wrong credentials (see bug #577821):
	- The user enters wrong credentials, gets a 'Connection failed' dialog
	  the first time. Then, enters wrong credentials a second time, gets no
	  dialog (but gets dialog for next try and so on).
	- Glom would crash if the user tried to open another document, then decides
	  to abort and only opens another document (much) later (which would
	  look like a random crash then).
	The ConnectionPool class could perhaps be made more robust concerning
	that flag since it currently allows inconsistent states.

2009-04-05  Philip Withnall  <philip@tecnocode.co.uk>

	* glom/libglom/data_structure/glomconversions.cc: Add
	xgettext:no-c-format to a string used with strftime which gettext is
	erroneously marking as c-format. (Closes: #578013)

2009-04-03  Murray Cumming  <murrayc@murrayc.com>

	* glom/frame_glom.cc: connection_request_password_and_attempt():
	When the password fails, just loop around the while again to ask again,
	instead of showing a one-off extra dialog. That fixes the problem of being
	asked twice when the first try failed.
	Load the document outside of the while() instead of each time we ask for the
	password.

2009-04-02  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/postgres_self.cc
	(discover_first_free_port): Fixed the logic in this function to allow
	two different glom instances to self-host a database at the same time.

2009-03-31  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: get_fields_for_table_from_database(): Use the libgda
	metastore API (almost as nasty as the schema API) to get the primarykeyness,
	because the schema API does not give us this, for no good reason that I can
	see. Anyway, it works, allowing us to use pre-existing databases.

2009-03-31  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/document_glom.[h|cc]: Renamed to document.[h|cc]:
	* *.[h|cc]: Adapted.

2009-03-31  Murray Cumming  <murrayc@murrayc.com>

	* Renamed Document_Glom to Document, and type_vec* to type_vec_* in all
	lower case, to make the API more consistent.

2009-03-31  Murray Cumming  <murrayc@murrayc.com>

	* config.h.in: Remove definitions that are in
	glom/libglom/libglom_config_h.in
	* configure.ac: Depend on pygobject instead of pygtk and remove duplicate
	dependencies in Glom and libglom.
	* glom/libglom/document/document_glom.h: Remove SWIG directives because I
	am now using a separate SWIG .i file.
	* po/POTFILES.in: Updated.

2009-03-30  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/Makefile.am:
	* glom/libglom/init.[h|cc]: Added this file with libglom_init() and
	libglom_deinit(), containing some code that was in main(). This allows
	code other than Glom to use libglom.
	* glom/main.cc: Call the new functions, replacing some code.
	* glom/libglom/test_document.cc: Call the new functions.

2009-03-30  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Remove the gtkmm dependency from libglom.

	* glom/libglom/Makefile.am:
	* glom/bakery/Makefile.am:
	* glom/libglom/busy_cursor.[h|cc]: Moved this to glom/bakery/.

	* glom/libglom/data_structure/glomconversions.[h|cc]:
	Moved get_pixbuf_for_gda_value() to glom/utils_ui.[h|cc].

	* glom/libglom/*.[h|cc]: Adapted, and removed any gtkmm or gdkmm headers.

2009-03-30  Murray Cumming  <murrayc@murrayc.com>

	* glom/glade_utils.cc: Added missing file to fix the build.

	* glom/Makefile.am:
	* glom/libglom/Makefile.am:
	* glom/libglom/utils.cc:
	* glom/libglom/utils.h: Moved some of these functions to new
	glom/utils_ui.[h|cc] files to avoid having the UI stuff in libglom.
	*.cc: Adapted.

	* glom/libglom/connectionpool.[h|cc]:
	* glom/libglom/connectionpool_backends/backend.[h|cc]:
	* glom/libglom/connectionpool_backends/postgres.[h|cc]:
	* glom/libglom/connectionpool_backends/postgres_self.[h|cc]:
	initialize(): Return an enum instead of a bool, to report errors, instead of
	showing a UI warning here.
	Added set_avahi_publish_callbacks() to avoid showing that UI here.
	* glom/frame_glom.[h|cc]: Adapt to the new API, showing UI here instead of
	in libglom.

	* glom/libglom/spawn_with_feedback.cc: Disconnect the progress timeout
		handlers.

	* glom/libglom/data_structure/layout/layoutitem_image.[h|cc]: Removed
	get_image_as_pixbuf() to avoid a gtkmm dependency in libglom. Made m_image
	public instead, to avoid performance problems with copying lots of binary
	data via a get*() method.
	* glom/libglom/document/document_glom.cc: Adapted.

	* glom/libglom/data_structure/print_layout.[h|cc]: Use a string instead of a
	Gtk::PrintLayout, using the Glib::KeyFile format, to avoid depending on gtkmm
	in libglom.
	* glom/mode_design/print_layouts/canvas_layout_item.cc:
	* glom/mode_design/print_layouts/canvas_print_layout.cc: Adapted.

2009-03-27  Murray Cumming  <murrayc@murrayc.com>

	* glom/bakery/app_withdoc.[h|cc]: Added on_document_close() virtual method
	now that we can break this ABI.
	* glom/application.[h|cc]: Override on_document_close().
	* glom/libglom/document/document_glom.cc: Destructor: Don't shutdown the
	database here. Do in App_Glom::on_document_close() instead.

	* glom/libglom/Makefile.am:
	* glom/libglom/spawn_with_feedback.[h|cc]: execute_command_line_and_wait(),
	  execute_command_line_and_wait_until_second_command_returns_success():
	  Take a SlotProgress callback instead of a parent window, and don't take
	  a human-readable message string to show, allowing the caller to show UI if
	  it wants, removing UI code from this part of libglom.
	  Use a Glib::MainLoop to block instead of using the Gtk::Main in
	  Gtk::Dialog::run().
	* glom/libglom/connectionpool.[h|cc]: initialize(), startup, cleanup():
	* glom/libglom/connectionpool_backends/backend.[h|cc]: initialize(),
	  startup(), cleanup():
	* glom/libglom/connectionpool_backends/postgres_self.cc: initialize(),
	startup, cleanup(): Take a SlotProgress callback instead of a parent window,
	allowing the caller to show UI if it wants, removing UI code from this part of
	libglom.

	* glom/Makefile.am:
	* glom/libglom/dialog_progress_creating.[h|cc]: moved to
	* glom/glom/glade_utils.[h|cc]: Moved get_and_show_pulse_dialog() here.

	* glom/dialog_new_self_hosted_connection.[h|cc]:
	* glom/frame_glom.[h|cc]:
	connection_request_password_and_choose_new_database_name(),
	connection_request_password_and_attempt(): Adapted.

2009-03-27  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac, glom/libglom/*/Makefile.am: Do two separate
	PKG_CONFIG_MODULE() checks for Glom and libglom to avoid unnecessary
	dependencies in libglom.
	* Moved libglom/glade_utils.h to glom/libglom/glade_utils.h.
	* *.[h|cc]: Some incomplete improvement of includes, to use full paths, to
  make search/replace refactoring easier.

2009-03-26  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Depend on the latest goocanvasmm for the new API.
	* glom/libglom/document/bakery/Makefile.am:
	* glom/libglom/document/bakery/view/Makefile.am: Install the headers as in
	the other directories.
	* glom/libglom/document/document_glom.h: Tell SWIG to add using Glom because
	it gets confused about the namespace.

2009-03-26  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac:
	* macros/macros.m4: Removed this.
	* macros/dk-warn.m4: Added this, which is the updated version.
	* glom/*/*.am
	* glom/*/*.cc: Fixed some warnings.

2009-03-26  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/canvas/canvas_table_movable.[h|cc]: get_xy(),
	set_xy(): Use the new height property instead of faking it.

2009-03-25  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/canvas/canvas_line_movable.cc: get_xy(),
	set_xy(), get_width_height(), set_width_height():
	* glom/utility_widgets/canvas/canvas_text_movable.cc
	get_width_height, set_width_height(): Use the new properties instead
	of our custom implementations.

2009-03-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/main.cc: Stop the mainloop when the window is hidden, and then
	delete it. I think this was done by AppInstanceManager before.

2009-03-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/bakery/:
	* glom/libglom/document/bakery/: Rename the files to make them lower
	case just because the inconsistency has always annoyed me.
	* glom/*.[h|cc]: Adapted.

2009-03-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/document_glom.h: Added a SWIG hint telling it how to
	include this header.

2009-03-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/bakery/Document.h:
	* glom/libglom/document/bakery/Document_XML.h: Removed more unnecessary
	virtuals.

2009-03-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.[h|cc]: Remove add_ui_from_string() because it is
	in App_WithDoc_Gtk too.
	* glom/bakery/App_WithDoc_Gtk.h: Make init_menus_file_recentfiles()
	non virtual because nothing overrides it.

2009-03-24  Murray Cumming <murrayc@murrayc.com>

	* glom/bakery/Makefile.am:
	* glom/bakery/App_WithDoc.h:
	* glom/bakery/App_Gtk.[h|cc]: Remove this, merging it into:
	* glom/bakery/App_WithDoc_Gtk.[h|cc]: allowing us to remove some
	awkward virtual inheritance.
	* glom/bakery/Dialog_OfferSave.cc:
	* glom/application.cc:
	* glom/utility_widgets/adddel/adddel.cc: Adapted.

2009-03-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/bakery/Makefile.am:
	* glom/bakery/GtkDialogs.[h|cc]: Remove this, moving the code into
	these functions that previously just called the same named functions
	in GtkDialogs, for reasons that are no longer relevant:
	* glom/bakery/App_WithDoc_Gtk.cc ui_warning(),
	ui_file_select_open(), uri_is_writable(),
	ui_file_select_save(), ui_offer_to_save_changes().

2009-03-23  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/document_glom.[h|cc]: Added a load() that just calls
	the base class, just to make life easier for SWIG, so it can ignore the base
	class for client-only API.

2009-03-22  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.[h|cc]: new_instance(): Spawn a new process via a
	a command line command.
	* glom/bakery/App.[h|cc]: new_instance(): Take a uri parameter.
	on_menu_file_new():
	* glom/bakery/App_WithDoc.cc: open_document():
	new_instance() is now expected to start a new process instead of
	returning a new C++ instance.

	This means that File/New and File/Open will start a new independent
	process.

2009-03-22  Murray Cumming  <murrayc@murrayc.com>

	Reverted this change because each instance is now an independent
	process, or soon will be when I have made some more changes:

	* configure.ac: Depend on libunique-1.0
	* glom/bakery/App_WithDoc_Gtk.[h|cc]: Added set_unique_app(), to make
	the app handle UniqueApp messages, to start new instances or open files.
	* glom/main.cc: Use set_unique_app() and send messages to the existing
	instance instead of starting a new instance, if one is already running.

2009-03-19  Murray Cumming  <murrayc@murrayc.com>

	* glom/bakery/Makefile.am:
	* glom/bakery/AppInstanceManager.[h|cc]: Removed this class.
	* glom/application.cc:
	* glom/bakery/App.cc:
	* glom/bakery/App.h:
	* glom/bakery/App_Gtk.cc:
	* glom/bakery/App_Gtk.h:
	* glom/bakery/App_WithDoc.cc:
	* glom/bakery/App_WithDoc_Gtk.cc: Removed management of multiple
	instances. Each Glom window is now isolated. That is necessary anyway
	because we have been storing a global application pointer separately
	anyway for a while now, which broke this.

	This would need to use some single-instance DBus thing anyway to make
	it work properly between processes (started from the Application menu.)
	That would be nice. Then we could really check if a file is already
	open, like gedit does.

2009-03-21  Armin Burgmeier  <armin@openismus.com>

	* autogen.sh: Don't run autoheader.

	* configure.ac: Prevent execution of autoheader with
	--enable-maintainer-mode. Copied from glibmm.

	* glom/libglom/libglom_config.h.in: Added include guards.

	* config.h.in: Added this file which was previously generated by
	autoheader. Removed the prefixed definitions from it but include
	glom/libglom/libglom_config.h instead. This prevents warnings about
	redefinitions when both config.h and libglom_config.h are included in
	a translation unit.

2009-03-20  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool_backends/postgres.cc:
	check_postgres_gda_client_is_available_with_warning(): Avoid a
	warning when libgda sometimes gives us a non-string GValue from
	gda_config_list_providers(), which is a silly API.

2009-03-20  Murray Cumming  <murrayc@murrayc.com>

	* glom/bakery/App_WithDoc_Gtk.cc: Remove checks for GTK+ 2.10. We really
	have it now.

2009-03-20  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Depend on libunique-1.0
	* glom/bakery/App_WithDoc_Gtk.[h|cc]: Added set_unique_app(), to make
	the app handle UniqueApp messages, to start new instances or open files.
	* glom/main.cc: Use set_unique_app() and send messages to the existing
	instance instead of starting a new instance, if one is already running.

2009-03-19  Murray Cumming  <murrayc@murrayc.com>

	* glom/bakery/*.[h|cc]: Fixed compiler warnings. Used GLOM defines
	instead of BAKERY defines.
	* po/POTFILES.in: Added the bakery files.

2009-03-18  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Correct the libgdamm and libgda versions needed.

2009-03-18  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.cc:
	* glom/bakery/App_Gtk.cc:
	* glom/bakery/App_WithDoc.cc:
	* glom/bakery/App_WithDoc_Gtk.cc:
	* glom/bakery/Dialog_OfferSave.cc:
	* glom/bakery/GtkDialogs.cc:
	* glom/libglom/connectionpool_backends/postgres_self.cc:
	* glom/libglom/data_structure/iso_codes.cc:
	* glom/libglom/document/bakery/Document.cc:
	* glom/libglom/document/bakery/view/View.h:
	* glom/main.cc:
	* glom/translation/window_translations.cc: Include config.h using <>
	instead of "", to be consistent with elsewhere.

2009-03-17  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool_backends/postgres.cc:
	check_postgres_gda_client_is_available_with_warning(): Actually check.
	This was commented out because the libgda-4.0 API for it is unpleasant.

2009-03-17  Murray Cumming  <murrayc@murrayc.com

	* glom/glom_developer.glade: Remove superfluous empty TextBuffer objects,
	to avoid warnigns, but we still have problems with Adjustments.
	See GtkBuilder bug #575714.

2009-03-17  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Remove the libglademm dependency.
	* glom/glom.glade:
	* glom/glom_developer.glade: Resaved as GtkBuilder format in glade-3.
	* glom/Makefile.am:
	* glom/variablesmap.[h|cc]: Copied this from libglademm and adapted it to
	Gtk::Builder.
	* glom/*.[h|cc]: Use Gtk::Builder instead of Gnome::Glade::Xml. The changes
	are mostly just search/replace.

2009-03-17  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Remove bakery dependency.
	* glom/Makefile.am:
	* glom/bakery/: Added copies of the Bakery/App files.
	* glom/libglom/document/bakery/: Added copies of the Bakery Document
	and View files.
	This allows us to change the Bakery ABI when we need to. We already
	do unusually hacky things with Bakery so this is reasonable.

2009-03-17  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/combo_textglade.[h|cc]: Remove the reimplementation
	of Gtk::ComboBoxText now that we can use gtkmm 2.14.
	* glom/frame_glom.cc:
	* glom/libglom/data_structure/glomconversions.cc:
	* glom/mode_design/dialog_add_related_table.cc:
	* glom/mode_design/fields/dialog_fielddefinition.cc:
	* glom/mode_design/script_library/dialog_script_library.cc:
	* glom/mode_design/users/dialog_users_list.cc: Adapted.
	* glom/libglom/document/document_glom.cc: save_before: Remove another
	gtkmm 2.10 workaround.

2009-03-17  Murray Cumming  <murrayc@murrayc.com>

	* configure.ac: Depend on gtkmm 2.14 rather than gtkmm 2.10.

	* glom/Makefile.am:
	* glom/utility_widgets/Makefile.am:
	* glom/utility_widgets/calendar/: Remove copy of Gtk::Calendar.
	* glom/mode_data/box_data_calendar_related.h: Adapted.

	* glom/application.cc:: init_toolbars(), add_ui_from_string():
	* glom/dialog_existing_or_new.cc: constructor, get_uri(),
	existing_icon_data_func():
	* glom/dialog_existing_or_new.h
	* glom/layout_item_dialogs/box_formatting.cc: get_formatting():
	* glom/libglom/data_structure/print_layout.cc: Constructor, operator=():

	* glom/mode_design/print_layouts/canvas_print_layout.cc: set_print_layout():
	* glom/mode_design/print_layouts/window_print_layout_edit.cc:
	get_icon_for_toolbar_item(), on_canvas_drag_drop(), on_canvas_drag_motion():
	* glom/xsl_utils.cc: transform_and_open():
	Remove workarounds for gtkmm 2.10 now that we can depend on gtkmm 2.14.
	This is not really necessary but it's nice to clean up the code.

This is svn trunk, for Glom 1.11/12. See also the glom-1-10 branch.

1.10.0:

2009-03-16  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/calendar/glomcalendar.[h|cc]:
	* glom/utility_widgets/calendar/glomgtkcalendar.[h|c]: Check for GTK+ 2.14,
	not GTK+ 2.16, because the GtkCalendar details_func API is in 2.14.
	Correct a typedef to fix the build in that case.

2009-03-16  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/gst-package.c: Converted a C++ comment to a C comment,
	to avoid a warning.

	* glom/main.cc (main): Fixed the build on Linux, which was broken
	since my last commit.

2009-03-13  Armin Burgmeier  <armin@openismus.com>

	* glom/dialog_existing_or_new.cc:
	* libglom/connectionpool_backends/postgres_self.cc:
	* libglom/glade_utils.h:
	* glom/main.cc:
	* glom/mode_design/print_layouts/print_layout_toolbar_button.cc:
	* glom/utility_widgets/layouttoolbar.cc:
	* glom/utility_widgets/layouttoolbarbutton.cc: Replaced
	g_win32_get_package_installation_subdirectory() by
	g_win32_get_package_installation_directory_of_module() since the
	former is deprecated. Bug #575021.

2009-03-13  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_design/fields/box_db_table_definition.
	field_has_null_values(): Do not warn about a false failure.

2009-03-13  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool.cc: connect(): Update the meta store for
	just the data types and the table names, instead of everything. This is
	slightly faster. This needs libgdamm from svn.
	More about the libgda meta store speed here:
	http://bugzilla.gnome.org/show_bug.cgi?id=575235

2009-03-13  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/fieldtypes.cc: Avoid an extra
	update_meta_store() when exceptions are disabled.
	* glom/navigation/box_tables.cc: fill_table_row(): Avoid a crash when
	the TableInfo is null.

2009-03-13  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool_backends/postgres.cc: Fix the build when
	GLOM_CONNECTION_DEBUG is defined.

2009-03-12  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/Makefile.am: Do not install some headers that are for
	API that I do not really want other people to use.

2009-03-12  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/adddel/eggcolumnchooser/: Copy a newer version from
	libegg, which already fixed the use of deprecated GTK+ macros.
	* glom/utility_widgets/flowtable.cc:
	* glom/utility_widgets/flowtable.h: child_type_vfunc(): Use GType instead
	of deprecated GtkType.
	This mostly fixes bug #575021 (André Klapper).

2009-03-12  Murray Cumming  <murrayc@murrayc.com>

	* configure.in: Rename to configure.ac, because configure.in is
	deprecated by recent autotools.

2009-03-12  Armin Burgmeier  <armin@openismus.com>

	* configure.in: Added config.h to AC_CONFIG_FILES, so that we create
	two config files: config.h with all definitions, and libglom_config.h
	which contains only definitions prefixed with GLOM_ to be installed.
	This means header files cannot use non-prefixed definitions.

	* glom/libglom/libglom_config.h.in: New file containing the
	definitions to be installed.

	* glom/libglom/connectionpool_backends/postgres_self.cc:
	* glom/libglom/data_structure/iso_codes.cc:
	* glom/translation/window_translations.cc:
	* glom/utility_widgets/calendar/glomgtkcalendar.h:
	* glom/utility_widgets/calendar/glomgtkcalendar.c:
	* glom/application.cc:
	* glom/main.cc: Adapt the code by including config.h instead of
	libglom_config.h.

1.9.4:

2009-03-10  Armin Burgmeier  <armin@openismus.com>

	* win32/build_installer: Only install the postgres and sqlite libgda
	provider, and not all the others. This prevents libgda from trying to
	load them, and fail doing so with a user-visible message about some
	DLLs not being found.

2009-03-10  Armin Burgmeier  <armin@openismus.com>

	* glom/xsl_utils.cc: Made reports work on Windows, by using
	Glib::get_tmp_dir() instead of "/tmp" and ShellExecute instead of
	g_app_info_launch_default_for_uri(), for which file:// URIs don't seem
	to be supported on Windows.

	* win32/build_installer: Don't ship libdb47.dll anymore, as this is no
	longer required with libgda 3.99.13.

2009-03-09  Claude Paroz  <claude@2xlibre.net>

	* glom/mode_data/dialog_layout_details.cc: Add a translator comment.
	Bug #574672.

2009-03-09  Murray Cumming  <murrayc@murrayc.com>

	* configure.in: Require the latest (from svn, not yet in a tarball) version
	of libgda, needed by the images in the example files.

2009-03-09  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/postgres_self.cc (startup): Use
	"postgres" executable instead of "postmaster".

	* glom/libglom/connectionpool.cc: Fixed the Windows build.

	* glom/main.cc: Fixed locale search path.

	* win32/querymodules.bat: Removed, this file is no longer required.

	* win32/build-installer:
	* win32/glom.iss.in:
	* win32/Makefile.am:
	* win32/README: Update for current version.

2009-03-09  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/document_glom.h: HostingMode: Declare all enum
	values regardless of what is enabled, to avoid ABI confusion and to maybe
	allow us to say that some are not supported at runtime.

2009-03-08  Stéphane Raimbault  <stephane.raimbault@gmail.com>

	* glom/libglom/data_structure/glomconversions.cc:
 	sanity_check_date_text_representation_uses_4_digit_years(): Fix a typo
 	in the word representation of the error message.

2009-03-08  Stéphane Raimbault  <stephane.raimbault@gmail.com>

	* configure.in: Changes made to reflect new po linguas setup including
	removing ALL_LINGUAS (now in new file LINGUAS).
	* po/LINGUAS: new file.
	Fixes #569721

2009-03-06  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/document_glom.cc: load_after(): Added an ifdef to
    fix the client-only sqlite build.

2009-03-06  Murray Cumming  <murrayc@murrayc.com>

	* glom/frame_glom.cc:
    connection_request_password_and_choose_new_database_name(): Added an ifdef
    to fix the client-only postgres build.

2009-03-06  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_data/box_data_portal.cc: get_suitable_record_to_view_details():
	Use the correct primary key of the related table. This fixes navigation
	on the Small Business Example, on the invoice lines, which goes to the
	product record.

2009-03-06  Murray Cumming  <murrayc@murrayc.com>

	* examples/example_lesson_planner.glom:
	* examples/example_project_manager.glom:
	* examples/example_smallbusiness.glom: Resaved these, because libgda
	corrected the string format for binary data (images). libgda also fixed
	the crash when parsing that string, as used in from_file_format().

2009-03-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/field.cc: from_file_format(): Add some
	checks.

2009-03-04  Murray Cumming  <murrayc@murrayc.com>

	* configure.in: Generate libglom/libglom_config.h instead of config.h,
	so we can install it and use it in our public headers.
	* glom/libglom/Makefile.am: Install libglom_config.h.
	* glom/libglom/glom-1.0.pc.in: Correct the shared library name.
	* *.[h|cc]: Include libglom/libglom_config.h instead of config.h.

2009-03-04  Murray Cumming  <murrayc@murrayc.com>

	* configure.in: Ran autoupdate on this so it does things as per what is
	currently correct.

2009-03-04  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/Makefile.am: Link to the correct library name for
	test_document.cc
	* glom/libglom/test_document.cc: List the tables in the document.

2009-03-03  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/document/document_glom.cc (load_after): Fixed another
	misplaced else which prevented postgresql files from being opened
	when support for both postgresql and sqlite was enabled.

	* glom/libglom/document/document_glom.h: Changed DEFAULT_HOSTED to
	HOSTING_MODE_POSTGRES_SELF if postgresql is enabled.

	* glom/application.cc (constructor): Use DEFAULT_HOSTED to initialize
	m_ui_save_extra_newdb_hosting_mode, so that we don't need an #ifdef.

2009-03-03  Murray Cumming  <murrayc@murrayc.com>

	* *.[h|cc]: Include all libglom headers via libglom/ instead of
	glom/libglom so it works from outside, with the path to the installed
	headers, from pkg-config.
	* All Makefile.am files: Add -I@top_srcdir@/glom to AM_CPPFLAGS.
	The repetition is awful. We should avoid that somehow.

2009-03-03  Murray Cumming  <murrayc@murrayc.com>

	* configure.in:
	* glom/libglom/Makefile.am:
	* glom/libglom/glom-1.0.pc.in: Added and installed pkg-config file.

	* glom/Makefile.am:
	* glom/libglom/data_structure/Makefile.am:
	* glom/libglom/data_structure/layout/Makefile.am:
	* glom/libglom/data_structure/layout/report_parts/Makefile.am:
	* glom/libglom/document/Makefile.am:
	* glom/python_embed/python_module/Makefile.am:
	* regression_tests/Makefile.am: Change libglom to libglom-1.0 so we can
	use proper API versioning. Install the headers.

	* glom/libglom/document/document_glom.cc: Use std::auto_ptr<> to
	avoid instantiating Bakery::BusyCursor if no parent window was set,
	to avoid the need to initialize gtkmm/GTK+.

2009-03-03  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/document_glom.h: Add some SWIG ifdefs to
	improve the Java wrapping output with swig.

2009-03-03  Murray Cumming  <murrayc@murrayc.com>

	* glom/dialog_existing_or_new.cc: Parser::on_start_element():
	Call xmlStopParser() to avoid unnecessary extra parsing, fixing a TODO.

2009-03-03  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/Makefile.am:
	* glom/libglom/document/document_glom.[h|cc]: Renamed the *_HOSTED enum values to
	use a prefix. Moved the View tyepdefs into a view.h file.

	* glom/application.cc:
	* glom/base_db.h:
	* glom/dialog_connection.cc:
	* glom/frame_glom.cc:
	* glom/layout_item_dialogs/dialog_field_layout.h:
	* glom/mode_design/dialog_design.h:
	* glom/relationships_overview/dialog_relationships_overview.h:
	* glom/translation/dialog_identify_original.h:
	* glom/translation/window_translations.[h|cc]:
	* glom/utility_widgets/datawidget.h:
	* glom/utility_widgets/filechooserdialog_saveextras.cc: Adapted.

2009-03-02  Armin Burgmeier  <armin@openismus.com>

	* glom/frame_glom.cc:
	(connection_request_password_and_choose_new_database_name): Call
	connectionpool's startup() also if SQLite is disabled. Bug #573799.

2009-03-02  Murray Cumming  <murrayc@murrayc.com>

	* Many .h files: Changed many protected to private to make the API
	clearer. This is particularly important for libglom, as I start
	thinking of wrapping the API for Java/Web.

2009-03-02  Murray Cumming  <murrayc@murrayc.com>

	* configure.in: Added an --enable-postgresql option, so we can have
	embedded builds that only use SQLite. Disable SQLite by default.

	* glom/utility_widgets/filechooserdialog_saveextras.[h|cc]:
	Don't mention the backend names if only SQLite is disabled, to avoid
	confronting people with unnecessary technicalese.

	* glom/application.cc:
	* glom/dialog_connection.cc:
	* glom/frame_glom.cc:
	* glom/libglom/connectionpool_backends/Makefile.am:
	* glom/libglom/connectionpool_backends/postgres.h:
	* glom/libglom/connectionpool_backends/postgres_central.[h|cc]:
	* glom/libglom/connectionpool_backends/sqlite.h:
	* glom/libglom/data_structure/glomconversions.h:
	* glom/libglom/document/document_glom.[h|cc]:
	* glom/libglom/gst-package.c:
	* glom/libglom/test_connectionpool.cc:
	* glom/main.cc:
	Added ifdefs to allow builds with -enable-postgresql=no.

	* glom/dialog_import_csv.cc: Replace gettext() with _().

1.9.3:

2009-02-27  Armin Burgmeier  <armin@openismus.com>

	* glom/frame_glom.cc:
	(connection_request_password_and_choose_new_database_name): When
	creating a new self-hosting postgres database, then store the port it
	uses within the document, so that remote connections (using browse
	network) can connect to the newly created database. Bug #572982.

2009-02-27  Armin Burgmeier  <armin@openismus.com>

	* glom/mode_design/fields/box_db_table_definition.cc (on_adddel_add):
	Add newly added field into document before refreshing m_vecFields, so
	that Base_DB::get_fields_for_table() has an up-to-date document. This
	fixes changing newly added fields with SQLite.

	* configure.in: Fixed a typo, which caused libgda-sqlite-4.0 not being
	required even when SQLite support was enabled.

1.9.2:

2009-02-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/flowtable.cc: on_size_allocate(): Change an
	accidental += to the = that it should be, to stop columns getting
	increasingly large amounts of extra width when there are >2 columns.
	Bug #539369 (maximiliano)

2009-02-24  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/postgres_central.cc (set_host):
	Only reset m_port to zero if m_try_other_ports is true. Otherwise, a
	specific port has already been set by the user.
	(connect): Compare m_port to 0, not port, which is a Glib::ustring.
	This fixes a warning about g_utf8_collate's argument being NULL, and
	fixes connection to a remote postgres server advertized via networked
	glom.

2009-02-24  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/backend.h:
	* glom/libglom/connectionpool_backends/backend.cc: Moved the
	ConnectionPool backend base class into a new file in the
	connectionpool_backends subdirectory.

	* glom/libglom/connectionpool_backends/Makefile.am: Add it to the
	build.

	* glom/libglom/connectionpool_backends/postgres.h:
	* glom/libglom/connectionpool_backends/sqlite.h:
	* glom/libglom/connectionpool_backends/sqlite.cc:
	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool.cc:
	* glom/libglom/test_connectionpool.cc:
	* glom/dialog_connection.cc:
	* glom/frame_glom.cc: Adapt.

2009-02-24  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool.cc: Added a get_string_find_operator()
	virtual method to ConnectionPoolBackend, and a similar method to
	ConnectionPool which simply queries its backend.

	* glom/libglom/connectionpool_backends/sqlite.h:
	* glom/libglom/connectionpool_backends/postgres.h: Implement the new
	virtual method appropriately.

	* glom/libglom/data_structure/field.cc (sql_find_operator): Use the
	get_string_find_operator() method of the connectionpool backend in
	case the field's type is TYPE_TEXT. This fixes Find Mode with SQLite.
	Bug #570401. I wonder whether libgda can generate a case-insensitive
	string comparison, which would make this easier for us.

2009-02-24  Armin Burgmeier  <armin@openismus.com>

	* configure.in: Added an --enable-sqlite configure option, which is
	enabled by default.

	* glom/libglom/connectionpool_backends/sqlite.h: #error if this file
	is included with SQLite support disabled. Mostly meant as a debugging
	aid.

	* glom/libglom/connectionpool_backends/Makefile.am: Don't build
	sqlite.cc in case SQLite support is disabled.

	* glom/libglom/document/document_glom.h:
	* glom/libglom/document/document_glom.cc: Don't declare SQLITE_HOSTED
	hosting mode if SQLite support is disabled, and refuse to open files
	with unknown hosting mode instead of falling back to postgres central.

	* glom/utility_widgets/filechooserdialog_saveextras.h:
	* glom/utility_widgets/filechooserdialog_saveextras.cc: Don't show the
	option to create a SQLite hosted file in the GUI if SQLite support is
	disabled.

	* glom/utility_widgets/db_adddel/glom_db_treemodel.cc: Removed a
	superfluous <libglom/connectionpool_backends/sqlite.h> include.

	* glom/frame_glom.cc:
	* glom/application.cc: #ifdef-out code to create a SQLite
	connectionpool backend if SQLite support is disabled, as well as a few
	related checks.

2009-02-24  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/sqlite.cc: Keep non-NULL
	constraint of columns when recreating table.

2009-02-23  David King  <davidk@openismus.com>

 	* glom/frame_glom.cc: on_menu_file_import(): Add CSV mime-type filter
 	to import dialog. Bug #572702

2009-02-23  Armin Burgmeier  <armin@openismus.com>

	* glom/utility_widgets/db_adddel/db_adddel.cc
	(construct_specified_columns): Clear m_refListStore if in case no
	column types are set. This allows dropping the reference to the GDA
	DataModel by setting an empty table name on the AddDel.

	* glom/frame_glom.h:
	* glom/frame_glom.cc: Added show_table_allow_empty() which allows the
	table name to be empty, in which case no table is shown, and
	show_no_table() as a shortcut for this case. Show an empty table
	before opening the fields editing dialog, so that no references to the
	database are used anymore. SQLite requires this to be able to drop the
	old table when changing fields.
	Bug #572847

2009-02-22  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom.glade, glom_developer.glade:
	* glom/base_db.cc: offer_notebook(): Move the dialog_notebook window
	into glom_developer.glade because it is only used in developer mode.

2009-02-22  Murray Cumming  <murrayc@murrayc.com>

	* Various minor fixes to avoid minor compiler warnings.

2009-02-22  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/glomconversions.cc:
	get_text_for_gda_value(): Avoid a warning about no return value.

2009-02-22  Armin Burgmeier  <armin@openismus.com>

	* glom/mode_data/flowtablewithfields.cc (add_field_at_position): Don't
	leak the Gtk::EventBox.

2009-02-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom_developer.glade: Resaved with glade-3. Recent versions of
	glade-3 are much better at converting from glade-2. I just had to
	hand-add the GtkSourceView widgets back.
	Bug #567470

2009-02-20  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.cc:
	* glom/base_db.[h|cc]:
	* glom/dialog_connection.cc:
	* glom/frame_glom.cc:
	* glom/libglom/connectionpool.[h|cc]:
	* glom/libglom/connectionpool_backends/postgres_central.cc
	* glom/navigation/box_tables.[h|cc]:
	Added ifdefs to fix the build with --enable-client-only.

2009-02-20  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom_privs[h|cc]: get_current_privs(): Cache the priviliges
	for each table for 30 seconds, to avoid unnecessary repetitive groups
	queries to the database. This seems to avoid about 5 out of 6
	requests, so it should be faster.
	Bug #567473

2009-02-20  Murray Cumming  <murrayc@murrayc.com>

	* configure.in:
	* glom/libglom/connectionpool_backends/postgres_self.cc: Use the
	postgres executable name instead of the deprecated postmaster
	executable. Everything probably has that now.
	Bug # 525108

2009-02-20  Murray Cumming  <murrayc@murrayc.com>

	* glom/utlity_widgets/datawidget.cc: Constructor: Show the Open button,
	(but not Find) for related fields that are primary keys, so we can
	navigate to that record.
	* glom/mode_data/box_data_details.cc:
	on_flowtable_field_open_details_requested(): Navigate to the
	appropriate record in the appropriate table for this type of Open
	button.
	Bug #571975

	* glom/base_db.cc: fill_full_field_details(): Avoid crashes.

2009-02-20  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/document_glom.[h|cc]:
	get_field_used_in_relationship_to_one(): Make this take a
	LayoutItem_Field instead of just a field name.
	* glom/utlity_widgets/datawidget.cc: Constructor: adapt, so we add
	Open and Find buttons for related fields too when appropriate.
	* glom/base_db.cc: Adapt to API change.

2009-02-18  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/field.cc: from_file_format(): Adjusted
	for a libgda API change in gda_string_to_binary().

2009-02-18  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/data_structure/field.cc (set_glom_type): Reset the
	default value if the Glom type is changed. The old default value
	probably doesn't make sense for the new type. This fixes a warning
	when changing a field's type from text to numerical.
	(set_default_value): Verify that the new default value is compatible
	with the field's glom type.
	(set_field_info): Verify that the default value of the new field info
	is compatible with the field's glom type.

	* glom/mode_design/fields/box_db_table_definition.cc
	(get_field_definition): When changing the field info's GType, make
	sure its default value matches the new GType, or reset it if not.

	* glom/libglom/document/document_glom.cc (load_after): Set a field's
	default value after having set the glom type, so that the checks
	introduced above don't fail.

2009-02-18  Murray Cumming   <murrayc@murrayc.com>

	* glom/libglom/data_structure/field.[h|cc]: sql(value, format):
	Replace this with sql(value, connection). Use
	Gda::DataHolder::get_sql_from_value(), using the connection to get the
	DataHolder. Remove the nasty Postgres escaping code, which is now
	unnecessary. There is now no code in Glom to do escaping or unescaping
	- we use libgda functions instead.
	sql(value): Use the active connection.
	* glom/libglom/connectionpool_backends/postgres.cc: change_columns():
	* glom/libglom/connectionpool_backends/sqlite.cc: recreate_table():
	Adapted, though these can probably just call sql(value), using the
	active connection.

	* glom/base_db.[h|cc]: get_connection(): Make this static because it
	can be.

2009-02-17  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/field.[h|cc]: Added static versions of
 	from_file_format() and to_file_format(), taking the field type, for use
	in document, though we can probably avoid that.
	* glom/libglom/data_structure/glomconversions.[h|cc]:
	* glom/libglom/document/document_glom.[h|cc]: Remove support for the
	deprecated one-big-string example_rows format. Store the example rows as
	a vector of vector of Values, instead of strings. This avoids extra
	string parsing, unescaping, etc.
	* glom/glom_document.dtd: Documented the change.
	* glom/frame_glom.[h|cc]: Added export_data_to_vector().
	* glom/application.cc: on_menu_file_save_as_example(): Use the vector
	instead of a string.
	* glom/base_db.cc: insert_example_data(): Handle the vector instead of
	doing nasty string parsing.

	* examples/example_*.glom: Resaved in the new format.

2009-02-16  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/glomconversions.cc:
	get_text_for_gda_value(), parse_value(): Use std::setprecision() to
	avoid showing the awkward scientific e notation, raising the limit
	from 7 digits to 15. We don't know how to avoid it always.
	Noticed by Arq. Maximiliano Meilán.

2009-02-16  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/sqlite.cc: Fixed various
	problems with field type changes. Before, often some or all of the
	records have been erased after certain changes (only from the view,
	not from the database).

2009-02-10  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/field.[h|cc]: Renamed from_sql() to
	from_file_format(), without the sql_format parameter, to make it
	clearer. Added to_file_format(), which currently just calls sql()
	with the postgres format.
	* glom/data_structure/glomconversions.cc: Removed unused
	unescape_binary_data_sqlite().
	* glom/base_db.cc: insert_example_data():
	* glom/dialog_import_csv.cc: field_data_func():
	* glom/dialog_import_csv_progress.cc: on_idle_import(): Adapt.
	* glom/frame_glom.cc: export_data_to_string(): Use to_file_format()
	instead of sql() to make it clearer.

1.9.1:

2009-02-15  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/data_structure/field.cc (get_gda_type_name): Use the
	GType from m_field_info instead of converting the glom type to a gda
	type, to take fallback types into account, as used by SQLite for
	numeric values.
	(get_holder): Use the passed value's type to initialize the holder
	type. For binary values, there can be a mismatch between the value
	type and the field type with SQLite. This is not optimal, but it
	works for now.

2009-02-15  Armin Burgmeier  <armin@openismus.com>

	* glom/mode_data/box_data_details.cc (on_flowtable_field_edited):
	Revert the changed value if set_field_value_in_database() throws a
	glib exception.

2009-02-15  Armin Burgmeier  <armin@openismus.com>

	* glom/utility_widgets/db_adddel/db_adddel.cc (user_changed): Revert
	the changed value if set_field_value_in_database() throws an
	exception.

2009-02-15  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/sqlite.cc: Convert existing
	values explicitely via the date() and time() SQLite functions when
	converting existing values to date or time. This fixes all rows being
	erased when changing a column to date or time.

2009-02-12  Armin Burgmeier  <armin@openismus.com>

	* glom/mode_design/fields/box_db_table_definition.cc
	(check_field_change): Check field's glom type directly instead of
	guessing the glom type from its GType, which might produce a wrong
	result with some of the fallback types used with SQLite.

	* glom/libglom/connectionpool_backends/sqlite.cc (recreate_table):
	Don't crash if transaction rollback fails without the error variable
	being set.

2009-02-10  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/sqlite.h:
	* glom/libglom/connectionpool_backends/sqlite.cc: Support dropping and
	changing columns, though changing doesn't yet seem to work reliably
	yet.

2009-02-10  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/sqlite.cc (recreate_table):
	Use get_value_type() to find out a value's not type, not get_g_type()
	which returns the GType the value stores if it's value type is GType.

	* glom/mode_design/fields/box_db_table_definition.cc (on_adddel_add):
	Don't call on_adddel_changed() just to store the field into the
	document, since on_adddel_changed() does a lot of unnecessary extra
	stuff such as calling change_columns() on the backend, which forces a
	whole table recreation with SQLite.

2009-02-10  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: insert_example_data(): Fixed my typo to fix the
	build. Sorry.

2009-02-09  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/field.[h|cc]: get_gda_type():
	Renamed to get_gda_type_name(). Removed get_gda_g_type() because
	we already have a static get_g_type_for_glom_type(). This gets rids of
	the nasty switch block.
	* glom/base_db.cc: insert_example_data(), get_lookup_value(),
	  get_primary_key_is_in_foundset(): Adapted.

2009-02-09  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool.cc: Added set_server_operation_value(),
	create_server_operation() and perform_server_operation() convenience
	methods to connectionpool backend base class.

	* glom/libglom/connectionpool_backends/sqlite.h:
	* glom libglom/connectionpool_backends/sqlite.cc: Implemented table
	recreation, required for changing or dropping columns, or adding
	primary key columns. The glom type of newly added columns doesn't yet
	seem to be recognized correctly, though.

2009-02-08  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/db_adddel/glom_db_treemodel.[h|cc]:
	constuctor/create(): Added a bool find_mode parameter and member
	variable.
	refresh_from_database(): Create a DataModelArray for find mode,
	with the appropriate column types.
	* glom/utility_widgets/db_adddel/db_adddel.[h|cc]:
	Remove the awkward ListStore alternative model for find mode that I
	recently introduced,
	construct_specified_columns(): Instead just specify find_mode=true
	when creating the tree model.

	* glom/mode_data/box_data_list.cc: Simplify this code again
	accordingly.

	* glom/utility_widgets/db_adddel/Makefile.am:
	* glom/utility_widgets/db_adddel/treemodel_with_addrow.[h|cc]:
	* glom/utility_widgets/db_adddel/liststore_with_addrow.[h|cc]:
	* regression_tests/Makefile.am:
	* regression_tests/test_treemodel_dynamic_cast.cc:
	Removed these because they are no longer used.

2009-02-08  Johannes Schmid  <jschmid@openismus.com>

	* glom/libglom/data_structure/Makefile.am:
	* glom/libglom/data_structure/parameternamegenerator.cc:
	* glom/libglom/data_structure/parameternamegenerator.h:
	New class to generate simple unique holder names

	* glom/base_db.cc (insert_example_data):
	Use the new ParameterNameGenerator class

2009-02-07  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: get_field_value_is_unique(): Use the
	Field::get_holder(value) method overload instead of get_holder(),
	avoiding copying the Field and using Field::get_data().
	* glom/libglom/data_structure/field.[h|cc]:
	Removed the get_holder(name) method overload because it is now not
	used.
	Removed get/set_data() and the member variable because they are now
	not used.

2009-02-06  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: get_table_names_from_database(): Comment out the
	checks for internal tables, because that is now fixed in libgda.
	* glom/mode_data/box_data.[h|cc]:
	* glom/base_db_table_data.[h|cc]: Move refresh_related_fields()
	(which is virtual) and get_related_fields() down the hierarchy so that
	the override is also used by DbAddDel, so related fields are updated
	in the view on list views and related records.
	This really fixes bug #569722 (Johannes Schmid)

2009-02-05  Armin Burgmeier  <armin@openismus.com>

	* glom/utility_widgets/db_adddel/glom_db_treemodel.cc: Added a
	clarifying comment on why we use a DataAccessWrapper.

2009-02-04  Armin Burgmeier  <armin@openismus.com>

	* glom/utility_widgets/db_adddel/glom_db_treemodel.cc
	(DbTreeModelRow::fill_values_if_necessary): Use a
	Gnome::Gda::DataModelWrapper to wrap the resulting cursor-based data
	model. This avoids a special-case for SQLite. Requires libgda trunk.

2009-02-03  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom_document.dtd: Mention the new self_hosted <connection>
	attribute.

2009-02-03  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: get_table_names_from_database(): Filter out some
	extra internal table names which may be created/reported by newer
	versions of libgda.

2009-02-02  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db_table_data.[h|cc]: Added get_row_selected() virtual function,
	used in record_new() instead of an always-null TreeModel::iterator.
	This lets lookups, default values, and calculated values be seen when
	adding new list records or related records.
	* glom/mode_data/box_data_list.[h|cc]:
	* glom/utility_widgets/db_adddel/db_adddel.[h|cc]:
	Added get_row_selected() overrides.
	This should fix bug #569722 (Johannes Schmid)

2009-02-02  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: query_execute_select(), query_execute():
	When using --debug_sql, use Statement::to_sql() to show the actual
	SQL with actual values, though this does not seem to work for
	non-SELECT queries.
	* glom/mode_data/box_data.cc: refresh_related_fields(): Some extra
	error checking.

2009-02-02  Murray Cumming  <murrayc@murrayc.com>>

	* glom/base_db.cc: :set_field_value_in_database(): Correct a
	copy/paste typo that was probably introduced when switching to using
	parameters, so we now actually specify the primary key, so we really
	change the data in the database.

2009-01-31  Johannes Schmid  <jschmid@openismus.com>

	* glom/application.cc (on_document_load()):
	Reinit cancelled state and some more cleanups.
	Fixes #569721 – Glom behaves strange when you cancel the new dialog

2009-01-30  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom.glade: Make the labels FILL and EXPAND so they really
	align left instead of centering. This broke when I resaved with a
	newer glade-2.

2009-01-30  Murray Cumming  <murrayc@murrayc.com>

	Added some TODO comments where we would like to use SQL parameters
	instead of Field::sql(), if we can figure out how to do that for
	fragments of SQL, or how to refactor the code to parse the whole
	SQL query at once.

2009-01-29  Johannes Schmid  <jhs@openismus.com>

	* glom/base_db.cc:
	* glom/base_db_table_data.cc:
	* glom/mode_data/box_data_calendar_related.cc:
	* glom/mode_data/box_data_list_related.cc:
	Move the rest of queries from sql() to use params where this made sense.
	Some methods generate random sql that is executed elsewhere which means that
	they cannot use parameters themselves. I did not touch those.

	* glom/libglom/data_structure/field.cc:
	* glom/libglom/data_structure/field.h:
	Added get_holder(value, name) to avoid having to use temporary field to
	be able to use get_holder() and get_gda_holder_string()

2009-01-29  Johannes Schmid  <jschmid@openismus.com>

	* glom/base_db.cc:
	* glom/base_db_table_data.cc:
	Converted more queries to use parameters

2009-01-27  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: auto_increment_insert_first_if_necessary(),
	get_next_auto_increment_value(), set_database_preferences():
	Use the new templated Gda::Set::add_holder(), simplifying the code.

2009-01-27  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool_backends/postgres.cc
	attempt_create_database(): Do not pass an empty Set to
	create_operation() because I added a method overload in libgdamm.

2009-01-27  Johannes Schmid  <jschmid@openismus.com>

	* glom/base_db.cc (set_field_value_in_database):
	Fix updating of fields with was broken due to a stupid mistake

2009-01-26  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: get_fields_for_table_from_database(),
	auto_increment_insert_first_if_necessary(),
	get_next_auto_increment_value(), insert_example_data():
	* glom/libglom/data_structure/field.cc: get_holder(): Adapt to
	my set_value()/set_value_as_value() changes in libgdamm to slightly
	simply the code. I guess that a better add_param() method could
	simplify it more.

2009-01-26  Johannes Schmid  <jschmid@openismus.com>

	* glom/base_db.cc:
	* glom/base_db.h:
	Ported more queries to use parameters. query_execute_select() now
	accepts parameters.

	* glom/base_db_table_data.cc:
	* glom/dialog_database_preferences.cc:
	* glom/frame_glom.cc:
	* glom/mode_data/box_data.cc:
	* glom/mode_data/box_data_calendar_related.cc:
	* glom/mode_data/box_data_details.cc:
	* glom/mode_design/fields/box_db_table_definition.cc:
	* glom/mode_design/print_layouts/canvas_print_layout.cc:
	Removed parent_window argument from query_execute_select() call.

	* glom/libglom/data_structure/field.cc:
	* glom/libglom/data_structure/field.h:
	Added get_holder() und get_gda_holder_string() as conveniece methods

2009-01-25  Johannes Schmid <jschmid@openismus.com>

	* glom/base_db.cc:
	Some cosmetic changes to error messages and removed the reference()
	call that is obviously caused by a bug in the postgres provider.

2009-01-24  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/data_structure/fieldtypes.cc (constructor): Added
	GdaBlob as a fallback type for GdaBinary, so that
	Field::set_field_info() sets the correct glom type if the GType is
	GDA_TYPE_BLOB.

	* glom/libglom/data_structure/glomconversions.cc
	(get_pixbuf_for_gda_value): Allow the value having type
	GDA_TYPE_BLOB, and handle this appropriately. These changes fix images
	in SQLite with libgda4, requiring libgda trunk.

	* glom/utility_widgets/db_adddel/glom_db_treemodel.cc
	(refresh_from_database): Use STATEMENT_MODEL_RANDOM_ACCESS to create
	the data model when using SQLite, because of bug #567891.

	* glom/mode_design/fields/box_db_table_definition.cc (fill_field): Use
	the field's glom type directly, instead of guessing it from the
	field's GType.

2009-01-23  Johannes Schmid  <jhs@openismus.com>

	* glom/base_db.cc:
	* glom/base_db.h:
	Refactored query_execute() to be able to use additional parameters. Changed
	insert_example_data() to use the new method.

	* glom/libglom/data_structure/field.cc:
	* glom/libglom/data_structure/field.h:
	Added get_gda_g_type() and made get_gda_type() should a wrapper around it

	* glom/base_db_table_data.cc:
	* glom/dialog_database_preferences.cc:
	* glom/mode_data/box_data_calendar_related.cc:
	* glom/mode_data/box_data_list_related.cc:
	* glom/mode_design/users/dialog_groups_list.cc:
	* glom/mode_design/users/dialog_users_list.cc:
	* glom/navigation/box_tables.cc:
	* glom/utility_widgets/db_adddel/glom_db_treemodel.cc:
	Removed the unused Gtk::Window* parameter from all query_execute() calls

2009-01-22  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: insert_example_data(): Catch exceptions as const.
	Remove spaces before (, again.

2009-01-22  Johannes Schmid  <jschmid@openismus.com>

	* glom/base_db.cc (insert_example_data(), get_connection()):
	* glom/base_db.h:
	Fixed insertion of example data by using variables in the sql statement
	instead of inserting the data directly in the statement (which confuses the
	GdaSqlParser and is inefficient)

	* glom/libglom/data_structure/field.cc (get_gda_type()):
	* glom/libglom/data_structure/field.h:
	Added a method to get the gda GType of the field. This is necessary to
	prepare the sql statement so I would rather like to reuse get_sql_type().
	Currntly investigating on gnome-db-list.

2009-01-20  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/document/document_glom.cc: save_changes():
	Revert the Johannes change here too, because it is causing infinite
	loops when adding fields, and probably at other times, repeatedly
	saving the file. The code is not equivalent.

2009-01-19  Murray Cumming  <murrayc@murrayc.com>

	* glom/application.cc: document_history_add: Revert the previous,
	because I removed the new API from Bakery and just fixed the existing
	Bakery method instead.

2009-01-19  Johannes Schmid  <jschmid@openismus.com>

	* glom/application.cc: document_history_add():
	Avoid a critical warning by adding the recent data instead of
	letting Gtk::RecentManager query for non-existing uris which causes a
	Gtk-Critical. Requires new bakery trunk

	* glom/libglom/document/document_glom.cc:
	Don't duplicate code from Bakery.

1.9.0:

2009-01-16  Murray Cumming  <murrayc@murrayc.com>

	* configure.in: Update the required libgda(mm) versions.

2009-01-15  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom.glade: initial dialog: Correct the button order, which
	seems to have been broken when re-saving with glade-2. The other
	dialogs seem OK.
	* glom/libglom/data_structure/fieldtypes.cc: Constructor:
	* glom/mode_design/fields/box_db_table_definition.cc: fill_fields():
	Comment out some debug output.

2009-01-14  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool_backends/postgres.cc (change_columns):
	When changing column types, only attempt to convert data if
	Field::get_conversion_possible() returns TRUE, otherwise just change
	the column type without trying to convert the data.

	* glom/libglom/connectionpool.cc (change_columns): Added a TODO
	comment about not failing when data could not be converted to the new
	column type.

	* glom/mode_design/fields/box_db_table_definition.cc
	(get_field_definition): Set the glom type explicitely on the result
	field, so that we don't have to guess from the GType.

2009-01-13  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool.cc add_column(): Don't set the
	autoincrement field for the newly added column since we do control
	this ourselves in Glom.

2009-01-13  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool.cc: Explain that when changing a table's
	primary key we are changing two columns, in response to Murray's
	previously added TODO comment. Don't compile add_column(),
	drop_column(), change_columns() in client only mode.

	* glom/libglom/connectionpool_backends/postgres.h:
	* glom/libglom/connectionpool_backends/postgres.cc: Added
	postgres-specific code for changing a column's type, to allow
	conversions from/to date and time fields.

	* glom/mode_design/fields/box_db_table_definition.h:
	* glom/mode_design/fields/box_db_table_definition.cc: Removed
	commented-out code that did the same before I moved the functionality
	to the connectionpool backend.

2009-01-13  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool.cc: change_columns(): Added a TODO
	comment asking why we would ever want to change multiple columns.
	Changing just one columns would make the function simpler.

2009-01-12  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool.cc: Added add_column(), change_column(),
	drop_column(), using a generic implementation via libgda's DDL API.

	* glom/libglom/connectionpool_backends/postgres.h:
	* glom/libglom/connectionpool_backends/postgres.cc:
	* glom/libglom/connectionpool_backends/Makefile.am: Added a base class
	for the two postgres backends, implementing the common functionality.

	* glom/libglom/connectionpool_backends/postgres_self.h:
	* glom/libglom/connectionpool_backends/postgres_central.h:
	* glom/libglom/connectionpool_backends/postgres_self.cc:
	* glom/libglom/connectionpool_backends/postgres_central.cc: Use the
	Postgres base class, instead of deriving directly from
	ConnectionPoolBackend.

	* glom/mode_design/fields/box_db_table_definition.h:
	* glom/mode_design/fields/box_db_table_definition.cc: Use the
	connectionpool add_column(), drop_column() and change_column()
	functions instead of using postgres-specific code from
	glom_postgres.cc. There is maybe a drawback concerning data conversion
	when changing column types, but I'll re-add the relevant code to the
	postgres connectionpool backend in the near future.

	* glom/glom_postgres.h:
	* glom/glom_postgres.cc: Removed postgres_add_column() and
	postgres_change_column_extras().

	* glom/main.cc: Adapt to
	check_postgres_gda_client_is_available_with_warning() now being in
	ConnectionPoolBackends::Postgres instead of
	ConnectionPoolBackends::PostgresCentral.

2009-01-12  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom.glade: Allowed a recent version of glade-2 to resave this.
	The changes seem harmless, just adding things, but we will see.

2009-01-12  Murray Cumming  <murrayc@murrayc.com>

	* configure.in: Increase version to 1.9.0, in anticiaption of a first
	unstable 1.9/1.10 release.

2009-01-12  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom.glade: Main window: Correct the order of the Records: and
	Found: labels, which became confused at some point, maybe during 1.8.

2009-01-12  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_find/box_data_list_find.cc: fill_from_database():
	Call DbAddDel::set_columns_ready() so the treeview actually shows some
	columns.
	* glom/utility_widgets/db_adddel/Makefile.am:
	* glom/utility_widgets/db_adddel/treemodel_with_addrow.[h|cc]: A new
	common MI abstract base class for treemodels that have the extra empty
	row for adding rows.
	* glom/utility_widgets/db_adddel/liststore_with_addrow.[h|cc]: A new
	treemodel derived from ListStore and the new base class, for use with
	find mode.
	* glom/utility_widgets/db_adddel/glom_db_treemodel.h: Derive from
	the new base class.
	* glom/utility_widgets/db_adddel/db_adddel.[h|cc]:
	construct_specified_columns(): Create the ListStore model for find mode.
	Use the model via the base class where possible, so we can use the
	find mode model too.
	Avoid changing the data in the database when in find mode.

	This makes find mode work again in the list view, fixing bug #565579.

2009-01-05  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.[h|cc]: Added update_gda_metastore_for_table().
	* glom/mode_design/fields/box_db_table_definition.cc
	  on_adddel_add(), on_adddel_delete(), postgres_change_column():
	Call it, but it does not seem to work.
	New fields are immedietaly reported as not found (on the command line)
	and field type changes are reverted when reopening the dialog.

2009-01-03  Murray Cumming  <murrayc@murrayc.com>

	* glom.desktop.in.in: Removed the encoding line because it is deprecated
	according to http://standards.freedesktop.org/desktop-entry-spec/1.0/apc.html
	and lintian (debian) complains about it.

2008-12-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_data/box_data_details.h: show_tool_pallete(): Make this
	non-virtual because there are no overrides.
	* glom/mode_find/box_data_details_find.cc: constructor,
	fill_from_database(): Hide the tool palette, because it is useless in
	Find mode.

2008-12-22  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.h: Documented two methods.
	* glom/mode_design/fields/box_db_table_definition.cc: on_adddel_changed():
	Warn on stdcerr if the newly-added field seems unknown to the database,
	showing that the GdaMetaStore is not being updated automatically.

2008-12-22  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool.cc:
	* glom/libglom/connectionpool.h: cleanup(): Clear the cached connection,
	to stop Glom from using a connection that has been disconnected.

2008-12-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: get_primary_key_is_in_foundset(): Avoid a crash
	when (unusually) the primary key is not known.

2008-12-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/layout/layoutitem_text.cc:
	Copy constructor and operator=: Copy the underlying text, not just
	the smartpointer to it. This stops us from accidentally changing the
	empty available template parts in reports.
	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/309417
	(elmergato)

2008-12-19  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_design/users/dialog_groups_list.cc
	on_button_group_delete():
	* glom/mode_design/users/dialog_users_list.cc
	on_button_user_delete(), on_button_user_add(),
	on_button_user_new(), on_button_user_edit():
	Add missing quotes around user and group names in SQL queries.

2008-12-19  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.[h|cc]: Split query_execute() into query_execute() and
	query_execute_select(), returning just a bool for query_execute(),
	as suggested by a TODO because of the changed API in libgda 4.0.
	* Many files: Call the correct method.

2008-12-18  Murray Cumming  <murrayc@murrayc.com>

	* glom/base_db.cc: query_execute(): Catch ServerProviderError
	exceptions too. This needs the latest libgdamm.

2008-12-18  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_design/fields/box_db_table_definition.cc:
	get_field_definition(): Actually store the primary-key and unique
	details. This was a regression since the port to libgda 4.0.

2008-12-17  Armin Burgmeier  <armin@openismus.com>

	* glom/base_db.cc (create_table_with_default_fields): Reverted the
	previous change. People can choose not to show the "comments" or
	"description" columns in their layouts. We'll later support removing
	columns by recreating the whole table.

2008-12-17  Armin Burgmeier  <armin@openismus.com>

	* glom/base_db.cc (create_table_with_default_fields): Don't create the
	"comments" and "description" columns if the database system does not
	support removing columns.

	* glom/utility_widgets/db_adddel/glom_db_treemodel.cc
	(fill_values_if_necessary): Adapt to libgdamm API change.
	Gda::DataModelIter::move_at_row has been renamed to move_to_row.

2008-12-16  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool.cc: connect(): Store a cache of the
	connection for 30 seconds, to avoid unnecessary reconnects. Clear the
	cache when setting the username/password/database, to force a reconnect.

2008-12-16  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/db_adddel/glom_db_treemodel.cc:
	refresh_from_database(): Use STATEMENT_MODEL_CURSOR instead of
	ITER_MODEL_ONLY, as needed by libgda-4.0.

2008-12-15  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/document/document_glom.cc (set_table_fields): Fixed
	logic so that the document is set to be modified when the new fields
	differ from the old fields, not when they compare equal.

	* glom/libglom/document/document_glom.h: Also copy the m_info member
	in DocumentTableInfo's copy constructor and assignment operator.

	* glom/base_db.cc: Update the libgda meta store after having created a
	new table, so that get_fields_for_table_from_database works correctly
	for the new table. These changes fix creating new tables.

2008-12-15  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool.cc:
	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool_backends/postgres_self.cc:
	* glom/libglom/connectionpool_backends/sqlite.cc:
	* glom/libglom/data_structure/glomconversions.cc:
	* glom/libglom/document/document_glom.cc:
	* glom/mode_data/box_data_calendar_related.cc:
	* glom/mode_data/box_data_portal.cc:
	* glom/mode_data/flowtablewithfields.cc:
	* glom/relationships_overview/dialog_relationships_overview.cc:
	* glom/relationships_overview/dialog_relationships_overview.h:
	* glom/relationships_overview/printoperation_relationshipsoverview.cc:
	* glom/translation/window_translations.cc:
	* glom/utility_widgets/adddel/adddel.cc:
	* glom/utility_widgets/calendar/glomcalendar.cc:
	* glom/utility_widgets/calendar/glomcalendar.h:
	* glom/utility_widgets/calendar/glomgtkcalendar.h:
	* glom/utility_widgets/canvas/canvas_group_resizable.cc:
	* glom/utility_widgets/canvas/canvas_item_movable.cc:
	* glom/utility_widgets/datawidget.cc:
	* glom/utility_widgets/egg/toolpalette/eggtoolpalette.h:
	* glom/utility_widgets/flowtable.cc:
	* glom/utility_widgets/flowtable_dnd.cc:
	* glom/utility_widgets/sidebar.cc: Avoided compiler warnings, mostly
	commenting out unused parameters.

2008-12-15  Johannes Schmid  <jhs@Obelix>

	* glom/frame_glom.cc:
	Fixed a warning (actually avoided a sprintf completely...)

	* glom/libglom/connectionpool_backends/postgres_central.cc:
	* glom/libglom/connectionpool_backends/postgres_central.h:
	* glom/libglom/connectionpool_backends/postgres_self.cc:
	Fixed creating of databases. Database is no created though things break
	at a latter stage.

2008-12-12  Murray Cumming  <murrayc@murrayc.com>

	* Many files: Remove tabs, and spaces before ( and generally fix some
	old Johannes-esque formatting.

2008-12-12  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/field.[h|cc]: Store the primary_key and
	unique_key details as bools in the C++ class, because we cannot
	easily get that from libgda-4.0, so we at least remember that
	information from the document. If we can get it from the database
	somehow then we can do that later.
	* glom/mode_design/fields/dialog_fielddefinition.cc: get_field():
	Store the primary_key and unique_key details in the C++ class.
	We previously stored them info Gda::Column but that code was commented
	out during the port to libgda-4.0.

	There is also a crash workaround in Gda::Holder and a refcount fix
	in DataModelIter in libgdamm. With this we can now actually view data.

2008-12-12  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool.cc: connect(): Call update_meta_store()
	here.
	* glom/libglom/data_structure/fieldtypes.cc: Constructor,
	* glom/base_db.cc: get_fields_for_table_from_database(): Do not call
	update_meta_store() here, because ConnectionPool::connect() has
	already called it. This makes things faster but there is still some
	slowness.

2008-12-12  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/fieldtypes.cc: Constructor,
	* glom/base_db.cc: get_fields_for_table_from_database():
	Use the new get_meta_store_data() method overload with no filter
	parameter to simplify the code slightly.
	Add debug output to show how often we call update_meta_store() and
	how awfully slow it is.

2008-12-11  Murray Cumming  <murrayc@murrayc.com>

	* glom/Makefile.am:
	* glom/dialog_existing_or_new.[h|cc]: Also check an alternative
	directory path for the examples because an (unofficial) Ubuntu package
	installs them in an unexpected location. I would rather find out
	how/why that is happening though.

2008-12-10  Johannes  <jschmid@openismus.com>

	* configure.in:
	Depend on libgdamm-4.0, libgda-postgres-4.0 and pygda-4.0

	* glom/main.cc: Call Gnome::Gda::Init() without arguments

	* glom/base_db.cc:
	* glom/libglom/connectionpool.cc:
	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool_backends/postgres_central.cc:
	* glom/libglom/connectionpool_backends/postgres_central.h:
	* glom/libglom/connectionpool_backends/postgres_self.cc:
	* glom/libglom/connectionpool_backends/postgres_self.h:
	* glom/libglom/connectionpool_backends/sqlite.cc:
	* glom/libglom/connectionpool_backends/sqlite.h:
	* glom/libglom/data_structure/field.cc:
	* glom/libglom/data_structure/fieldtypes.cc:
	* glom/libglom/python_embed/py_glom_relatedrecord.cc:
	* glom/libglom/test_connectionpool.cc:
	* glom/libglom/utils.cc:
	* glom/mode_design/fields/box_db_table_definition.cc:
	* glom/mode_design/fields/dialog_fielddefinition.cc:
	* glom/utility_widgets/db_adddel/glom_db_treemodel.cc:
	* regression_tests/test_parsing_time.cc:

	Ported gda calls to libgda 4.0. This does mostly involve the removal of Gda::Client
	and some more API changes (Gda::ParamList => Gda::Set, Gda::Parameter => Gda::Holder).
	Some bits are still missing which involves creating database for Postgres (sqlite works) and
	several checks if postgres is installed that have been performed in the past. Also, the
	set_unique_key() and set_primary_key() methods of Gda::Column have no replacement in 4.0.
	All things that are not finished are marked with "TODO_gda:".

2008-12-09  Armin Burgmeier  <armin@openismus.com>

	* glom/application.h:
	* glom/application.cc: Set "Users" menu item in "Developer" menu
	insensitive when the database does not support users.

	* glom/frame_glom.cc: Don't ask for user/password for SQLite
	connections.

	* glom/libglom/data_structure/glomconversions.cc
	(get_text_for_gda_value): Really allow TIME values to be strings.

	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool_backends/postgres_central.h:
	* glom/libglom/connectionpool_backends/postgres_self.h:
	* glom/libglom/connectionpool_backends/sqlite.h: Added a
	supports_remote_connection() virtual function to the ConnectionPool
	backends.

	* glom/libglom/connectionpool.cc: Don't advertize the Glom document
	via avahi when the database does not support remote connections, such
	as SQLite.

2008-12-09  Murray Cumming  <murrayc@murrayc.com>

	* glom/dialog_import_csv.[h|cc]:
	validate_primary_key(): Avoid a null pointer dereference (crash) if
	there is no primary key, though that should never happen now.
	handle_line(), import(): Use a sorted tree model so the fields list is
	alphabetically sorted.
	Ubuntu bug #https://bugs.launchpad.net/ubuntu/+source/glom/+bug/306593
	(elmergato)

2008-12-09  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_design/users/dialog_groups_list.cc:
	* glom/mode_design/users/dialog_users_list.cc: Constructors:
	Do not enable row drag and drop on the treeviews, because it is not
	used and it just confuses users who trigger it accidentally.
	This was just some left-over code from when these classes were started
	by copying the layout dialog.
	As mentioned in Ubuntu bug
	https://bugs.launchpad.net/ubuntu/+source/glom/+bug/299573
	(elmergato)

2008-12-09  Murray Cumming  <murrayc@murrayc.com>

	* glom/dialog_existing_or_new.cc: Constructor: When the examples
	directory does not exist, mention the path in the stderr message, to
	help us to debug the problem.

2008-12-08  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/connectionpool.cc: cleanup(): Check for a null
	m_backend, to avoid a crash when quitting Glom without opening a file.
	I added some more checks elsewhere.

2008-12-08  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/canvas/canvas_group_grid.cc: create_lines():
	Do not create a GooCanvasGrid with 0 steps, so Glom works with versions
	of GooCanvas without the bug fix.
	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/303453
	(elmergato)

2008-12-06  Murray Cumming  <murrayc@murrayc.com>

	* glom/combobox_fields.cc: on_cell_data_title(): Pass a ustring to
	set_property() for the (None) item, so it really shows up.
	set_property() cannot handle a char* there, it seems.
	For instance, this means that the choices fields can be cleared again.
	This regression probably happened when we first ported Glom to Maemo.
	Bug found by Arq. Maximiliano Meilán.

2008-12-06  Murray Cumming  <murrayc@murrayc.com>

	* glom/box_reports.cc: on_adddel_Add(): Set a default title based on
	the name, when adding a new report, as we do for tables, relationships,
	print layouts, etc.

2008-12-05  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/data_structure/glomconversions.h:
	* glom/libglom/data_structure/glomconversions.cc: Replaced
	get_escaped_binary_data by escape_binary_data_postgres() and
	escape_binary_data_sqlite(). SQLite uses a different format for binary
	data.
	(get_text_for_gda_value): Allow DATE and TIME values to be strings,
	and parse them always in ISO format. This is used for SQLite within
	which we store dates and times as ISO-formatted strings.

	* glom/libglom/data_structure/field.cc (glom_unescape_text): Don't
	unescape double quotes, as they are not escaped in glom_escape_text
	either.
	(sql): Use the escape_binary_data_postgres or
	escape_binary_data_sqlite functions from glomconversions, depending on
	the preferred format.
	(from_sql): Use the unescape_binary_data_postgres or
	unescape_binary_data_sqlite functions from glomconversions, depending
	on the preferred format.

2008-12-04  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/foundset.[h|cc]: Added has_no_criteria()
	to check if it has a sort order or where clause.
	* glom/libglom/document/document_glom.[h|cc]: Added
	set_criteria_current(), like set_layout_current(), so we can
	temporarily remember the sort (and find) for a table while navigating.
	DocumentTableInfo: Hand-wrote copy constructor and operator=() rather
	than depend on generated ones.
	* glom/utility_widgets/db_adddel/db_adddel.[h|cc]:
	Added signal_sort_clause_changed, emitted when the user clicks on
	the column header, which already caused a refresh with that sort.
	* glom/mode_data/box_data_list.[h|cc]: Respond to a sort change in the
	DbAddDel widget, saving it temporarily in the document.
	* glom/mode_data/frame_glom.cc: show_table(): Use the remembered
	criteria, from the document, where there is one.

	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/303422
	(elmergato)

2008-12-02  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/data_structure/fieldtypes.[h|cc]:  Added a fallback map
	that specifies types that can be used when the database does not support
	another type natively.

	* glom/libglom/data_structure/field.cc (set_field_info): Only set glom
	type of the field based on the GType of the info if it represents a
	different type. This prevents losing type information of the field
	when the type for this field used a fallback.

	* glom/libglom/data_structure/glomconversions.cc
	(get_text_for_gda_value): Don't complain for numeric types when the
	gtype is double, because this is used when the database system does
	not support GdaNumeric natively.

2008-12-01  Murray Cumming  <murrayc@murrayc.com>

	* configure.in: Depend on the latest goocanvasmm version.

2008-11-30  Armin Burgmeier  <armin@openismus.com>

	* Makefile.am: Removed the DISTCHECK_CONFIGURE_FLAGS setting, since
	the --disable-scrollkeeper option is already passed to configure
	during distcheck by other means. This allows setting custom
	DISTCHECK_CONFIGURE_FLAGS. Bug #562688.

2008-11-29  Armin Burgmeier  <armin@openismus.com>

	* configure.in: Fixed the description of the --with-postgres-utils
	option to match the default.

2008-11-29  Armin Burgmeier  <armin@openismus.com>

	* Makefile.am: Changed DISTCLEAN_FILES to DISTCLEANFILES, to fix make
	distcheck.

2008-11-28  Armin Burgmeier  <armin@openismus.com>

	* win32/build-installer:
	* win32/glom.iss.in: Update for Glom 1.8.

2008-11-28  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/data_structure/field.h:
	* glom/libglom/data_structure/field.cc: Added a sql_format
	enumeration, and added a format paramater to sql() and from_sql().
	This is needed for sqlite because it does not understand the
	E'binarydata'::bytea representation for binary data, which is a
	postgres extension.

	* glom/libglom/connectionpool.h:
	* glom/libglom/connectionpool.cc:
	* glom/libglom/connectionpool_backends/postgres_central.h:
	* glom/libglom/connectionpool_backends/postgres_self.h:
	* glom/libglom/connectionpool_backends/sqlite.h: Added a
	get_sql_format() virtual method that returns the SQL format of the
	backend.

	* glom/libglom/data_structure/fieldtypes.cc
	(get_string_name_for_gdavaluetype): Added some fallbacks for types
	sqlite does not support. This means we are storing numerics as
	doubles, and dates and times as strings in sqlite.

	* glom/libglom/data_structure/glomconversions.cc
	(get_double_for_gda_value_numeric): Handle the value being a double,
	since we use this when the database system doesn't has a "numeric"
	type.

	* glom/dialog_import_csv.cc:
	* glom/dialog_import_csv_progress.cc:
	* glom/frame_glom.cc: Export/Import data always in postgres format,
	because this is what we used to do.

	* glom/base_db.cc (add_standard_groups): Make this a no-op in case the
	database system doesn't support users.
	(insert_example_data): Convert data from the example file from
	postgres format to the format the current database backend uses before
	importing.
	(count_rows_returned_by): For sqlite the result of the SELECT COUNT
	query is int, not int64, so handle that case as well.

	* glom/glom_privs.cc (get_current_privs): Assume we have all possible
	privileges in case the database system doesn't support users.

	* glom/utility_widgets/filechooserdialog_saveextras.cc
	(set_extra_newdb_hosting_mode): Fixed central hosting/self hosting
	mismatch (the default option in the dialog was wrong).

2008-11-26  Murray Cumming  <murrayc@murrayc.com>

	* glom/relationships_overview/dialog_relationships_overview.[h|cc]:
	Respond to changes in the scrolledwindow adjustments to increase the
	canvas size when the window size changes, so it is always big enough,
	avoiding dead areas.
	Bug #559157 (Iain Lane).

2008-11-25  Armin Burgmeier  <armin@openismus.com>

	* glom/mode_data/dialog_layout_export.cc (get_layout_groups): Fixed a
	crash which was caused by accessing mapGroups[1] in a
	default-constructed vector. Bug #557052.

2008-11-25  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/utils.[h|cc]:
	Added a show_ok_dialog() overload that takes the parent_window as a
	pointer to simplify code by avoiding the need for a null check by
	callers.

	* glom/mode_design/fields/box_db_table_definition.cc:
	check_field_change(): Refuse to leave no primary key set because
	the rest of Glom expects each table to have one, by refusing to
	directly unset a primary key.
	When setting a primary key, ask the user if they really want to _change_
	the primary key, and do the suitability checks that were previously in
	change_definition().
	change_definition(): When setting a primary key, unset the previous
	primary key first.

	This prevents the table from ever having no primary key.
	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/299549
	(elmergato)
	Glom bug #562147

2008-11-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_data/box_data_details.cc:
	set_found_set_from_primary_key_value(): Do not crash if there is no
	primary key, though we should not allow tables with no primary keys.

2008-11-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/frame_glom.cc: update_table_in_document_from_database:
	Ignore the default_value property from libgda/database, because we only
	use it from the document, because libgda returns weird values.
	This prevents the loss of the default value information when reloading
	a document.
	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/299896
	(elmergato)

2008-11-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/db_adddel/db_adddel.cc
	user_added(): Call set_value_key(), like the old code did.
	Otherwise, each field edit adds another record, generating a new primary
	key each time, resulting in duplicate records.
	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/300819
	(elmergato)

2008-11-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_design/users/dialog_groups_list.cc: on_button_group_new():
	Put quotes around the group name, to avoid a problem when it contains a
	space.

2008-11-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/db_adddel/db_adddel.[h|cc]: Removed
	the unused signal_user_requested_delete signal.
	on_MenuPopup_activate_Delete() (also called when the button is pressed):
	Actually call user_requested_delete(), so that the user can delete a
	list row. I forgot to do this when moving the other stuff down into
	DbAddDel.
	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/299853
	(elmergato)

2008-11-24  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/glomconversions.cc
	get_text_for_gda_value: Add a more specific warning when getting a
	text representation for a boolean, as done by the import dialog, though
	it should not really. Return translated true/false strings in that case.

2008-11-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom_developer.glade: Corrected a button name to avoid a crash
	when editing reports.
	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/300054

2008-11-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom.glade: dialog_import_csv: Added a lable for advice about
	the expected data format.
	* glom/dialog_import_csv.cc: Constructor: Generate advice text in the
	label, showing an example of the expected ISO date format.
	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/299591

2008-11-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/frame_glom.cc: on_menu_file_export(): Correct the order of
	parameters to Document_Glom::get_data_layout_groups_plus_new_fields()
	so we actually get a sensible default set of fields instead of nothing.
	This was only a problem since the addition of the active-layout feature
	on trunk.

2008-11-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/glom.glade: Mark a tooltip as translatable in the initial dialog.
	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/299556

2008-11-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/glomconversions.c:
	sanity_check_date_text_representation_uses_4_digit_years():
	Default to dd/mm/yyyy for dates when the translator has not provided
	a 4-digit-year date syntax for the locale, printing a warning that the
	default might not be suitable. This seems better than failing.

2008-11-21  Armin Burgmeier  <armin@openismus.com>

	* glom/libglom/connectionpool.h: Changed connect() and
	create_database() functions of Backend to always take an error
	parameter as last argument, to save ugly #ifdefs. The ConnectionPool
	is the only one accessing these functions anyway, so this is not part
	of "public" API.

	* glom/libglom/connectionpool_backends/postgres_self.h:
	* glom/libglom/connectionpool_backends/postgres_self.cc:
	* glom/libglom/connectionpool_backends/postgres_central.h:
	* glom/libglom/connectionpool_backends/postgres_central.cc: Adapt.

	* glom/libglom/connectionpool_backends/sqlite.h:
	* glom/libglom/connectionpool_backends/sqlite.cc:
	* glom/libglom/connectionpool_backends/Makefile.am: Added a sqlite for
	creating and connecting to SQlite databases.

	* glom/libglom/document/document_glom.h:
	* glom/libglom/document/document_glom.cc: Replace self_hosted
	attribute by a hosting_mode one in the document XML, which can be
	either "postgres_central", "postgres_self" or "sqlite".

	* glom/utility_widgets/filechooserdialog_saveextras.h:
	* glom/utility_widgets/filechooserdialog_saveextras.cc: Offer to store
	the data in a SQlite database.

	* glom/application.h:
	* glom/application.cc:
	* glom/dialog_connection.cc:
	* glom/frame_glom.cc: Handle the SQlite case, create corresponding
	ConnectionPool backend. It is possible to create a SQlite database
	this way, but some initial queries still fail yet because they are
	specific to postgres.

2008-11-21  Murray Cumming  <murrayc@murrayc.com>

	* glom/libglom/data_structure/glomconversions.[h|cc]:
	Added sanity_check_date_parsing() and
	sanity_check_date_text_representation_uses_4_digit_years().
	* glom/main.cc: Use them to show informative warnings at startup.
	The translators comment for %x mentions those warnings now too.
	* po/es.po: Add a translation for %x because the es locales do not
	use 4-digit years for this.
	Ubuntu bug https://bugs.launchpad.net/ubuntu/+source/glom/+bug/300057

	* glom/test_pyembed.cc: Add a cast to avoid a warning.
	* glom/utility_widgets/db_adddel/db_adddel.cc: Initialize InnerIgnore
	members to avoid warnings, though these would always be initialized in
	real life.

2008-11-17  Armin Burgmeier  <armin@arbur.net>

	* glom/libglom/connectionpool.h: Removed postgres-specific functions,
	added a common "Backend" interface. Simplified the code logic in
	connect().

	* glom/libglom/connectionpool_backends/postgres_self.h:
	* glom/libglom/connectionpool_backends/postgres_self.cc:
	* glom/libglom/connectionpool_backends/postgres_central.h:
	* glom/libglom/connectionpool_backends/postgres_central.cc:
	* glom/libglom/connectionpool_backends/Makefile.am: Added backends
	for postgres central and self hosting.

	* glom/libglom/gst-package.c:
	* glom/libglom/test_connectionpool.cc:
	* glom/libglom/connectionpool.cc:
	* glom/libglom/document/document_glom.cc:
	* glom/main.cc:
	* glom/frame_glom.cc:
	* glom/dialog_connection.cc:
	* glom/application.cc:
	* glom/dialog_new_self_hosted_connection.cc: Adapt other glom code,
	instantate the backends appropiately.

2008-11-13  Murray Cumming  <murrayc@murrayc.com>

	* glom/utility_widgets/canvas/canvas_group_grid.[h|cc]:
	Use the new Goocanvas::Grid instead of creating lots of lines ourselves.
	We still need this class to add the rules and do the snapping though.

2008-11-11  Murray Cumming  <murrayc@murrayc.com>

	* glom/mode_design/print_layouts/canvas_layout_item.cc:
	* glom/mode_design/print_layouts/canvas_print_layout.cc:
